#ifndef I_SOUND_H_INCLUDED
#define I_SOUND_H_INCLUDED

#include "ICommonPlugin.h"

// {D61D213A-47C3-4e59-8365-8E480BE11D47}
static const GUID IID_IMusic = 
{ 0xd61d213a, 0x47c3, 0x4e59, { 0x83, 0x65, 0x8e, 0x48, 0xb, 0xe1, 0x1d, 0x47 } };

interface __declspec(uuid("{D61D213A-47C3-4e59-8365-8E480BE11D47}")) IMusic: public IUnknown
{
	virtual HRESULT CALLBACK PlayMusic( IN const char *filename, IN bool looped = true ) = 0; //Direct file read not useing engine FS
	virtual HRESULT CALLBACK StopMusic() = 0;
	virtual HRESULT CALLBACK IsMusicPlaying( OUT bool &playing ) = 0;
};

// {4DF259CD-F584-44f7-B1E3-8C8CA6CB15EF}
static const GUID IID_ISoundSample = 
{ 0x4df259cd, 0xf584, 0x44f7, { 0xb1, 0xe3, 0x8c, 0x8c, 0xa6, 0xcb, 0x15, 0xef } };

interface __declspec(uuid("{4DF259CD-F584-44f7-B1E3-8C8CA6CB15EF}")) ISoundSample: public IUnknown
{
	virtual HRESULT CALLBACK GetName( OUT const char *&name ) = 0;
	virtual HRESULT CALLBACK Play(IN bool loop = false) = 0;
	virtual HRESULT CALLBACK Stop() = 0;
	virtual HRESULT CALLBACK IsPlaying( OUT bool &playing ) = 0;
	virtual HRESULT CALLBACK SetPause( IN bool pause ) = 0;
	virtual HRESULT CALLBACK SetVolume( IN unsigned int volume ) = 0;
	virtual HRESULT CALLBACK GetVolume( OUT unsigned int &volume ) = 0;
	virtual HRESULT CALLBACK SetPan( IN int pan ) = 0;
	virtual HRESULT CALLBACK GetPan( OUT int &pan ) = 0;
	virtual HRESULT CALLBACK SetPosition( IN float x, IN float y, IN float z ) = 0;
	virtual HRESULT CALLBACK GetPosition( OUT float &x, OUT float &y, OUT float &z ) = 0;
};

// {488571E2-6D69-4099-AFD0-C9E380CA7F0E}
static const GUID IID_ISound = 
{ 0x488571e2, 0x6d69, 0x4099, { 0xaf, 0xd0, 0xc9, 0xe3, 0x80, 0xca, 0x7f, 0xe } };

interface __declspec(uuid("{488571E2-6D69-4099-AFD0-C9E380CA7F0E}")) ISound: public ICommonPlugin
{
	virtual HRESULT CALLBACK CreateDevice() = 0;
	virtual HRESULT CALLBACK ReleaseDevice() = 0;
	virtual HRESULT CALLBACK GetMusic( OUT IMusic *&pMusic ) = 0;
	virtual HRESULT CALLBACK LoadSoundSample( IN const char *filename, IN const char *name, OUT ISoundSample *&pSoundSample ) = 0;
	virtual HRESULT CALLBACK GetSoundSample( IN const char *name, OUT ISoundSample *&pSoundSample ) = 0;
	virtual HRESULT CALLBACK FreeSoundSample( IN const char *name ) = 0;
	virtual HRESULT CALLBACK SoundSetVolumeAll( IN unsigned int volume ) = 0;
	virtual HRESULT CALLBACK SoundStopAll() = 0;
	//virtual HRESULT CALLBACK SetEarsPosition( IN float x, IN float y, IN float z ) = 0;
	//virtual HRESULT CALLBACK GetEarsPosition( OUT float &x, OUT float &y, OUT float &z ) = 0;
};

#endif //I_SOUND_H_INCLUDED