#ifndef RENDERER_ENUMS_H_INCLUDED
#define RENDERER_ENUMS_H_INCLUDED

namespace RendererEnums
{
	enum FRAME_BUFF_FORMAT
	{
		FB_UNKNOWN,
		FB_16bpp,
		FB_32bpp
	};
	enum TEXTURE_FORMAT
	{
		TEX_UNKNOWN,
		TEX_A8_U,
		TEX_A8_S,
		TEX_R8G8_U,
		TEX_R8G8_S,
		TEX_R8G8B8A8_U,
		TEX_R8G8B8A8_S,
		TEX_BC1_U,
		TEX_BC1_S,
		TEX_BC2_U,
		TEX_BC2_S,
		TEX_BC3_U,
		TEX_BC3_S
	};
	namespace IStandardMaterial
	{
		enum LIGHTING_MODEL
		{
			LIGHTING_MODEL_AMBIENT		= 0,
			LIGHTING_MODEL_LAMBERT		= 1,
			LIGHTING_MODEL_PHONG		= 2
		};
		enum NORMAL_TECHNIQUE
		{
			NORMAL_TECHNIQUE_UNPERTURBED			= 0,
			NORMAL_TECHNIQUE_NORMAL_MAP_3_COMPONENT	= 1,
			NORMAL_TECHNIQUE_HEIGHT_MAP_4_SAMPLES	= 2
		};
		enum PARALLAX_TECHNIQUE
		{
			PARALLAX_TECHNIQUE_NONE		= 0,
			PARALLAX_TECHNIQUE_SPHERE	= 1,
			PARALLAX_TECHNIQUE_PLANE	= 2
		};
	}
	namespace IInstance
	{
		enum CULL_MODE
		{
			CULL_NONE	= 0,
			CULL_CW		= 1,
			CULL_CCW	= 2
		};
	}
}

#endif //RENDERER_ENUMS_H_INCLUDED