#ifndef EVENTS_H_INCLUDED
#define EVENTS_H_INCLUDED

#include "IEventSystem.h"
#include "IInput.h"

#define EV_WIN_MESSAGE			"Windows Message"
#define EV_FPS_TIMER			"Fps Timer"
#define EV_RENDER_STATUS		"Render status"
#define EV_ON_LUA_INIT			"Lua Init"

static const char *InputKeyboardEvents[] = {
	"input_OnKeyDown",
	"input_OnKeyUp",
	"input_OnKeyPress"
};
static const char *InputMouseEvents[] = {
	"input_OnMouseMove",
	"input_OnMouseDown",
	"input_OnMouseUp",
	"input_OnMousePress",
	"input_OnMouseWheel"
};

// {46F98424-8999-4b63-8E95-DE289BAE7056}
static const GUID IID_ISenderEvent = 
{ 0x46f98424, 0x8999, 0x4b63, { 0x8e, 0x95, 0xde, 0x28, 0x9b, 0xae, 0x70, 0x56 } };
interface __declspec(uuid("{46F98424-8999-4b63-8E95-DE289BAE7056}")) ISenderEvent: public IEvent
{
	virtual HRESULT CALLBACK SetSender(IN IUnknown *pSender) = 0;
	virtual HRESULT CALLBACK GetSender(OUT IUnknown *&pSender) = 0;	
};

// {878C9EDE-5431-4ad0-BB37-A6DC16827538}
static const GUID IID_IInputKeyEvent = 
{ 0x878c9ede, 0x5431, 0x4ad0, { 0xbb, 0x37, 0xa6, 0xdc, 0x16, 0x82, 0x75, 0x38 } };

interface __declspec(uuid("{878C9EDE-5431-4ad0-BB37-A6DC16827538}")) IInputKeyEvent: public ISenderEvent
{
	virtual HRESULT CALLBACK GetParam(OUT unsigned int &key) = 0;
};

// {FCF74D43-E2C4-44c5-B792-A4D5FDDC1715}
static const GUID IID_IInputMouseEvent = 
{ 0xfcf74d43, 0xe2c4, 0x44c5, { 0xb7, 0x92, 0xa4, 0xd5, 0xfd, 0xdc, 0x17, 0x15 } };

interface __declspec(uuid("{FCF74D43-E2C4-44c5-B792-A4D5FDDC1715}")) IInputMouseEvent: public ISenderEvent
{
	virtual HRESULT CALLBACK GetParam(OUT sMouseStates &mouse, OUT DPE_MOUSE_BUTTONS &button) = 0;
};

// {B9EE22DE-7254-4195-B816-AE5D7A32A2BF}
static const GUID IID_IWinEvent = 
{ 0xb9ee22de, 0x7254, 0x4195, { 0xb8, 0x16, 0xae, 0x5d, 0x7a, 0x32, 0xa2, 0xbf } };

interface __declspec(uuid("{B9EE22DE-7254-4195-B816-AE5D7A32A2BF}")) IWinEvent: public IEvent
{
	virtual HRESULT CALLBACK GetParam(OUT unsigned int *message, OUT WPARAM *wParam, OUT LPARAM *lParam) = 0;
};

// {89A17AE2-EA35-429b-AB45-3005600D2EE3}
static const GUID IID_IRenderStatusEvent = 
{ 0x89a17ae2, 0xea35, 0x429b, { 0xab, 0x45, 0x30, 0x5, 0x60, 0xd, 0x2e, 0xe3 } };

interface __declspec(uuid("{89A17AE2-EA35-429b-AB45-3005600D2EE3}")) IRenderStatusEvent: public IEvent
{
	virtual HRESULT CALLBACK GetParam(OUT volatile bool &do_render) = 0;
};

#endif//EVENTS_H_INCLUDED