#include "FileTransfer.h"

FileTransfer::FileTransfer()
{
	_data = NULL;
	_count = 0;
	_ext = new char[1];
	_ext[0] = '\0';
}

FileTransfer::~FileTransfer()
{
	if (_count!=0)
	{
		for(size_t i=0; i<_count; i++)
			if(_data[i].file!=NULL)
				_data[i].file->Release();

		delete[] _data;
	}
	if (_ext) delete[] _ext;
}

bool FileTransfer::AddData(int idx, char* extradata, ext_type type, IUnknown** file)
{
	
	if (_count==0) _data = new TFileData [1];
	else
	_data = (TFileData*)realloc(_data, (_count+1)*sizeof(TFileData));

	_data[_count].idx = idx;
	strcpy(_data[_count].extra,extradata);
	_data[_count].type = type;
	_data[_count].file = *file;
	_count++;

	return true;

}

void FileTransfer::SetExt(const char* ext)
{
	if (_ext) delete[] _ext;
	_ext = new char[strlen(ext)+1];
	strcpy(_ext, ext);
}

HRESULT CALLBACK FileTransfer::GetFileData(TFileData **Data)
{
	if(_data!=NULL)
	{
		*Data = _data;
		return S_OK;
	}
	else
	{
		*Data = NULL;
		return E_FAIL;
	}
}


HRESULT CALLBACK FileTransfer::GetFileDataCount(size_t &count)
{
	count = _count;
	return S_OK;
}


HRESULT CALLBACK FileTransfer::GetFileDataCount(ext_type ext, size_t &count)
{
	count = 0;
	if(_data == NULL)
		return E_FAIL;
	for (size_t cur_file_idx = 0; cur_file_idx < _count; cur_file_idx++)
		if (_data[cur_file_idx].type == ext)
			count++;
	return S_OK;
}


HRESULT CALLBACK FileTransfer::GetFileExtension(char* ext)
{
	strcpy(ext, _ext);
	return S_OK;
}


/*IUnknown*/
HRESULT FileTransfer::QueryInterface(REFIID riid, VOID **ppvObject)
{
	*ppvObject = NULL;

	if (::memcmp(&riid, &IID_IUnknown, sizeof(GUID)) == 0)
		*ppvObject = static_cast<IUnknown *>(this);
	else
		if (::memcmp(&riid, &IID_IFileTransfer, sizeof(GUID)) == 0)
			*ppvObject = static_cast<IFileTransfer *>(this);
		else
			return E_NOINTERFACE;	

	return S_OK;
}
ULONG FileTransfer::AddRef()
{
	return 1;
}
ULONG FileTransfer::Release()
{
	delete this;
	return 1;
}
