#ifndef FILETRANSFER_H_INCLUDED
#define FILETRANSFER_H_INCLUDED
#include "IFileSystem.h"
#include "FileTransfer.h"

class FileTransfer: public IFileTransfer
{

private:

	TFileData *_data;
	size_t	   _count;
	char*	   _ext;

public:


	FileTransfer();
	~FileTransfer();

	void SetExt(const char* ext);
	bool AddData(int idx, char* extradata, ext_type type, IUnknown** file);
						
	virtual HRESULT CALLBACK GetFileData(TFileData **Data);
	virtual HRESULT CALLBACK GetFileDataCount(size_t &count);
	virtual HRESULT CALLBACK GetFileDataCount(IN ext_type ext, OUT size_t &count);
	virtual HRESULT CALLBACK GetFileExtension(char* ext);

	/*IUnknown*/
	virtual HRESULT CALLBACK QueryInterface(REFIID riid, VOID **ppvObject);
	virtual ULONG   CALLBACK AddRef();
	virtual ULONG   CALLBACK Release();


};
#endif