/*-----------------------------------------------------------------------
This source file is a part of DPEngine.

Created:		1.08.2008
LastModified:	1.08.2008

Revision history:
	* Created by GAS
	* Revised by ...

Disctription:
-----------------------------------------------------------------------*/
#pragma once

#include <windows.h>
#include "enums.h"

// {B6055A87-FE6C-4899-852A-F362B37B3172}
static const GUID IID_IFMaterial = 
{ 0xb6055a87, 0xfe6c, 0x4899, { 0x85, 0x2a, 0xf3, 0x62, 0xb3, 0x7b, 0x31, 0x72 } };

class __declspec(uuid("{B6055A87-FE6C-4899-852A-F362B37B3172}")) IFMaterial: public IUnknown
{
public:
	struct MATERIAL_DATA
	{
		struct MATERIAL_TEXTURE
		{
			enum TEXTURE_TYPE
			{
				TEX_TYPE_SINGLE
			} tex_type;
			union
			{
				char map_path[MAX_PATH];
			};
			inline MATERIAL_TEXTURE()
			{
				map_path[0] = '\0';
			}
		};
		RendererEnums::IStandardMaterial::LIGHTING_MODEL lighting_model;
		RendererEnums::IStandardMaterial::NORMAL_TECHNIQUE normal_technique;
		RendererEnums::IStandardMaterial::PARALLAX_TECHNIQUE parallax_technique;
		float ambient[4];
		float diffuse[3];
		float specular[3];
		float shinness;
		MATERIAL_TEXTURE diffuse_texture;
		MATERIAL_TEXTURE specular_texture;
		MATERIAL_TEXTURE normal_texture;
		MATERIAL_TEXTURE height_texture;
		float height_delta_scale;
		float height_scale;
		bool enable_anisotropy;
		bool enable_alphatest;
		bool receive_shadows;

		inline MATERIAL_DATA()
		{
			lighting_model = RendererEnums::IStandardMaterial::LIGHTING_MODEL_PHONG;
			normal_technique = RendererEnums::IStandardMaterial::NORMAL_TECHNIQUE_UNPERTURBED;
			parallax_technique = RendererEnums::IStandardMaterial::PARALLAX_TECHNIQUE_NONE;
			ambient[0] = ambient[1] = ambient[2] = ambient[3] =
			diffuse[0] = diffuse[1] = diffuse[2] =
			specular[0] = specular[1] = specular[2] =
			shinness = 1.0f;
			diffuse_texture.tex_type = specular_texture.tex_type = normal_texture.tex_type = height_texture.tex_type = MATERIAL_TEXTURE::TEX_TYPE_SINGLE;
			diffuse_texture.map_path[0] = specular_texture.map_path[0] = normal_texture.map_path[0] = height_texture.map_path[0] = '0';
			height_delta_scale = height_scale = 1.0f;
			enable_anisotropy = enable_alphatest = receive_shadows = false;
		}
	} material;
	virtual HRESULT CALLBACK GetMaterialData(OUT MATERIAL_DATA &material) = 0;
};