#ifndef IFTEXTURE_H_INCLUDED
#define IFTEXTURE_H_INCLUDED

#include <Unknwn.h>

// {9FCC89DC-B6E1-4f14-B797-FE7F614C0D83}
static const GUID IID_IFTexture = 
{ 0x9fcc89dc, 0xb6e1, 0x4f14, { 0xb7, 0x97, 0xfe, 0x7f, 0x61, 0x4c, 0xd, 0x83 } };

class __declspec(uuid("{9FCC89DC-B6E1-4f14-B797-FE7F614C0D83}")) IFTexture: public IUnknown
{
public:
	struct F_TEXTURE_DESC
	{
		unsigned int width, height;
		enum F_TEXTURE_BUFFERS_DESC
		{
			UNKNOWN,	// invalid
			R8G8B8,		// 1 buffer with rgb data (24 bit)
			R8G8B8_A8,  // 2 buffers: rgb (24 bit) and alpha (8 bit) data
			A8			// 1 buffer alpha (8 bit) data
		} buffers_desc;

		inline F_TEXTURE_DESC():
			width(0),
			height(0),
			buffers_desc(UNKNOWN)
		{
		}
		inline F_TEXTURE_DESC &operator =(const F_TEXTURE_DESC &texture_desc)
		{
			width = texture_desc.width;
			height = texture_desc.height;
			buffers_desc = texture_desc.buffers_desc;

			return *this;
		}
	};
	virtual HRESULT STDMETHODCALLTYPE GetDesc(F_TEXTURE_DESC &texture_desc) const = 0;
	virtual HRESULT STDMETHODCALLTYPE GetData(size_t buffer_idx, void *&pData) const = 0;
	virtual HRESULT STDMETHODCALLTYPE FillBuffer(size_t buffer_idx, const void *pData) = 0;
};
#endif