#ifndef I_COMMON_PLUGIN_H_INCLUDED
#define I_COMMON_PLUGIN_H_INCLUDED

#include <windows.h>
#include "IEventSystem.h"
#include "ILog.h"

/* Common plugin information*/
enum E_PluginType
{
	Pl_CUSTOM_UNKNOWN = 0,
	Pl_RENDER,
	Pl_INPUT,
	Pl_SOUND,
	Pl_SCENES,
	Pl_CUSTOM_SCENES,
	Pl_CUSTOM_FILE_SYSTEM
};

#pragma pack(push, 1)
typedef struct
{
	E_PluginType type;
	const char *name;
	const char *provider;
	const char *version;
	const char *discription;
	GUID  guid;
} PluginInfo;
#pragma pack(pop)

// {1CBE4D3F-46BA-4ca2-B9EC-9147FB80B4DD}
static const GUID IID_ICommonPlugin = 
{ 0x1cbe4d3f, 0x46ba, 0x4ca2, { 0xb9, 0xec, 0x91, 0x47, 0xfb, 0x80, 0xb4, 0xdd } };

//forward declaration
interface ICoreModule;

interface __declspec(uuid("{1CBE4D3F-46BA-4ca2-B9EC-9147FB80B4DD}")) ICommonPlugin: public IUnknown
{
	virtual HRESULT STDMETHODCALLTYPE GetEventSystem(OUT IEventSystem **EventSystem) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetCoreModuleInterface(IN ICoreModule *Module) = 0;
	virtual HRESULT STDMETHODCALLTYPE SetLog(ILog* log) = 0;
};

#endif//I_COMMON_PLUGIN_H_INCLUDED