#ifndef I_CORE_MODULE_H_INCLUDED
#define I_CORE_MODULE_H_INCLUDED

#include <windows.h>
#include "ICommonPlugin.h"
#include "IFileSystem.h"
#include "ILua.h"

// {76D9A98F-6D2E-466f-90DF-BFB31C51EBBA}
static const GUID IID_ICoreModule = 
{ 0x76d9a98f, 0x6d2e, 0x466f, { 0x90, 0xdf, 0xbf, 0xb3, 0x1c, 0x51, 0xeb, 0xba } };

interface __declspec(uuid("{76D9A98F-6D2E-466f-90DF-BFB31C51EBBA}")) ICoreModule: public IUnknown
{
	virtual HRESULT CALLBACK GetHandle(OUT HWND *Handle) = 0;
	virtual HRESULT CALLBACK GetScreenRes(int &width, int &height) = 0;
	virtual HRESULT CALLBACK QuitEngine() = 0;
	virtual HRESULT CALLBACK GetProcessInterval(int &time) = 0;
	virtual HRESULT CALLBACK Lua_DoString(const char* text) = 0;
	virtual HRESULT CALLBACK Lua_ReInit() = 0;
	virtual HRESULT CALLBACK Lua_Get(OUT ILua **lua) = 0;
	virtual HRESULT CALLBACK Con_Write(const char* text, bool toprevline = false) = 0;
	virtual HRESULT CALLBACK Con_Exec(const char* command) = 0;
	virtual HRESULT CALLBACK Con_RegComProc( const char* name, const char* help, void (*proc)(const char* param) ) = 0; 
	virtual HRESULT CALLBACK Con_RegComValue( const char* name, const char* help, int* value, int minvalue, int maxvalue, void (*proc)(const char* param) = NULL ) = 0;
	virtual HRESULT CALLBACK PluginCount(OUT ULONG *count, E_PluginType type) = 0;
	virtual HRESULT CALLBACK PluginInformation(OUT PluginInfo *info, E_PluginType type, ULONG index = 0) = 0;
	virtual HRESULT CALLBACK PluginByType(OUT ICommonPlugin **iplugin, E_PluginType type, ULONG index = 0) = 0;
	virtual HRESULT CALLBACK PluginByName(OUT ICommonPlugin **iplugin, const char* name) = 0;
	virtual HRESULT CALLBACK FileSystem(OUT IFileSystem **imain_fs) = 0;
};

#endif//I_CORE_MODULE_H_INCLUDED