#ifndef I_EVENT_SYSTEM_H_INCLUDED
#define I_EVENT_SYSTEM_H_INCLUDED

#include <windows.h>
#include <Unknwn.h>

// {D3ED183B-D67C-4ACE-AA11-B88613EA31E4}
static const GUID IID_IEvent = 
{ 0xd3ed183b, 0xd67c, 0x4ace, { 0xaa, 0x11, 0xb8, 0x86, 0x13, 0xea, 0x31, 0xe4 } };

interface __declspec(uuid("{D3ED183B-D67C-4ACE-AA11-B88613EA31E4}")) IEvent: public IUnknown
{
	virtual HRESULT STDMETHODCALLTYPE Send() = 0;
	virtual HRESULT STDMETHODCALLTYPE Hash(ULONG* Hash) = 0;
	virtual HRESULT STDMETHODCALLTYPE Name(char** Name) = 0;	
};

// {A85C64B5-BD6C-46EE-BE10-259561089626}
static const GUID IID_IEventSystem = 
{ 0xa85c64b5, 0xbd6c, 0x46ee, { 0xbe, 0x10, 0x25, 0x95, 0x61, 0x08, 0x96, 0x26 } };

interface __declspec(uuid("{A85C64B5-BD6C-46EE-BE10-259561089626}")) IEventSystem: public IUnknown
{	
	virtual HRESULT STDMETHODCALLTYPE SetMainEventSystem(IEventSystem* MainSystem) = 0;	
	virtual HRESULT STDMETHODCALLTYPE DispatchEvent(IEvent* Event) = 0;
};

#endif//I_EVENT_SYSTEM_H_INCLUDED