/*-----------------------------------------------------------------------
This source file is a part of DPEngine.

Created:		08.04.2008
LastModified:	28.07.2008

Revision history:
	* Created by Mike
	* Revised by ...

Disctription:
-----------------------------------------------------------------------*/
#ifndef _STRING_UTILS_H_
#define _STRING_UTILS_H_

#ifndef __BORLANDC__

#include <string>

typedef std::string String;
typedef std::stringstream StrStream;
//-----------------------------------------------------------------------

String ToLowerCase(String &inString);
String ToUpperCase(String &inString);
//-----------------------------------------------------------------------
int SearchStr(String str, String where, int num=1, int after=0);
int SearchStrSens(const String& str, const String& where, int num=1, int after=0);
bool TpltSearchStr(String what, String where);
bool TpltSearchStrSens(String what, String where);
int CountOf(String what, String where);
int CountOfSens(String what, String where);
//-----------------------------------------------------------------------
int StrToInt(const String &str);
unsigned int StrToUInt(const String &str);
float StrToFloat(const String &str);
bool StrToBool(String &str);
//-----------------------------------------------------------------------
String IntToStr(int val);
String UIntToStr(unsigned int val);
String UIntToStrX(unsigned int val);
String FloatToStr(float val);
String BoolToStr(bool val);
//-----------------------------------------------------------------------
String GetPath(const char *name);
String GetFileName(const char *name);
String GetFileExt(const char *name);
String GetOnlyFileName(const char *name);
//-----------------------------------------------------------------------
#endif
#endif
