/*-----------------------------------------------------------------------
This source file is a part of DPEngine.

Created:		16.06.2008
LastModified:	16.06.2008

Revision history:
	* Created by Mike
	* Revised by

Disctription:
-----------------------------------------------------------------------*/
#ifndef _AABB_H_INCLUDED_
#define _AABB_H_INCLUDED_

#include <windows.h>
#include "Vector.h"
#include "ScalarTypes.h"
#include "plane.h"

#include "DEFINE_FOR_BORLANDC"

namespace DPE_Scenes
{

struct TAABB
{
	Vector Max;
	Vector Min;

	TAABB();
	TAABB(const Vector &vMax, const Vector &vMin);

	int Classify(const Vector &vPoint) const;
	int Classify(const Vector &vA, const Vector &vB) const;
	int Classify(const TPlane &plane) const;
	int Classify(const TAABB &aabb) const;
	Vector GetCenter() const;
	float GetDiagonal() const;
	void GetEdges(OUT Vector (&edges)[8]) const;
	void AddInternalPoint(const Vector &vPoint);

	TAABB &operator += (const TAABB &other);
	TAABB &operator *= (const Matrix &m);
	friend TAABB operator + (const TAABB &first, const TAABB &second);
	friend TAABB operator * (const TAABB &aabb, const Matrix &m);
};

}

#include "UNDEF_FOR_BORLANDC"

#endif