#include "Bullets.h"

int	Bullets::efidx = 0;

void Bullets::MakeShot(Point2D_Int pos, bool bullet)
{
_counter++;
 ISprite *sprite;
 pMan2D->CreateSprite(string("bullet:"+IntToStr(_counter)).c_str(),sprite);
 sprite->SetZOrder(755);
 if (bullet)
 sprite->SetTexture("bullet");
 else
 {
	sprite->SetTexture("blast");
	sprite->SetDimension(32,32);
 }
 ICollisionShape::TCircleDesc cd;
 cd.density = 2;
 cd.friction = 1.0f;
 cd.restitution = 0.0f;
 cd.radius = 5;
 cd.filter.groupIndex = -1000;
 sprite->SetShape(&cd);
 IBody::TBodyDesc body_desc;
 body_desc.isBullet = true;
 body_desc.position.x = pos.x;
 body_desc.position.y = pos.y;
 body_desc.angularDamping = 10.0f;
 IBody *body = NULL;
 pMan2D->CreateCollidableBody(string("bullet:"+IntToStr(_counter)).c_str(),&body_desc,body);
 body->AppendShapes(sprite);
 body->SetMassFromShapes();

 if(bullet)
  body->ApplyImpulse(Vector2D_Float(10.0f, 0.f),Point2D_Int(pos.x-4,pos.y-4));  
 else
  body->ApplyImpulse(Vector2D_Float(-5.0f, 0.f),Point2D_Int(pos.x-4,pos.y-4));  

 _bullets.push_back(TBullet(sprite,body,bullet));
}

void Bullets::_killbullet(int idx)
{
	_bullets[idx].body->Free();
	_bullets[idx].body->Release();

	_bullets[idx].sprite->Free();
	_bullets[idx].sprite->Release();

	_bullets.erase(_bullets.begin()+idx);
}

void Bullets::Update()
{
	_idxss.clear();
	if(_bullets.size()>0)
		for(int i = 0; i < _bullets.size(); i++)
		{
			
			ICamera2D *cam;
			pMan2D->GetCamera(cam);
			Point2D_Int cp, bp;
			cam->GetPosition(cp);
			_bullets[i].body->GetPosition(bp);
			cam->Release();
			if(bp.x>cp.x+420)
			{
				_killbullet(i);
				continue;
			}

			int count = 0;
			pListner->GetCount(count);
			IContactListener::TContactPoint cpoint;
			if (count > 0)
			{
				unsigned long bull_id = 0,id1 = 0, id2 = 0;
				_bullets[i].sprite->GetID(bull_id);

				for (int j = 0; j < count; j++)
				{
					cpoint.pShape1 = NULL;
					cpoint.pShape2 = NULL;
					pListner->NextPoint(cpoint);
					cpoint.pShape1->GetID(id1);
					cpoint.pShape2->GetID(id2);
 					if (bull_id == id1) 
					{
						_idxss.push_back(TCb(id2,_bullets[i].isbullet));
						
						IEmitter2D *p;
						pMan2D->CreateParticleEmitter(String("iskry"+IntToStr(++efidx)).c_str(),"iskry",p);
						p->SetScale(0.4);
						p->SetZOrder(800);
						p->SetPosition(bp.x,bp.y);
						p->Release();

						_killbullet(i);
						break;
					}
					else 
					if (bull_id == id2) 
					{
						_idxss.push_back(TCb(id1,_bullets[i].isbullet));
	
						IEmitter2D *p;
						pMan2D->CreateParticleEmitter(String("iskry"+IntToStr(++efidx)).c_str(),"iskry",p);
						p->SetScale(0.4);
						p->SetZOrder(800);
						p->SetPosition(bp.x,bp.y);
						p->Release();

						_killbullet(i);
						break;
					}
				}
			}
		}
}

bool Bullets::CollideWith(unsigned long idx, bool bullet)
{
	if(_idxss.size()>0)
		for(int i = 0; i<_idxss.size(); i++)
			if(_idxss[i].id==idx&&_idxss[i].bul==bullet)
				return true;

	return false;
}

Bullets::Bullets(IEngineCore *eng):_counter(0)
{
	pEngineCore = eng;
	pEngineCore->PluginByType(reinterpret_cast<ICommonPlugin **>(&pSceneManFact),Pl_SCENES);
	pSceneManFact->GetResourceManager(pMainResManager);
	pSceneManFact->GetManager2D(pMan2D);
	pMan2D->GetContactListener(pListner);
}

Bullets::~Bullets()
{
	if(_bullets.size()>0)
		for(int i = 0; i < _bullets.size(); i++)
		{
			_bullets[i].sprite->Free();
			_bullets[i].sprite->Release();
			_bullets[i].body->Free();
			_bullets[i].body->Release();
		}
	
	_bullets.clear();
	pListner->Release();
	pMan2D->Release();
	pMainResManager->Release();
	pSceneManFact->Release();
}
