#include "Film.h"

Film::Film(IResourceManager *g_pResMan)
{
	_noise_lines.clear();

	new_noise_line();
	new_noise_line();
	new_noise_line();
	new_noise_line();
	new_noise_line();

	move = -50;
	move_line = 900;

	g_pResMan->Load(DATA_PATH("plenka\\cadr.png"),"tex_cadr");
	g_pResMan->GetTexture("tex_cadr", tex_cadr);

	g_pResMan->Load(DATA_PATH("plenka\\noise.png"),"tex_noise");
	g_pResMan->GetTexture("tex_noise", tex_noise);

	g_pResMan->Load(DATA_PATH("plenka\\noise1.png"),"tex_noise1");
	g_pResMan->GetTexture("tex_noise1", tex_noise1);

	g_pResMan->Load(DATA_PATH("plenka\\noise2.png"),"tex_noise2");
	g_pResMan->GetTexture("tex_noise2", tex_noise2);

	g_pResMan->Load(DATA_PATH("plenka\\noise3.png"),"tex_noise3");
	g_pResMan->GetTexture("tex_noise3", tex_noise3);	

	g_pResMan->Load(DATA_PATH("plenka\\noise4.png"),"tex_noise4");
	g_pResMan->GetTexture("tex_noise4", tex_noise4);

	g_pResMan->Load(DATA_PATH("plenka\\noise5.png"),"tex_noise5");
	g_pResMan->GetTexture("tex_noise5", tex_noise5);

	g_pResMan->Load(DATA_PATH("plenka\\noise6.png"),"tex_noise6");
	g_pResMan->GetTexture("tex_noise6", tex_noise6);

	g_pResMan->Load(DATA_PATH("plenka\\noise7.png"),"tex_noise7");
	g_pResMan->GetTexture("tex_noise7", tex_noise7);

	g_pResMan->Load(DATA_PATH("plenka\\noise8.png"),"tex_noise8");
	g_pResMan->GetTexture("tex_noise8", tex_noise8);

	g_pResMan->Load(DATA_PATH("plenka\\noise9.png"),"tex_noise9");
	g_pResMan->GetTexture("tex_noise9", tex_noise9);

	g_pResMan->Load(DATA_PATH("plenka\\noise10.png"),"tex_noise10");
	g_pResMan->GetTexture("tex_noise10", tex_noise10);

	g_pResMan->Load(DATA_PATH("plenka\\shadow.png"),"tex_shadow");
	g_pResMan->GetTexture("tex_shadow", tex_shadow);

	g_pResMan->Load(DATA_PATH("plenka\\line.png"),"tex_line");
	g_pResMan->GetTexture("tex_line", tex_line);	

}

Film::~Film()
{
	tex_cadr->Release();
	tex_line->Release();
	tex_noise->Release();
	tex_shadow->Release();
	tex_noise1->Release();
	tex_noise2->Release();
	tex_noise3->Release();
	tex_noise4->Release();
	tex_noise5->Release();
	tex_noise6->Release();
	tex_noise7->Release();
	tex_noise8->Release();
	tex_noise9->Release();
	tex_noise10->Release();
}


void Film::update_noise_points()
{
	_noise_points.clear();

	int count = rand()%20;

	if ( count>2 )
	for(int i = 0; i<count; i++)
	{
		NOISE_POINT np;
		np.x = ( rand()%800 );
		np.y = ( rand()%600 );
		np.n_obj = rand()%9;
		
		if (np.y<34) np.y = 34;
		if (np.y>600-34) np.y = 600-34;

		_noise_points.push_back(np);
	}
}

void Film::new_noise_line()
{
	
	NOISE_LINE nl;

	nl.x = ( rand()%800 );
	nl.inercia = 0.5;//( rand()%2 )

	nl.life = ( rand()%100 );
	if ( nl.life<50 ) nl.life = 50;

	_noise_lines.push_back(nl);
}

void Film::process()
{
	if(_noise_lines.size()>0)
		for(int i = 0; i<_noise_lines.size(); i++)
		{
			_noise_lines[i].x = _noise_lines[i].x + _noise_lines[i].inercia;

			_noise_lines[i].life--;
			
			if ( _noise_lines[i].life<10 ) _noise_lines[i].life = 50;

			if (_noise_lines[i].x>800)
			{
				_noise_lines[i].x = ( rand()%800 );
				_noise_lines[i].inercia = ( rand()%2 );
				_noise_lines[i].life = ( rand()%100 );
				if ( _noise_lines[i].life<50 ) _noise_lines[i].life = 50;
			}

			if (_noise_lines[i].x<0)
			{
				_noise_lines[i].x = ( rand()%800 );
				_noise_lines[i].inercia = ( rand()%2 );
				_noise_lines[i].life = ( rand()%100 );
				if ( _noise_lines[i].life<50 ) _noise_lines[i].life = 50;
			}
		}
	update_noise_points();
	move = move-5;
	if (move<-100) move=-50;

	move_line = move_line-8.02;
	if (move_line<-10) move_line=900;
}

void Film::render()
{
	if(rand()%150==25)
	tex_line->Draw(Point2D_Int(move_line,34),Dimension2D_UInt(2,532),255);

	if(_noise_lines.size()>0)
		for(int i = 0; i<_noise_lines.size(); i++)
		{
				tex_noise->Draw(Point2D_Int(_noise_lines[i].x,34),Dimension2D_UInt(1,532),_noise_lines[i].life+20);
		}

		
	if(_noise_points.size()>0)
	for(int i = 0; i<_noise_points.size(); i++)
	{
		switch( _noise_points[i].n_obj )
		{
			case 0 : tex_noise1->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),100);break;
			case 1 : tex_noise2->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),150);break;
			case 2 : tex_noise3->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),70);break;
			case 3 : tex_noise4->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),200);break;
			case 4 : tex_noise5->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),100);break;
			case 5 : tex_noise6->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),200);break;
			case 6 : tex_noise7->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),200);break;
			case 7 : tex_noise8->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),200);break;
			case 8 : tex_noise9->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),100);break;
			case 9 : tex_noise10->DrawSimple(Point2D_Int(_noise_points[i].x,_noise_points[i].y),200);break;
		}
			
	}

	for(int i=0; i<18; i++)
	{
			tex_cadr->DrawSimple(Point2D_Int((i*50)+move,0),255);
			tex_cadr->DrawSimple(Point2D_Int((i*50)+move,600-34),255);
	}
	int rsh = (rand()%50)+205;
	tex_shadow->Draw(Point2D_Int(0,34),Dimension2D_UInt(800,100),rsh);
	tex_shadow->Draw(Point2D_Int(0,600-134),Dimension2D_UInt(800,100),rsh,false,true);
}