#include "Game.h"

int game::efidx = 0;

IEngineCore	*game::pEngineCore;
_mdel		 game::_delStartGameClick, game::_delExitGameClick, game::_delResumeGameClick;

void game::onQuitClick(IEvent *ev)
{
	pEngineCore->QuitEngine();
}

void game::onContinueGameClick(IEvent *ev)
{
	if (!_delResumeGameClick.IsNull()) _delResumeGameClick();	
}

void game::onExitGameClick(IEvent *ev)
{
	if (!_delExitGameClick.IsNull()) _delExitGameClick();
}

void game::onStartGameClick(IEvent *ev)
{
	if (!_delStartGameClick.IsNull()) _delStartGameClick();
}

void game::resumegame()
{
	IDPEGUIWindow *pWin = NULL;
	pGuiMan->GetForm("win_pause",pWin);
	pWin->SetVisible(false);
	pWin->Release();

	_paused = false;
}

void game::exittomenu()
{	
	IDPEGUIWindow *pWin = NULL;
	pGuiMan->GetForm("win_pause",pWin);
	pWin->SetVisible(false);
	pWin->Release();

	scene(MENU);
}

void game::startgame()
{
	scene(INTRO);
}

game::game(IEngineCore *eng, int w, int h):_levelnumber(0),_dtick(0)
{
	_player = NULL;
	_pPlayerBiped = NULL;
	_map = NULL;
	_bullets = NULL;

	_escpress = false;
	_screen_w = w;
	_screen_h = h;
	_counter = 0;
	_scene = NONE;

	_delStartGameClick+=NewDelegate(this,&game::startgame);
	_delExitGameClick+=NewDelegate(this,&game::exittomenu);
	_delResumeGameClick+=NewDelegate(this,&game::resumegame);

	pEngineCore = eng;

	pEngineCore->GetLog(&_log);

	pEngineCore->PluginByType(reinterpret_cast<ICommonPlugin **>(&pInput),Pl_INPUT);	
	#ifdef _DEBUG
	pInput->CreateDevice(true,false,false);
	#else
	pInput->CreateDevice(true,true,true);
	#endif

	pEngineCore->PluginByType(reinterpret_cast<ICommonPlugin **>(&pSound),Pl_SOUND);	
	pSound->CreateDevice();

	pEngineCore->PluginByType(reinterpret_cast<ICommonPlugin **>(&pSceneManFact),Pl_SCENES);
	pSceneManFact->GetResourceManager(pMainResManager);
	pSceneManFact->GetGUIManager(pGuiMan);
	pSceneManFact->GetManager2D(pMan2D);

	pMan2D->CreateBox2DWorld(Point2D_Int(-10000,-10000),Point2D_Int(10000,10000),Vector2D_Float(0.f,90),true);
	#ifndef _DEBUG
	pMan2D->SetDebugDrawFlags(0);
	#endif
	
	pMan2D->GetCamera(_cam);

	pMainResManager->Load(DATA_PATH("alien_20.dft"),"fnt_main");
	pMainResManager->GetFont("fnt_main",_font);

	pMainResManager->Load(DATA_PATH("menu_bg.jpg"),"menubg");
	pMainResManager->Load(DATA_PATH("menu.png"),"menu");
	pMainResManager->Load(DATA_PATH("button.png"),"button");
	pMainResManager->Load(DATA_PATH("cursor.png"),"cursor");
	pMainResManager->Load(DATA_PATH("dron.jpg"),"dron");
	pMainResManager->Load(DATA_PATH("warner.jpg"),"warner");
	pMainResManager->Load(DATA_PATH("alien.jpg"),"alien");
	pMainResManager->Load(DATA_PATH("txt.jpg"),"txt");
	pMainResManager->Load(DATA_PATH("bullet.png"),"bullet");
	pMainResManager->Load(DATA_PATH("fire.png"),"fire");
	pMainResManager->Load(DATA_PATH("blast.png"),"blast");
	pMainResManager->Load(DATA_PATH("tarelko.png"),"tex_boss");

	pMainResManager->Load(DATA_PATH("ExplodeFlash.pyro"),"color_expl");
	pMainResManager->Load(DATA_PATH("iskry.pyro"),"iskry");
	pMainResManager->Load(DATA_PATH("alien blood.pyro"),"ablood");
	pMainResManager->Load(DATA_PATH("human blood.pyro"),"blood");

	pMan2D->CreateSprite("gun_fire",_fire);
	_fire->SetTexture("fire");
	_fire->SetVisible(false);
	_fire->SetZOrder(780);
	_fire->SetAlpha(100);

	pMainResManager->Load(DATA_PATH("hero\\foot_back.png"),"foot_back");
	pMainResManager->Load(DATA_PATH("hero\\foot_front.png"),"foot_front");
	pMainResManager->Load(DATA_PATH("hero\\leg_back2.png"),"leg_back2");
	pMainResManager->Load(DATA_PATH("hero\\leg_back1.png"),"leg_back1");
	pMainResManager->Load(DATA_PATH("hero\\hand_back2.png"),"hand_back2");
	pMainResManager->Load(DATA_PATH("hero\\hand_back1.png"),"hand_back1");
	pMainResManager->Load(DATA_PATH("hero\\leg_front2.png"),"leg_front2");
	pMainResManager->Load(DATA_PATH("hero\\leg_front1.png"),"leg_front1");
	pMainResManager->Load(DATA_PATH("hero\\head_rash.png"),"head");
	pMainResManager->Load(DATA_PATH("hero\\body.png"),"body");
	pMainResManager->Load(DATA_PATH("hero\\gun.png"),"gun");
	pMainResManager->Load(DATA_PATH("hero\\gun1.png"),"gun1");
	pMainResManager->Load(DATA_PATH("hero\\gun3.png"),"gun2");
	pMainResManager->Load(DATA_PATH("hero\\hand_front2.png"),"hand_front2");
	pMainResManager->Load(DATA_PATH("hero\\hand_front1.png"),"hand_front1");

	pMainResManager->Load(DATA_PATH("inv\\foot_back.png"),"afoot_back");
	pMainResManager->Load(DATA_PATH("inv\\foot_front.png"),"afoot_front");
	pMainResManager->Load(DATA_PATH("inv\\leg_back2.png"),"aleg_back2");
	pMainResManager->Load(DATA_PATH("inv\\leg_back1.png"),"aleg_back1");
	pMainResManager->Load(DATA_PATH("inv\\hand_back2.png"),"ahand_back2");
	pMainResManager->Load(DATA_PATH("inv\\hand_back1.png"),"ahand_back1");
	pMainResManager->Load(DATA_PATH("inv\\leg_front2.png"),"aleg_front2");
	pMainResManager->Load(DATA_PATH("inv\\leg_front1.png"),"aleg_front1");
	pMainResManager->Load(DATA_PATH("inv\\head.png"),"ahead");
	pMainResManager->Load(DATA_PATH("inv\\body.png"),"abody");
	pMainResManager->Load(DATA_PATH("inv\\gun.png"),"agun");
	pMainResManager->Load(DATA_PATH("inv\\hand_front2.png"),"ahand_front2");
	pMainResManager->Load(DATA_PATH("inv\\hand_front1.png"),"ahand_front1");

	_film = new Film(pMainResManager);

	ISoundSample *pSample;
	pSound->LoadSoundSample(DATA_PATH("sound\\expl.wav"),"expl",pSample);
	pSample->Release();

	pSound->LoadSoundSample(DATA_PATH("sound\\hallelujah.wav"),"hallelujah",sHal);
	pSound->LoadSoundSample(DATA_PATH("sound\\auto.wav"),"auto",sShot);
	pSound->LoadSoundSample(DATA_PATH("sound\\evilhaa.wav"),"evilhaa",sAlha);
	pSound->LoadSoundSample(DATA_PATH("sound\\pain.wav"),"pain",sPain);
	pSound->LoadSoundSample(DATA_PATH("sound\\blaster.wav"),"blaster",sBlast);

	pMainResManager->GetTexture("cursor",tex_cursor);
	//

	//Create GUI
	IDPEGUIWindow *pWin;
	IDPEGUIButton *pBtn1, *pBtn2;
	pGuiMan->SetDefaultFont("fnt_main");
	
	//Create pause menu
	pGuiMan->CreateForm("win_pause", Rect2D_Int(295,200,295+210,200+200),pWin);
	pGuiMan->CreateButton("btn_resume", Rect2D_Int(35,75,35+150,75+30),pBtn1);
	pGuiMan->CreateButton("btn_quit", Rect2D_Int(35,132,35+150,132+30),pBtn2);
	pBtn1->SetText("Resume");
	pBtn2->SetText("Quit");
	pBtn1->SetTextColor(0);
	pBtn2->SetTextColor(0);

	pBtn1->AddListerner(ET_ON_CLICK, &onContinueGameClick);
	pBtn2->AddListerner(ET_ON_CLICK, &onExitGameClick);

	pWin->SetSprite(0,"menu",1,1);
	pWin->SetFillMode(false);
	pWin->SetCloseBtnVisible(false);
	pWin->SetVisible(false);
	pWin->SetCanSize(false);
	pWin->SetDragged(false);
	
	pWin->Include(pBtn1);
	pWin->Include(pBtn2);

	pBtn1->SetSprite(0,"button",1,3);
	pBtn2->SetSprite(0,"button",1,3);
	pBtn1->SetFillMode(false);
	pBtn2->SetFillMode(false);

	pWin->Release();
	pBtn1->Release();
	pBtn2->Release();

	//Create Main Menu
	pGuiMan->CreateForm("win_main", Rect2D_Int(5,20,210,200),pWin);
	pGuiMan->CreateButton("btn_start", Rect2D_Int(35,75,35+150,75+30),pBtn1);
	pGuiMan->CreateButton("btn_exit", Rect2D_Int(35,132,35+150,132+30),pBtn2);

	pWin->SetSprite(0,"menu",1,1);
	pWin->SetFillMode(false);
	pWin->SetCloseBtnVisible(false);
	pWin->SetVisible(false);
	pWin->SetCanSize(false);
	pWin->SetDragged(false);

	pWin->Include(pBtn1);
	pWin->Include(pBtn2);

	pBtn1->SetText("Start");
	pBtn2->SetText("Quit");
	pBtn1->SetTextColor(0);
	pBtn2->SetTextColor(0);

	pBtn1->SetSprite(0,"button",1,3);
	pBtn2->SetSprite(0,"button",1,3);
	pBtn1->SetFillMode(false);
	pBtn2->SetFillMode(false);

	pBtn1->AddListerner(ET_ON_CLICK, &onStartGameClick);
	pBtn2->AddListerner(ET_ON_CLICK, &onQuitClick);
	
	pWin->Release();
	pBtn1->Release();
	pBtn2->Release();

	tik = GetTickCount();

	_map = new GameMap(pEngineCore,"intro");

	_log->Log("INVADERS MUST DIE!!!");
}

game::~game()
{	
	endscene();

	sHal->Release();
	sShot->Release();
	sAlha->Release();
	sPain->Release();
	sBlast->Release();

	_fire->Free();
	_fire->Release();
	delete _film;

	_font->Release();
	tex_cursor->Release();

	_cam->Release();
	pMan2D->Release();
	pGuiMan->Release();
	pMainResManager->Release();
	pSceneManFact->Release();

	pSound->ReleaseDevice();
	pSound->Release();

	pInput->ReleaseDevice();
	pInput->Release();
	
	_log->Log("ALL INVADERS ARE DEAD, REALLY???");

	_log->Release();
}

void game::createplayer(Point2D_Int playerpos)
{
if(_player) delete _player;
_player = new CPlayer("player","hero", pEngineCore);
_player->loadDB();
ICollisionShape::TPolygonDesc sd_up, sd_down;
sd_up.density = 50.0f;
sd_up.restitution = 0.0f;
sd_up.friction = 1.0f;

sd_up.vertexCount = 6;
sd_up.vertices[0] = Point2D_Int(-7,-48);
sd_up.vertices[1] = Point2D_Int(17,-48);
sd_up.vertices[2] = Point2D_Int(24,-40);
sd_up.vertices[3] = Point2D_Int(24,80);
sd_up.vertices[4] = Point2D_Int(-14,80);
sd_up.vertices[5] = Point2D_Int(-14,-40);

sd_down = sd_up;
sd_down.vertexCount = 6;
sd_down.vertices[0] = sd_up.vertices[4];
sd_down.vertices[1] = sd_up.vertices[3];
sd_down.vertices[2] = Point2D_Int(24,116);
sd_down.vertices[3] = Point2D_Int(17,124);
sd_down.vertices[4] = Point2D_Int(-7,124);
sd_down.vertices[5] = Point2D_Int(-14,116);

IBody::TBodyDesc bd;
bd.fixedRotation = true;
bd.angularDamping = 0.005f;
bd.linearDamping = 0.0f;
bd.position = Point2D_Int(playerpos);
_player->createBody(sd_up, sd_down, bd);


_player->setGun("gun1", true);
_player->setGun("gun", false);
_player->setGun("gun2", false);

_player->enableAnimation("stand", true);
_player->playAnimations();

_cam->SetPosition(playerpos);
}

void game::startscene(E_SCENE scene)
{
	_scene = scene;
	_counter = 0;

	switch ( _scene )
	{

	case MENU:
			IDPEGUIWindow *pWin;
			pGuiMan->GetForm("win_main",pWin);
			pWin->SetVisible(true);
			pWin->Release();
			
			IMusic *pm;
			pSound->GetMusic(pm);
			bool play;
			pm->IsMusicPlaying(play);
			if (play) pm->StopMusic();
			pm->PlayMusic("menu.mid");
			pm->Release();
		break;

	case GAME:

			pBoss = NULL;

			_lives = 4;
			_shot_wt = 100;

			pMan2D->SetGravity(Vector2D_Float(0.f,9.8*40));
			_aliens_c = 0;
			_paused = false;
			
			if(_aliens.size()>0)
				for(int i = 0; i<_aliens.size(); i++)
					delete _aliens[i];

			_aliens.clear();

			if(_pPlayerBiped) delete _pPlayerBiped;
			if(_bullets) delete _bullets;
			_bullets = new Bullets(pEngineCore);
			if(_map) delete _map;
			_map = new GameMap(pEngineCore,String("map"+IntToStr(_levelnumber)).c_str());
			for(int i = 0; i<_map->GetRespawns()->size(); i++)
			{

				if(_map->GetRespawns()->at(i).type==4)
					_exitx = _map->GetRespawns()->at(i).x;

				if(_map->GetRespawns()->at(i).type==0)
					createplayer(Point2D_Int(_map->GetRespawns()->at(i).x,_map->GetRespawns()->at(i).y));
				
				
				if(_map->GetRespawns()->at(i).type==3)
				{
					pBoss = new CBoss("boss", pEngineCore);
					pBoss->setPosition(Point2D_Int(_map->GetRespawns()->at(i).x,_map->GetRespawns()->at(i).y));
				}

				if(_map->GetRespawns()->at(i).type==1)
				{
					Alien *al = new Alien(String("alien"+IntToStr(++_aliens_c)).c_str(),"inv",pEngineCore, _bullets, sBlast);
					
					al->loadDB();
					ICollisionShape::TPolygonDesc sd_up, sd_down;
					sd_up.density = 50.0f;
					sd_up.restitution = 0.0f;
					sd_up.friction = 1.0f;

					sd_up.vertexCount = 6;
					sd_up.vertices[0] = Point2D_Int(-17,-48);
					sd_up.vertices[1] = Point2D_Int(7,-48);
					sd_up.vertices[2] = Point2D_Int(14,-40);
					sd_up.vertices[3] = Point2D_Int(14,80);
					sd_up.vertices[4] = Point2D_Int(-24,80);
					sd_up.vertices[5] = Point2D_Int(-24,-40);

					sd_down = sd_up;
					sd_down.vertexCount = 6;
					sd_down.vertices[0] = sd_up.vertices[4];
					sd_down.vertices[1] = sd_up.vertices[3];
					sd_down.vertices[2] = Point2D_Int(14,106);
					sd_down.vertices[3] = Point2D_Int(7,114);
					sd_down.vertices[4] = Point2D_Int(-17,114);
					sd_down.vertices[5] = Point2D_Int(-24,106);

					IBody::TBodyDesc bd;
					bd.fixedRotation = true;
					bd.angularDamping = 0.005f;
					bd.linearDamping = 0.0f;
					bd.position = Point2D_Int(_map->GetRespawns()->at(i).x, _map->GetRespawns()->at(i).y);
					al->createBody(sd_up, sd_down, bd);


					_aliens.push_back(al);

				}
		}
		break;

	}

}

void game::endscene()
{

	switch (_scene)
	{

	case LOGO:
		IEmitter2D *p;
		if(SUCCEEDED(pMan2D->GetParticleEmitter("expl1",p)))
		{
			p->Free();
			p->Release();
		}
		delete _map;
		_map = NULL;
		pMan2D->Update(1.f); //        )))))      PMan2D->Draw        )))
		break;

	case MENU:
		IDPEGUIWindow *pWin;
		pGuiMan->GetForm("win_main",pWin);
		pWin->SetVisible(false);
		pWin->Release();

		IMusic *pm;
		pSound->GetMusic(pm);
		pm->StopMusic();
		pm->PlayMusic("ingame.mid");
		pm->Release();

		_levelnumber = 0;
		break;

	case GAME:
		if(pBoss)
		{
			delete pBoss;
			pBoss = NULL;
		}
		if (_map) 
		{
			delete _map;
			_map = NULL;
		}
		if(_pPlayerBiped)
		{
			delete _pPlayerBiped;
			_pPlayerBiped = NULL;
		}
		if(_bullets)
		{
			delete _bullets;
			_bullets = NULL;
		}

		if(_aliens.size()>0)
			for(int i = 0; i<_aliens.size(); i++)
				delete _aliens[i];
		_aliens.clear();

		if(_aliens_corps.size()>0)
			for(int i = 0; i<_aliens_corps.size(); i++)
				delete _aliens_corps[i];
		_aliens_corps.clear();

		break;

	}
}

void game::scene(E_SCENE scene)
{
	endscene();
	startscene(scene);
}


void game::process()
{

	_counter++;

	_film->process();

	pInput->Update();
	
	pInput->GetMouseStates(_mouse);
	bool _down[3];
	switch (_scene)
	{

	case INTRO:
			if (_counter>870) scene(GAME);
			pInput->GetKey(KEY_SPACE,_down[0]);
			pInput->GetKey(KEY_RETURN,_down[1]);
			pInput->GetKey(KEY_ESCAPE,_down[2]);

			if(_down[0]||_down[1]||_down[2])
			{
				scene(GAME);
				return;
			}
			pMan2D->Update(1.f);
	break;

	case LOGO:
		pInput->GetKey(KEY_SPACE,_down[0]);
		pInput->GetKey(KEY_RETURN,_down[1]);
		pInput->GetKey(KEY_ESCAPE,_down[2]);

		if(_counter>150&&_down[0]||_down[1]||_down[2])
		{
			scene(MENU);
			return;
		}

		if (_counter==150)
		{
			ISoundSample *pSample;
			if(SUCCEEDED(pSound->GetSoundSample("expl",pSample)))
			{
				pSample->Play();
				pSample->Release();
			}
		}

		if (_counter==145)
		{	
			IEmitter2D *p;
			pMan2D->CreateParticleEmitter("expl1","color_expl",p);
			p->SetZOrder(800);
			p->SetSpeed(0.04);
			p->SetPosition(320,353);
			p->Release();
		}

		if(_counter>155)
		pMan2D->Update(1.f);
		else
		pMan2D->Update(0.f);

		if (_counter>650) 
		{
			scene(MENU);
			return;
		}

		break;

	case MENU:
		pMan2D->Update(1.f);
		pGuiMan->Update(1.f);
		break;

	case GAME:
		
		bool down;
		pInput->GetKey(KEY_ESCAPE,down);
		if (_escpress && !down) 
		{
			IDPEGUIWindow *pWin = NULL;
			pGuiMan->GetForm("win_pause",pWin);
			pWin->SetVisible(true);
			pWin->Release();
			_paused = true;
		}

		_escpress = down;

		if (!_paused)
		{

			if (_bullets) _bullets->Update();

			if (_player) 
			{

				Point2D_Int playerpos;
				_player->getPosition(playerpos);


				if(playerpos.x>_exitx)
				{
					_levelnumber++;
					scene(GAME);
					return;
				}

				_shot_wt++;
				pInput->GetKey(KEY_SPACE,down);
				if(down && _shot_wt>10)
				{
					_shot_wt = 0;
					_bullets->MakeShot(Point2D_Int(playerpos.x+40,playerpos.y+16),true); 
					_fire->SetVisible(true);
					sShot->Play();
				}

				_fire->SetPosition(Point2D_Int(playerpos.x+90,playerpos.y+16));
				_fire->SetVisible(_shot_wt<1);

				_player->update(pInput, 30.0f);
				if(_bullets->CollideWith(_player->getid(false),false)||_bullets->CollideWith(_player->getid(true),false))
				{
						sPain->Play();	
						_player->dechealth(35);
						IEmitter2D *p;
						pMan2D->CreateParticleEmitter(String("blood"+IntToStr(++efidx)).c_str(),"blood",p);
						p->SetZOrder(800);
						p->SetPosition(playerpos.x,playerpos.y+15);
						p->Release();
				}
				Point2D_Int pos, pl_pos;
				_cam->GetPosition(pos);
				_player->getPosition(pl_pos);
				if(pl_pos.x+200>pos.x)
					pos.x = pl_pos.x+200;
				pos.y = pl_pos.y - 100;
				_cam->MoveTo(pos);

				if(_player->gethealth()<=0)
				{

					CBipedDesc *desc = new CBipedDesc();
					desc->humanVertices();
					desc->humanPositions();
					desc->humanJoints();
					{
						ISprite *obj = 0;
						// left thigh
						{
							obj = _player->GetSprite("leg_back1");
							obj->SetPosition(-12, -7);
							obj->SetAngle(0.0f, Point2D_Int(12, 7));
							desc->setLThigh(obj);
						}
						// left calf
						{
							obj = _player->GetSprite("leg_back2");
							obj->SetPosition(-12, -7);
							obj->SetAngle(0.0f, Point2D_Int(12, 7));
							desc->setLCalf(obj);
						}
						// left foot
						{
							obj = _player->GetSprite("foot_back");
							obj->SetPosition(-5, -2);
							obj->SetAngle(0.0f, Point2D_Int(5, 2));
							desc->setLFoot(obj);
						}
						// left upperarm
						{
							obj = _player->GetSprite("hand_back1");
							obj->SetPosition(-7, -5);
							obj->SetAngle(0.0f, Point2D_Int(7, 5));
							desc->setLUpperArm(obj);
						}
						// left forearm
						{
							obj = _player->GetSprite("hand_back2");
							obj->SetPosition(-7, -6);
							obj->SetAngle(0.0f, Point2D_Int(7, 6));
							desc->setLForearm(obj);
						}
						// head
						{
							obj = _player->GetSprite("head");
							obj->SetPosition(-20,-21);
							obj->SetAngle(2.09439510f, Point2D_Int(20,21));
							desc->setHead(obj);
						}
						// chest
						{
							obj = _player->GetSprite("body");
							obj->SetPosition(-8, -18);
							obj->SetAngle(0.0f, Point2D_Int(8,18));
							desc->setChest(obj);
						}
						// right thigh
						{
							obj = _player->GetSprite("leg_front1");
							obj->SetPosition(-12, -7);
							obj->SetAngle(0.0f, Point2D_Int(12, 7));
							desc->setRThigh(obj);
						}
						// right calve
						{
							obj = _player->GetSprite("leg_front2");
							obj->SetPosition(-12, -7);
							obj->SetAngle(0.0f, Point2D_Int(12, 7));
							desc->setRCalf(obj);
						}
						// right foot
						{
							obj = _player->GetSprite("foot_front");
							obj->SetPosition(-5, -2);
							obj->SetAngle(0.0f, Point2D_Int(5, 2));
							desc->setRFoot(obj);
						}
						// right upperarm
						{
							obj = _player->GetSprite("hand_front1");
							obj->SetPosition(-7, -5);
							obj->SetAngle(0.0f, Point2D_Int(7, 5));
							desc->setRUpperArm(obj);
						}
						// right forearm
						{
							obj = _player->GetSprite("hand_front2");
							obj->SetPosition(-7, -6);
							obj->SetAngle(0.0f, Point2D_Int(7, 6));
							desc->setRForearm(obj);
						}
					}
					
					_pPlayerBiped = CBiped::Create(pMan2D, desc, playerpos);
					_pPlayerBiped->setMassFromShapes();
					_pPlayerBiped->ApplyImp(-2000.f);

					delete _player;
					_player = NULL;
					_lives --;
					_dtick = 0;
				} 

			}
			else
			{
				if(_pPlayerBiped)
				{
					Point2D_Int pos;
					_pPlayerBiped->getPosition(pos);
					pos.y-=120;
					_cam->MoveTo(pos);
					pos.y-=300;
					_dtick++;
					if(_dtick>200&&_lives>=0)
					{
						_dtick = 0;
						createplayer(pos);
						sHal->Play();
						delete _pPlayerBiped;
						_pPlayerBiped = NULL;
					}
				}
			}

			Point2D_Int pl_pos = Point2D_Int(0,0);
			if(_player)	_player->getPosition(pl_pos);

			if(_aliens.size()>0)
			for(int i = 0; i<_aliens.size(); i++)
			{
				_aliens[i]->update(pInput, 30.0f, pl_pos);
				
				if(_bullets->CollideWith(_aliens[i]->getid(false),true)||_bullets->CollideWith(_aliens[i]->getid(true),true))
				{				
					_aliens[i]->dechealth(25);
					Point2D_Int pos;
					_aliens[i]->getPosition(pos);
					IEmitter2D *p;
					pMan2D->CreateParticleEmitter(String("ablood"+IntToStr(++efidx)).c_str(),"ablood",p);
					p->SetZOrder(800);
					p->SetPosition(pos.x,pos.y+15);
					p->Release();

				}
				if(_aliens[i]->gethealth()<=0)
				{

					sAlha->Play();

					CBipedDesc *desc = new CBipedDesc();
					desc->alienVertices();
					desc->alienPositions();
					desc->alienJoints();

						ISprite *obj = 0;
						// left thigh
						{
							obj = _aliens[i]->GetSprite("aleg_back1");
							obj->SetPosition(-9, -7);
							obj->SetAngle(0.0f, Point2D_Int(9, 7));
							desc->setLThigh(obj);
						}
						// left calf
						{
							obj = _aliens[i]->GetSprite("aleg_back2");
							obj->SetPosition(-5, -4);
							obj->SetAngle(0.0f, Point2D_Int(5, 4));
							desc->setLCalf(obj);
						}
						// left foot
						{
							obj = _aliens[i]->GetSprite("afoot_back");
							obj->SetPosition(-16, -3);
							obj->SetAngle(0.0f, Point2D_Int(16, 3));
							desc->setLFoot(obj);
						}
						// left upperarm
						{
							obj = _aliens[i]->GetSprite("ahand_back1");
							obj->SetPosition(-3, -3);
							obj->SetAngle(0.0f, Point2D_Int(3, 3));
							desc->setLUpperArm(obj);
						}
						// left forearm
						{
							obj = _aliens[i]->GetSprite("ahand_back2");
							obj->SetPosition(-10, -5);
							obj->SetAngle(0.0f, Point2D_Int(10, 5));
							desc->setLForearm(obj);
						}
						// head
						{
							obj = _aliens[i]->GetSprite("ahead");
							obj->SetPosition(-12, -11);
							obj->SetAngle(0.0f, Point2D_Int(12, 11));
							desc->setHead(obj);
						}
						// chest
						{
							obj = _aliens[i]->GetSprite("abody");
							obj->SetPosition(-10, -14);
							obj->SetAngle(0.0f, Point2D_Int(10, 14));
							desc->setChest(obj);
						}
						// right thigh
						{
							obj = _aliens[i]->GetSprite("aleg_front1");
							obj->SetPosition(-9, -7);
							obj->SetAngle(0.0f, Point2D_Int(9, 7));
							desc->setRThigh(obj);
						}
						// right calve
						{
							obj = _aliens[i]->GetSprite("aleg_front2");
							obj->SetPosition(-5, -4);
							obj->SetAngle(0.0f, Point2D_Int(5, 4));
							desc->setRCalf(obj);
						}
						// right foot
						{
							obj = _aliens[i]->GetSprite("afoot_front");
							obj->SetPosition(-16, -3);
							obj->SetAngle(0.0f, Point2D_Int(16, 3));
							desc->setRFoot(obj);
						}
						// right upperarm
						{
							obj = _aliens[i]->GetSprite("ahand_front1");
							obj->SetPosition(-3, -3);
							obj->SetAngle(0.0f, Point2D_Int(3, 3));
							desc->setRUpperArm(obj);
						}
						// right forearm
						{
							obj = _aliens[i]->GetSprite("ahand_front2");
							obj->SetPosition(-7, -6);
							obj->SetAngle(0.0f, Point2D_Int(7, 6));
							desc->setRForearm(obj);
						}
					
					Point2D_Int pnt;
					_aliens[i]->getPosition(pnt);
					CBiped *acp = CBiped::Create(pMan2D, desc, pnt);
					acp->setMassFromShapes();
					acp->ApplyImp(2000.f);

					_aliens_corps.push_back(acp);
					delete _aliens[i];
					_aliens.erase(_aliens.begin()+i);
				}

			}


			if(pBoss) pBoss->update();

			pMan2D->Update(1.f);
		}
		else
		{
			pGuiMan->Update(1.f);
		}

		break;

	}

}

void game::render()
{
	if (_map) _map->DrawBG();
	pMan2D->Draw(NULL);

	switch (_scene)
	{

	case INTRO:
		if (_counter<170) 
		{
			ITexture *t;
			pMainResManager->GetTexture("warner",t);
			t->Draw(Point2D_Int(0,0),Dimension2D_UInt(800,600),255-_counter*1.2);
			t->Release();
		}
		if (_counter>170 && _counter<420)
		{
			ITexture *t;
			pMainResManager->GetTexture("dron",t);
			if (_counter>190)
			t->DrawSimple(Point2D_Int(100,150));
			t->Release();
			_font->Draw("Sergant James",120,110);
			if (_counter>210)
			_font->Draw("Staring DRON",100,430);
			
			if (_counter>250)
			_font->Draw("V S",340,250,ColorRGB(1.f,1.f,1.f),255,3);

			if (_counter>290)
			{
				pMainResManager->GetTexture("alien",t);
				if (_counter>310)
				t->DrawSimple(Point2D_Int(500,170));
				t->Release();
				_font->Draw("Evil invaders",520,110);
				if (_counter>340)
				_font->Draw("Staring Alien Bob",500,430);
			}

			if (_counter>390)
				_font->Draw("IN",350,450,ColorRGB(1.f,1.f,1.f),255,3);

		}
		
		if (_counter>420)
		{
			if (_counter<450)
			_font->Draw("FILM BY",250,250,ColorRGB(1.f,1.f,1.f),255,3);

			if (_counter>460&&_counter<500)
			_font->Draw("MASTER OF HORROR",0,250,ColorRGB(1.f,1.f,1.f),255,3);

			if (_counter>500&&_counter<570)
			_font->Draw("George Andrew Romero",120,250,ColorRGB(1.f,1.f,1.f),255,2);

			if (_counter>570&&_counter<670)
			{
				ITexture *t;
				pMainResManager->GetTexture("txt",t);
				t->DrawSimple(Point2D_Int(207,190));
				t->Release();
				_font->Draw("Invaders Must Die",300,280);
				_font->Draw("(c) Warner Bros. 1968 year",250,500);
			}

			if(_counter>670)
			{
				ITexture *t;
				pMainResManager->GetTexture("txt",t);
				t->DrawSimple(Point2D_Int(207,190));
				t->Release();
				_font->Draw("Sergant James grabs his gun,",250,250);
				_font->Draw("and goes outside to kick",250,285);
				_font->Draw("some alien butts!",250,320);

			}

		}
		_film->render();
	break;

	case LOGO:
		if(_counter<155)
			_font->Draw("PRESENTS",500,400,ColorRGB(0.f,0.f,0.f),255,2);
		break;

	case MENU:
		ITexture *t;
		pMainResManager->GetTexture("menubg",t);
		t->Draw(Point2D_Int(0,0),Dimension2D_UInt(800,600));
		t->Release();

		_font->Draw("Invaders Must Die",320,40,ColorRGB(1.f,1.f,1.f),255,2);
		_film->render();
		pGuiMan->Draw();
		tex_cursor->DrawSimple(Point2D_Int(_mouse.world_x,_mouse.world_y));
		break;

	case GAME:
		_film->render();
		if(_dtick>250&&_lives<0)
		_font->Draw("The End",250,250,ColorRGB(1.f,1.f,1.f),255,3);

		if(_lives>0)
		{
			ITexture *t;
			pMainResManager->GetTexture("head",t);
			for(int i=0; i<_lives; i++)
			t->DrawSimple(Point2D_Int(10+i*32,520));
			t->Release();
		}

		pGuiMan->Draw();
		if(_paused)
		tex_cursor->DrawSimple(Point2D_Int(_mouse.world_x,_mouse.world_y));
		break;

	}

}