#pragma once
#include <DPE_Application_Include.h>

#include "GameMap.h"
#include "Film.h"
#include "player.h"
#include "biped.h"
#include "Bullets.h"
#include "alien.h"
#include "boss.h"

#include <math.h>
#include <string>
#include <vector>
using namespace std;

#ifdef _DEBUG
//#define DATA_PATH(filename) string("..\\..\\release\\data\\"+string(filename)).c_str()
#define DATA_PATH(filename) string("..\\..\\release\\data.zip|"+string(filename)).c_str()
#else 
#define DATA_PATH(filename) string("data.zip|"+string(filename)).c_str() 
#endif

class GameMap;
class Film;
class Bullets;
class Alien;

enum E_SCENE
{
	NONE,
	LOGO,
	MENU,
	GAME,
	INTRO
};

typedef CDelegate0 <void> _mdel; //method deligate

class game {

private:
	
	DWORD tik;

	bool _escpress, _paused;

	static int efidx;

	int _counter, _screen_w, _screen_h;
	
	E_SCENE _scene;

	sMouseStates _mouse;

	static _mdel		_delStartGameClick, _delExitGameClick, _delResumeGameClick;

	IFont				*_font;

	ILog				*_log;
	
	IInput				*pInput;
	ISound				*pSound;
	static IEngineCore	*pEngineCore;
	IResourceManager	*pMainResManager;
	IDPEGUIManager		*pGuiMan;
	IManager2D			*pMan2D;

	int					_exitx;

	IManagersFactory	*pSceneManFact;

	ITexture	*tex_cursor;

	ISoundSample *sHal, *sShot, *sAlha, *sPain, *sBlast;

	ICamera2D	*_cam;
	GameMap		*_map;
	Bullets		*_bullets;
	int			_levelnumber;

	Film				*_film;
	CPlayer				*_player;
	CBiped				*_pPlayerBiped;
	int					_aliens_c;

	CBoss				*pBoss;

	ISprite				*_fire;

	int					_lives;
	int					_dtick;
	int					_shot_wt;

	std::vector<Alien*>	 _aliens;
	std::vector<CBiped*> _aliens_corps;

	static void onQuitClick(IEvent *ev);
	static void onStartGameClick(IEvent *ev);
	static void onExitGameClick(IEvent *ev);
	static void onContinueGameClick(IEvent *ev);

	void startgame();
	void exittomenu();
	void resumegame();
	void createplayer(Point2D_Int playerpos);

	void startscene(E_SCENE scene);
	void endscene();

public:

	game(IEngineCore *eng, int w, int h);
	~game();
	void scene(E_SCENE scene);
	void process();
	void render();

};