#pragma once

#include <DPE_Application_Include.h>
#include <StringUtils.h>
#include "Game.h"
#include <vector>
#include <string>
using namespace std;

struct TDB_Obj
{
	char name[64];
	int  special; 
	//-1 for non special 
	char tex_name[64];
	int width;
	int height;
	int borderX[8];
	int borderY[8];
	bool isstatic;
	bool ispassable;
	bool ispoly;
	float density;
};

struct TMapObj
{
	int idx;
	int ground;
	int XCoord[8];
	int YCoord[8];
	int w;
	int h;
	bool isstatic;
	bool ispassable;
	bool ispoly;
	float density;
};

struct TMapHeader
{
	int color1;
	int color2;
	int count;
};

struct TRespawnData
{
	int type;//0 - player respawn, 1 - enemy1, 2 - enemy2, 3 - UFO, 4 - medekit, 5 - grenade, 6 - macinegun, 7 - podstvolka
	int x;
	int y;
};

struct TInagemePhysSprite
{
	ISprite *sprite;
	IBody *body;
	TInagemePhysSprite::TInagemePhysSprite(ISprite *s, IBody *b)
	{
		sprite = s;
		body = b;
	}
};

class GameMap {

private:
	
	IEngineCore			*pEngineCore;
	IManagersFactory 	*pSceneManFact;
	IResourceManager	*pMainResManager;
	IManager2D			*pMan2D;

	static vector<TDB_Obj>		obj_base;
	vector<TRespawnData>		respawns;
	vector<TInagemePhysSprite>  sprites;

	TMapHeader	_header;

	void	_loadobjectsdb();
	void	_loadmap(const char *name);
	void    _freemap();

public:
	
	vector<TRespawnData>* GetRespawns();
	void DrawBG();
	GameMap(IEngineCore *eng, const char *name);
	~GameMap();

};