#include "alien.h"

Alien::Alien(const char *name, const char *texdat, IEngineCore *core, Bullets *bul, ISoundSample *blast):CPlayer(name,texdat,core)
{
	_bullets = bul;
	bl = blast;
	shot_wait = 0;
	playAnimations();
	allowmoving = (rand()%5!=2);
	if(!allowmoving)
	{
		canseat = true;
		canjump = false;
	}
	else
	{
	canseat = (rand()%3==1);
	canjump = (rand()%2==1);
	}
	statictic = 0;
}

Alien::~Alien()
{

}

void Alien::update(IInput *input, float speed, Point2D_Int playerpos)
{
 bool leftcollide = false;
 bool collision = false;
 bool wascol = false;
 mbInAir = true;

 mBody->AllowSleeping(true);

 if (mCtrl_up && mBody)
 {
  int count = 0;
  mListner->GetCount(count);
  IContactListener::TContactPoint cpoint;
  if (count > 0)
  {
   unsigned long id_shape2 = 0, id_shape = 0, id1 = 0, id2 = 0;
   if (mbSeating) mCtrl_up->GetID(id_shape);
   else
	   if(mCtrl_down!=NULL) mCtrl_down->GetID(id_shape);

   if(mCtrl_down!=NULL) mCtrl_down->GetID(id_shape2);

   for (int i = 0; i < count; i++)
   {
    cpoint.pShape1 = NULL;
    cpoint.pShape2 = NULL;
    mListner->NextPoint(cpoint);
    cpoint.pShape1->GetID(id1);
    cpoint.pShape2->GetID(id2);
    Vector2D_Float vy(0.0f, 1.0f), normal = cpoint.normal;
   
    if (id_shape == id1 && id_shape2!=id2)
    {
     collision = true;
    }
    else if (id_shape == id2&& id_shape2!=id1)
    {
     collision = true;
     vy.y*= -1.0f;
    }

    if (collision)
    {  
     float length = sqrt(normal.x*normal.x+normal.y*normal.y);
     normal = Vector2D_Float(normal.x/length, normal.y/length);
     float angle = acosf( normal.x*vy.x+normal.y*vy.y );

     if (abs(angle) < PI/4.0f)
     {
      mbInAir = false;
	  wascol = true;
	  break;
     }
	 else
	 {
		//if(!wascol)
		leftcollide = true;
		break;
	 }
    }
   }
  }
 }

 Point2D_Int pos, cpos;
 mBody->GetPosition(pos);
 ICamera2D *cam;
 mMan2d->GetCamera(cam);
 cam->GetPosition(cpos);
 cam->Release();
 if(cpos.x+520>pos.x&&cpos.x-300<pos.x)
 {
	 shot_wait++;
	 //here cpmes AI

	 if(shot_wait>60)
	 {
		 shot_wait = 0;
		_bullets->MakeShot(Point2D_Int(pos.x-60,pos.y+10),false);
		bl->Play();
	 }


	 //LOGIC

		static const float imp_value = 1400.0f/10.f;
		Vector2D_Float impulse, velocity;		
		bool doJUMP = false;
		mBody->GetWorldCenter(pos);
		if(oldp==pos) 
		{
			statictic++;
			if(statictic>2)
			{
				statictic = 0;
				doJUMP = true;
			}
		}
		oldp = pos;
		// reset player

		mBody->GetLinearVelocity(velocity);
		if (abs(velocity.x) < 30.0f && (int)velocity.y == 0 && !mbSeating && !mbInAir)
		{
			enableAnimation("stand", true);
			enableAnimation("down", false);
			enableAnimation("walk", false);
			enableAnimation("jump", false);
		}

		//

		//Seating
		
		if ((pos.y<playerpos.y || !allowmoving) && canseat && !mbInAir)
		{
				mbSeating = true;
				enableAnimation("stand", false);
				enableAnimation("walk", false);
				enableAnimation("jump", false);
				enableAnimation("down", true);
				// delete down shape
				if (mCtrl_down)
				{
					mCtrl_down->Free();
					mCtrl_down->Release();
					mCtrl_down = NULL;
				}
				impulse+= Vector2D_Float(0.0f, imp_value/2);
		}
		else
		{
			// return down shape
			if (!mCtrl_down && !mbInAir)
			{
				enableAnimation("stand", true);
				mbSeating = false;

				Point2D_Int pos;
				mBody->GetPosition(pos);
				pos.y-=52;
				mBody->SetPosition(pos);

				mMan2d->CreateEmptyObject((mName+"_down").c_str(), mCtrl_down);
				assert(mCtrl_down);
				mCtrl_down->SetShape(&mSDDown);

				mBody->AppendShapes(mCtrl_down);
				mBody->SetMassFromShapes();
			}
		}



		//jump
		if ((pos.y>playerpos.y+100 && rand()%10==5 && canjump) || (doJUMP && !mbSeating && pos.x>playerpos.x+300))
		{			
			if (!mbInAir)
			{
				enableAnimation("stand", false);
				enableAnimation("down", false);
				enableAnimation("walk", false);
				enableAnimation("jump", true);
				impulse+= Vector2D_Float(0.0f, -13*imp_value);
				mbInAir = true;
				mbSeating = false;
				mbWalk = false;
			}
		}		

		//go left
		if (allowmoving && !leftcollide && !mbSeating && pos.x>playerpos.x+300)
		{
			if (!mbInAir)
			{
				enableAnimation("stand", false);
				enableAnimation("down", false);
				enableAnimation("jump", false);
				enableAnimation("walk", true);
				mbSeating = false;
				mbWalk = true;
			}
			impulse+= Vector2D_Float(-imp_value/1.5, 0.0f);
		}

			if (velocity.y <= -200.0f) impulse.y = 0.0f;
			if (velocity.x <= -150.0f) impulse.x = 0.0f;
			mBody->ApplyImpulse(impulse, pos);

	//////////////////////////
			 updateAnimations(speed);
 }
}
