#include "biped desc.h"

signed short CBipedDesc::NEXT_GROUP = 0;

const int c_scale = 1;

CBipedDesc::CBipedDesc() : 
	HeadShape(NULL),
	ChestShape(NULL),
	LThighShape(NULL),
	RThighShape(NULL),
	LCalfShape(NULL),
	RCalfShape(NULL),
	LFootShape(NULL),
	RFootShape(NULL),
	LUpperArmShape(NULL),
	RUpperArmShape(NULL),
	LForearmShape(NULL),
	RForearmShape(NULL)
{
	setMotorTorque(2.0f);
	setMotorSpeed(0.0f);
	setDensity(80.0f);
	setRestitution(0.0f);
	setFriction(1.0f);
	setLinearDamping(0.0f);
	setAngularDamping(0.005f);
	setGroupIndex(--NEXT_GROUP);
	enableMotor();
	enableLimit();
}
CBipedDesc::~CBipedDesc()
{
	if(HeadShape) HeadShape->Release();
	if(ChestShape) ChestShape->Release();
	if(LThighShape) LThighShape->Release();
	if(RThighShape) RThighShape->Release();
	if(LCalfShape) LCalfShape->Release();
	if(RCalfShape) RCalfShape->Release();
	if(LFootShape) LFootShape->Release();
	if(RFootShape) RFootShape->Release();
	if(LUpperArmShape) LUpperArmShape->Release();
	if(RUpperArmShape) RUpperArmShape->Release();
	if(LForearmShape) LForearmShape->Release();
	if(RForearmShape) RForearmShape->Release();
}

void CBipedDesc::Free()
{
	if(HeadShape) HeadShape->Free();
	if(ChestShape) ChestShape->Free();
	if(LThighShape) LThighShape->Free();
	if(RThighShape) RThighShape->Free();
	if(LCalfShape) LCalfShape->Free();
	if(RCalfShape) RCalfShape->Free();
	if(LFootShape) LFootShape->Free();
	if(RFootShape) RFootShape->Free();
	if(LUpperArmShape) LUpperArmShape->Free();
	if(RUpperArmShape) RUpperArmShape->Free();
	if(LForearmShape) LForearmShape->Free();
	if(RForearmShape) RForearmShape->Free();
}

void CBipedDesc::setMotorTorque(float f)
{
	LAnkleDesc.maxMotorTorque		= f;
	RAnkleDesc.maxMotorTorque		= f;
	LKneeDesc.maxMotorTorque		= f;
	RKneeDesc.maxMotorTorque		= f;
	LHipDesc.maxMotorTorque			= f;
	RHipDesc.maxMotorTorque			= f;
	NeckDesc.maxMotorTorque			= f;
	LShoulderDesc.maxMotorTorque	= f;
	RShoulderDesc.maxMotorTorque	= f;
	LElbowDesc.maxMotorTorque		= f;
	RElbowDesc.maxMotorTorque		= f;
}
void CBipedDesc::setMotorSpeed(float f)
{
	LAnkleDesc.motorSpeed		= f;
	RAnkleDesc.motorSpeed		= f;
	LKneeDesc.motorSpeed		= f;
	RKneeDesc.motorSpeed		= f;
	LHipDesc.motorSpeed			= f;
	RHipDesc.motorSpeed			= f;
	NeckDesc.motorSpeed			= f;
	LShoulderDesc.motorSpeed	= f;
	RShoulderDesc.motorSpeed	= f;
	LElbowDesc.motorSpeed		= f;
	RElbowDesc.motorSpeed		= f;
}
void CBipedDesc::setDensity(float f)
{
	HeadCirc.density			= f;
	ChestPoly.density			= f;
	LThighPoly.density			= f;
	RThighPoly.density			= f;
	LCalfPoly.density			= f;
	RCalfPoly.density			= f;
	LFootPoly.density			= f;
	RFootPoly.density			= f;
	LUpperArmPoly.density		= f;
	RUpperArmPoly.density		= f;
	LForearmPoly.density		= f;
	RForearmPoly.density		= f;
}
void CBipedDesc::setFriction(float f)
{
	HeadCirc.friction			= f;
	ChestPoly.friction			= f;
	LThighPoly.friction			= f;
	RThighPoly.friction			= f;
	LCalfPoly.friction			= f;
	RCalfPoly.friction			= f;
	LFootPoly.friction			= f;
	RFootPoly.friction			= f;
	LUpperArmPoly.friction		= f;
	RUpperArmPoly.friction		= f;
	LForearmPoly.friction		= f;
	RForearmPoly.friction		= f;
}
void CBipedDesc::setRestitution(float f)
{
	HeadCirc.restitution			= f;
	ChestPoly.restitution			= f;
	LThighPoly.restitution			= f;
	RThighPoly.restitution			= f;
	LCalfPoly.restitution			= f;
	RCalfPoly.restitution			= f;
	LFootPoly.restitution			= f;
	RFootPoly.restitution			= f;
	LUpperArmPoly.restitution		= f;
	RUpperArmPoly.restitution		= f;
	LForearmPoly.restitution		= f;
	RForearmPoly.restitution		= f;
}
void CBipedDesc::setLinearDamping(float f)
{
	HeadDesc.linearDamping		= f;
	ChestDesc.linearDamping		= f;
	LThighDesc.linearDamping	= f;
	RThighDesc.linearDamping	= f;
	LCalfDesc.linearDamping		= f;
	RCalfDesc.linearDamping		= f;
	LFootDesc.linearDamping		= f;
	RFootDesc.linearDamping		= f;
	LUpperArmDesc.linearDamping	= f;
	RUpperArmDesc.linearDamping	= f;
	LForearmDesc.linearDamping	= f;
	RForearmDesc.linearDamping	= f;
}
void CBipedDesc::setAngularDamping(float f)
{
	HeadDesc.angularDamping		= f;
	ChestDesc.angularDamping	= f;
	LThighDesc.angularDamping	= f;
	RThighDesc.angularDamping	= f;
	LCalfDesc.angularDamping	= f;
	RCalfDesc.angularDamping	= f;
	LFootDesc.angularDamping	= f;
	RFootDesc.angularDamping	= f;
	LUpperArmDesc.angularDamping= f;
	RUpperArmDesc.angularDamping= f;
	LForearmDesc.angularDamping	= f;
	RForearmDesc.angularDamping	= f;
}
void CBipedDesc::enableLimit()
{
	setLimit(true);
}
void CBipedDesc::disableLimit()
{
	setLimit(false);
}
void CBipedDesc::setLimit(bool b)
{
	LAnkleDesc.enableLimit		= b;
	RAnkleDesc.enableLimit		= b;
	LKneeDesc.enableLimit		= b;
	RKneeDesc.enableLimit		= b;
	LHipDesc.enableLimit		= b;
	RHipDesc.enableLimit		= b;
	NeckDesc.enableLimit		= b;
	LShoulderDesc.enableLimit	= b;
	RShoulderDesc.enableLimit	= b;
	LElbowDesc.enableLimit		= b;
	RElbowDesc.enableLimit		= b;
}
void CBipedDesc::enableMotor()
{
	setMotor(true);
}
void CBipedDesc::disableMotor()
{
	setMotor(false);
}
void CBipedDesc::setMotor(bool b)
{
	LAnkleDesc.enableLimit		= b;
	RAnkleDesc.enableLimit		= b;
	LKneeDesc.enableLimit		= b;
	RKneeDesc.enableLimit		= b;
	LHipDesc.enableLimit		= b;
	RHipDesc.enableLimit		= b;
	NeckDesc.enableLimit		= b;
	LShoulderDesc.enableLimit	= b;
	RShoulderDesc.enableLimit	= b;
	LElbowDesc.enableLimit		= b;
	RElbowDesc.enableLimit		= b;
}
void CBipedDesc::setGroupIndex(signed short i)
{
	HeadCirc.filter.groupIndex			= i;
	ChestPoly.filter.groupIndex			= i;
	LThighPoly.filter.groupIndex		= i;
	RThighPoly.filter.groupIndex		= i;
	LCalfPoly.filter.groupIndex			= i;
	RCalfPoly.filter.groupIndex			= i;
	LFootPoly.filter.groupIndex			= i;
	RFootPoly.filter.groupIndex			= i;
	LUpperArmPoly.filter.groupIndex		= i;
	RUpperArmPoly.filter.groupIndex		= i;
	LForearmPoly.filter.groupIndex		= i;
	RForearmPoly.filter.groupIndex		= i;
}
void CBipedDesc::setPosition(int x, int y)
{
	setPosition(Point2D_Int(x,y));	
}
void CBipedDesc::setPosition(const Point2D_Int &pos)
{
	HeadDesc.position = c_scale * Point2D_Int(0,-50) + pos;
	ChestDesc.position = c_scale * Point2D_Int(0,0) + pos;
	LThighDesc.position = RThighDesc.position = c_scale * Point2D_Int(0,95) + pos;
	LCalfDesc.position = RCalfDesc.position = c_scale * Point2D_Int(0,145) + pos;
	LFootDesc.position = RFootDesc.position = c_scale * Point2D_Int(0,192) + pos;
	LUpperArmDesc.position = RUpperArmDesc.position = c_scale * Point2D_Int(0,-5) + pos;
	LForearmDesc.position = RForearmDesc.position = c_scale * Point2D_Int(0,45) + pos;
}
void CBipedDesc::setBullet(bool b)
{
	HeadDesc.isBullet		= b;
	ChestDesc.isBullet		= b;
	LThighDesc.isBullet		= b;
	RThighDesc.isBullet		= b;
	LCalfDesc.isBullet		= b;
	RCalfDesc.isBullet		= b;
	LFootDesc.isBullet		= b;
	RFootDesc.isBullet		= b;
	LUpperArmDesc.isBullet	= b;
	RUpperArmDesc.isBullet	= b;
	LForearmDesc.isBullet	= b;
	RForearmDesc.isBullet	= b;
}

void CBipedDesc::setFixedRotation(bool b)
{
	HeadDesc.fixedRotation		= b;
	ChestDesc.fixedRotation		= b;
	LThighDesc.fixedRotation	= b;
	RThighDesc.fixedRotation	= b;
	LCalfDesc.fixedRotation		= b;
	RCalfDesc.fixedRotation		= b;
	LFootDesc.fixedRotation		= b;
	RFootDesc.fixedRotation		= b;
	LUpperArmDesc.fixedRotation	= b;
	RUpperArmDesc.fixedRotation	= b;
	LForearmDesc.fixedRotation	= b;
	RForearmDesc.fixedRotation	= b;
}

void CBipedDesc::humanVertices()
{
	// head
	HeadCirc.radius = c_scale * 12.0f;

	// chest
	ChestPoly.vertexCount = 5;
	ChestPoly.vertices[0] = c_scale * Point2D_Int(6,-18);
	ChestPoly.vertices[1] = c_scale * Point2D_Int(18,-9);
	ChestPoly.vertices[2] = c_scale * Point2D_Int(14,50);
	ChestPoly.vertices[3] = c_scale * Point2D_Int(-7,50);
	ChestPoly.vertices[4] = c_scale * Point2D_Int(-7,-7);

	// thighs
	LThighPoly.vertexCount = RThighPoly.vertexCount = 5;
	LThighPoly.vertices[0] = RThighPoly.vertices[0] = c_scale * Point2D_Int(-9,0);
	LThighPoly.vertices[1] = RThighPoly.vertices[1] = c_scale * Point2D_Int(9,0);
	LThighPoly.vertices[2] = RThighPoly.vertices[2] = c_scale * Point2D_Int(7,36);
	LThighPoly.vertices[3] = RThighPoly.vertices[3] = c_scale * Point2D_Int(-6,36);
	LThighPoly.vertices[4] = RThighPoly.vertices[4] = c_scale * Point2D_Int(-11,7);

	// calves
	LCalfPoly.vertexCount = RCalfPoly.vertexCount = 4;
	LCalfPoly.vertices[0] = RCalfPoly.vertices[0] = c_scale * Point2D_Int(-7,0);
	LCalfPoly.vertices[1] = RCalfPoly.vertices[1] = c_scale * Point2D_Int(7,0);
	LCalfPoly.vertices[2] = RCalfPoly.vertices[2] = c_scale * Point2D_Int(1,37);
	LCalfPoly.vertices[3] = RCalfPoly.vertices[3] = c_scale * Point2D_Int(-7,37);

	// feet
	LFootPoly.vertexCount = RFootPoly.vertexCount = 5;
	LFootPoly.vertices[0] = RFootPoly.vertices[0] = c_scale * Point2D_Int(-4,0);
	LFootPoly.vertices[1] = RFootPoly.vertices[1] = c_scale * Point2D_Int(4,0);
	LFootPoly.vertices[2] = RFootPoly.vertices[2] = c_scale * Point2D_Int(16,3);
	LFootPoly.vertices[3] = RFootPoly.vertices[3] = c_scale * Point2D_Int(16,7);
	LFootPoly.vertices[4] = RFootPoly.vertices[4] = c_scale * Point2D_Int(-4,6);

	// upper arms
	LUpperArmPoly.vertexCount = RUpperArmPoly.vertexCount = 5;
	LUpperArmPoly.vertices[0] = RUpperArmPoly.vertices[0] = c_scale * Point2D_Int(-6,0);
	LUpperArmPoly.vertices[1] = RUpperArmPoly.vertices[1] = c_scale * Point2D_Int(6,0);
	LUpperArmPoly.vertices[2] = RUpperArmPoly.vertices[2] = c_scale * Point2D_Int(6,25);
	LUpperArmPoly.vertices[3] = RUpperArmPoly.vertices[3] = c_scale * Point2D_Int(-4,25);
	LUpperArmPoly.vertices[4] = RUpperArmPoly.vertices[4] = c_scale * Point2D_Int(-6,8);

	// forearms
	LForearmPoly.vertexCount = RForearmPoly.vertexCount = 4;
	LForearmPoly.vertices[0] = RForearmPoly.vertices[0] = c_scale * Point2D_Int(-5,0);
	LForearmPoly.vertices[1] = RForearmPoly.vertices[1] = c_scale * Point2D_Int(4,0);
	LForearmPoly.vertices[2] = RForearmPoly.vertices[2] = c_scale * Point2D_Int(6,26);
	LForearmPoly.vertices[3] = RForearmPoly.vertices[3] = c_scale * Point2D_Int(1,26);
}
void CBipedDesc::humanPositions()
{
	setPosition(0,0);
}
void CBipedDesc::humanJoints()
{
	// head and chest
	NeckDesc.localAnchor1	= c_scale * Point2D_Int(-5,-8);
	NeckDesc.localAnchor2	= c_scale * Point2D_Int(12,-13);
	NeckDesc.referenceAngle	= 0.0f;
	NeckDesc.lowerAngle		= 1.04719755f;
	NeckDesc.upperAngle		= 2.61799388f;

	// hips
	LHipDesc.localAnchor1	= RHipDesc.localAnchor1		= c_scale * Point2D_Int(2,44);
	LHipDesc.localAnchor2	= RHipDesc.localAnchor2		= c_scale * Point2D_Int(0,0);
	LHipDesc.referenceAngle	= RHipDesc.referenceAngle	= 0.0f;
	LHipDesc.lowerAngle		= RHipDesc.lowerAngle		= -2.26892803f;
	LHipDesc.upperAngle		= RHipDesc.upperAngle		= 0;

	// knees
	LKneeDesc.localAnchor1		= RKneeDesc.localAnchor1	= c_scale * Point2D_Int(0,36);
	LKneeDesc.localAnchor2		= RKneeDesc.localAnchor2	= c_scale * Point2D_Int(0,0);
	LKneeDesc.referenceAngle	= RKneeDesc.referenceAngle	= 0.0f;
	LKneeDesc.lowerAngle		= RKneeDesc.lowerAngle		= 0;
	LKneeDesc.upperAngle		= RKneeDesc.upperAngle		= 2.61799388f;

	// ankles
	LAnkleDesc.localAnchor1		= RAnkleDesc.localAnchor1	= c_scale * Point2D_Int(-3,35);
	LAnkleDesc.localAnchor2		= RAnkleDesc.localAnchor2	= c_scale * Point2D_Int(0,0);
	LAnkleDesc.referenceAngle	= RAnkleDesc.referenceAngle	= 0.0f;
	LAnkleDesc.lowerAngle		= RAnkleDesc.lowerAngle		= -0.523598776f;
	LAnkleDesc.upperAngle		= RAnkleDesc.upperAngle		= 0.523598776f;

	// shoulders
	LShoulderDesc.localAnchor1		= RShoulderDesc.localAnchor1	= c_scale * Point2D_Int(0,0);
	LShoulderDesc.localAnchor2		= RShoulderDesc.localAnchor2	= c_scale * Point2D_Int(0,0);
	LShoulderDesc.referenceAngle	= RShoulderDesc.referenceAngle	= 0.0f;
	LShoulderDesc.lowerAngle		= RShoulderDesc.lowerAngle		= -3.14159265f;
	LShoulderDesc.upperAngle		= RShoulderDesc.upperAngle		= 1.04719755f;

	// elbows
	LElbowDesc.localAnchor1		= RElbowDesc.localAnchor1	= c_scale * Point2D_Int(1,25);
	LElbowDesc.localAnchor2		= RElbowDesc.localAnchor2	= c_scale * Point2D_Int(0,0);
	LElbowDesc.referenceAngle	= RElbowDesc.referenceAngle	= 0.0f;
	LElbowDesc.lowerAngle		= RElbowDesc.lowerAngle		= -2.7925268f;
	LElbowDesc.upperAngle		= RElbowDesc.upperAngle		= 0;
}

void CBipedDesc::alienVertices()
{
	// head
	HeadCirc.radius = c_scale * 13.0f;

	// chest
	ChestPoly.vertexCount = 6;
	ChestPoly.vertices[0] = c_scale * Point2D_Int(-1,-13);
	ChestPoly.vertices[1] = c_scale * Point2D_Int(5,-3);
	ChestPoly.vertices[2] = c_scale * Point2D_Int(3,41);
	ChestPoly.vertices[3] = c_scale * Point2D_Int(-5,41);
	ChestPoly.vertices[4] = c_scale * Point2D_Int(-9,11);
	ChestPoly.vertices[5] = c_scale * Point2D_Int(-9,-4);

	// thighs
	LThighPoly.vertexCount = RThighPoly.vertexCount = 5;
	LThighPoly.vertices[0] = RThighPoly.vertices[0] = c_scale * Point2D_Int(-5,0);
	LThighPoly.vertices[1] = RThighPoly.vertices[1] = c_scale * Point2D_Int(3,0);
	LThighPoly.vertices[2] = RThighPoly.vertices[2] = c_scale * Point2D_Int(-4,38);
	LThighPoly.vertices[3] = RThighPoly.vertices[3] = c_scale * Point2D_Int(-8,38);
	LThighPoly.vertices[4] = RThighPoly.vertices[4] = c_scale * Point2D_Int(-9,30);

	// calves
	LCalfPoly.vertexCount = RCalfPoly.vertexCount = 4;
	LCalfPoly.vertices[0] = RCalfPoly.vertices[0] = c_scale * Point2D_Int(-3,0);
	LCalfPoly.vertices[1] = RCalfPoly.vertices[1] = c_scale * Point2D_Int(4,0);
	LCalfPoly.vertices[2] = RCalfPoly.vertices[2] = c_scale * Point2D_Int(5,35);
	LCalfPoly.vertices[3] = RCalfPoly.vertices[3] = c_scale * Point2D_Int(0,35);

	// feet
	LFootPoly.vertexCount = RFootPoly.vertexCount = 4;
	LFootPoly.vertices[0] = RFootPoly.vertices[0] = c_scale * Point2D_Int(-4,-2);
	LFootPoly.vertices[1] = RFootPoly.vertices[1] = c_scale * Point2D_Int(3,-2);
	LFootPoly.vertices[2] = RFootPoly.vertices[2] = c_scale * Point2D_Int(3,3);
	LFootPoly.vertices[3] = RFootPoly.vertices[3] = c_scale * Point2D_Int(-14,3);

	// upper arms
	LUpperArmPoly.vertexCount = RUpperArmPoly.vertexCount = 4;
	LUpperArmPoly.vertices[0] = RUpperArmPoly.vertices[0] = c_scale * Point2D_Int(-3,0);
	LUpperArmPoly.vertices[1] = RUpperArmPoly.vertices[1] = c_scale * Point2D_Int(3,0);
	LUpperArmPoly.vertices[2] = RUpperArmPoly.vertices[2] = c_scale * Point2D_Int(4,28);
	LUpperArmPoly.vertices[3] = RUpperArmPoly.vertices[3] = c_scale * Point2D_Int(2,29);

	// forearms
	LForearmPoly.vertexCount = RForearmPoly.vertexCount = 5;
	LForearmPoly.vertices[0] = RForearmPoly.vertices[0] = c_scale * Point2D_Int(-3,0);
	LForearmPoly.vertices[1] = RForearmPoly.vertices[1] = c_scale * Point2D_Int(2,0);
	LForearmPoly.vertices[2] = RForearmPoly.vertices[2] = c_scale * Point2D_Int(-5,33);
	LForearmPoly.vertices[3] = RForearmPoly.vertices[3] = c_scale * Point2D_Int(-8,32);
	LForearmPoly.vertices[4] = RForearmPoly.vertices[4] = c_scale * Point2D_Int(-8,16);
}
void CBipedDesc::alienPositions()
{
	setPosition(0,0);
}
void CBipedDesc::alienJoints()
{
	// head and chest
	NeckDesc.localAnchor1	= c_scale * Point2D_Int(9,9);
	NeckDesc.localAnchor2	= c_scale * Point2D_Int(-1,-13);
	NeckDesc.referenceAngle	= 0.0f;
	NeckDesc.lowerAngle		= 0;
	NeckDesc.upperAngle		= 0.62831853f;

	// hips
	LHipDesc.localAnchor1	= RHipDesc.localAnchor1		= c_scale * Point2D_Int(0,36);
	LHipDesc.localAnchor2	= RHipDesc.localAnchor2		= c_scale * Point2D_Int(0,0);
	LHipDesc.referenceAngle	= RHipDesc.referenceAngle	= 0.0f;
	LHipDesc.lowerAngle		= RHipDesc.lowerAngle		= -2.26892803f;
	LHipDesc.upperAngle		= RHipDesc.upperAngle		= 0;

	// knees
	LKneeDesc.localAnchor1		= RKneeDesc.localAnchor1	= c_scale * Point2D_Int(-6,38);
	LKneeDesc.localAnchor2		= RKneeDesc.localAnchor2	= c_scale * Point2D_Int(0,0);
	LKneeDesc.referenceAngle	= RKneeDesc.referenceAngle	= 0.0f;
	LKneeDesc.lowerAngle		= RKneeDesc.lowerAngle		= -2.61799388f;
	LKneeDesc.upperAngle		= RKneeDesc.upperAngle		= 0;

	// ankles
	LAnkleDesc.localAnchor1		= RAnkleDesc.localAnchor1	= c_scale * Point2D_Int(3,36);
	LAnkleDesc.localAnchor2		= RAnkleDesc.localAnchor2	= c_scale * Point2D_Int(0,0);
	LAnkleDesc.referenceAngle	= RAnkleDesc.referenceAngle	= 0.0f;
	LAnkleDesc.lowerAngle		= RAnkleDesc.lowerAngle		= -0.523598776f;
	LAnkleDesc.upperAngle		= RAnkleDesc.upperAngle		= 0.523598776f;

	// shoulders
	LShoulderDesc.localAnchor1		= RShoulderDesc.localAnchor1	= c_scale * Point2D_Int(0,0);
	LShoulderDesc.localAnchor2		= RShoulderDesc.localAnchor2	= c_scale * Point2D_Int(0,0);
	LShoulderDesc.referenceAngle	= RShoulderDesc.referenceAngle	= 0.0f;
	LShoulderDesc.lowerAngle		= RShoulderDesc.lowerAngle		= -1.04719755f;
	LShoulderDesc.upperAngle		= RShoulderDesc.upperAngle		= 3.14159265f;

	// elbows
	LElbowDesc.localAnchor1		= RElbowDesc.localAnchor1	= c_scale * Point2D_Int(3,30);
	LElbowDesc.localAnchor2		= RElbowDesc.localAnchor2	= c_scale * Point2D_Int(0,0);
	LElbowDesc.referenceAngle	= RElbowDesc.referenceAngle	= 0.0f;
	LElbowDesc.lowerAngle		= RElbowDesc.lowerAngle		= 0;
	LElbowDesc.upperAngle		= RElbowDesc.upperAngle		= 2.7925268f;
}

// setuping shapes
void CBipedDesc::setHead(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &HeadShape);
	assert(HeadShape);
	HeadShape->SetShape(&HeadCirc);
}
void CBipedDesc::setChest(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &ChestShape);
	assert(ChestShape);
	ChestShape->SetShape(&ChestPoly);
}
void CBipedDesc::setLThigh(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &LThighShape);
	assert(LThighShape);
	LThighShape->SetShape(&LThighPoly);
}
void CBipedDesc::setRThigh(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &RThighShape);
	assert(RThighShape);
	RThighShape->SetShape(&RThighPoly);
}
void CBipedDesc::setLCalf(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &LCalfShape);
	assert(LCalfShape);
	LCalfShape->SetShape(&LCalfPoly);
}
void CBipedDesc::setRCalf(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &RCalfShape);
	assert(RCalfShape);
	RCalfShape->SetShape(&RCalfPoly);
}
void CBipedDesc::setLFoot(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &LFootShape);
	assert(LFootShape);
	LFootShape->SetShape(&LFootPoly);
}
void CBipedDesc::setRFoot(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &RFootShape);
	assert(RFootShape);
	RFootShape->SetShape(&RFootPoly);
}
void CBipedDesc::setLUpperArm(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &LUpperArmShape);
	assert(LUpperArmShape);
	LUpperArmShape->SetShape(&LUpperArmPoly);
}
void CBipedDesc::setRUpperArm(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &RUpperArmShape);
	assert(RUpperArmShape);
	RUpperArmShape->SetShape(&RUpperArmPoly);
}
void CBipedDesc::setLForearm(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &LForearmShape);
	assert(LForearmShape);
	LForearmShape->SetShape(&LForearmPoly);
}
void CBipedDesc::setRForearm(IN _2D::IObject *obj)
{
	assert(obj);
	obj->QueryInterface(_2D::IID_IObject, (void **) &RForearmShape);
	assert(RForearmShape);
	RForearmShape->SetShape(&RForearmPoly);
}