#ifndef _BIPED_H_INCLUDED_
#define _BIPED_H_INCLUDED_

#if defined(_MSC_VER) && (_MSC_VER > 1000)
#pragma once
#endif	/* _MSC_VER > 1000 */

#include <DPE_Application_Include.h>

#include <assert.h>
#include <string>

#include "biped desc.h"

#define SAFE_FREE(p) {if (NULL != p) {p->Free(); p->Release(); p = NULL;}}

class CBiped
{
public:
	CBiped(IManager2D *man, CBipedDesc *desc, const Point2D_Int &position);
	virtual ~CBiped();

	static CBiped *Create(IManager2D *man, CBipedDesc *desc, const Point2D_Int &position)
	{
		return new CBiped(man, desc, position);
	}
public:
	void setPosition(const Point2D_Int &pos);
	void setMassFromShapes();
	void ApplyImp(float imp);
	void getPosition(Point2D_Int &pos);
private:
	CBipedDesc			*descr;
	IBody				*Head, *Chest, *Pelvis, *LThigh, *RThigh,
						*LFoot, *RFoot, *LCalf, *RCalf,
						*LUpperArm, *RUpperArm, *LForearm, *RForearm;

	IRevoluteJoint		*Neck, *LHip, *RHip, *LKnee, *RKnee, *LAnkle, *RAnkle, 						
						*LShoulder, *RShoulder, *LElbow, *RElbow;

	std::string	mName;
};


#endif	/* _BIPED_H_INCLUDED_ */