#include "boss.h"
#include "Game.h"

int CBoss::_counter = 0;

CBoss::CBoss( const char *name,IEngineCore *core):
	mCore(NULL),	
	mMan2d(NULL),
	mResMan(NULL)
{
	mCore = core;
	assert(mCore);
	mCore->AddRef();

	IManagersFactory *pSceneManFact = NULL;
	core->PluginByType(reinterpret_cast<ICommonPlugin **>(&pSceneManFact),Pl_SCENES);
	assert(pSceneManFact);
	pSceneManFact->GetResourceManager(mResMan);
	assert(mResMan);
	pSceneManFact->GetManager2D(mMan2d);
	assert(mMan2d);

	mMan2d->CreateSprite((String(name)+IntToStr(++_counter)).c_str(),pBossSprite);
	pBossSprite->SetTexture("tex_boss");
	pBossSprite->SetZOrder(800);
	angle = 0;
	back_ang = false;
}

CBoss::~CBoss()
{
	// system
	if (mCore) mCore->Release();
	if (mMan2d) mMan2d->Release();
	if (mResMan) mResMan->Release();
}

void CBoss::setPosition(const Point2D_Int &pos)
{
	position = pos;
	pBossSprite->SetPosition(position);	
}

void CBoss::update()
{
	if (!back_ang)
	{
		angle= angle+0.05;
		position.x--;
		position.y=position.y-2;
	}
	else
	{
		angle= angle-0.05;
		position.x++;
		position.y=position.y+2;
	}

	if (angle > 1) back_ang = true;
	if (angle < 0) back_ang = false;

	//pBossSprite->SetAngle(angle);
	setPosition(position);	
}