#include <windows.h>

#include <DPE_Application_Include.h>
#include <DPE_CPP_Include.h>

#include "Game.h"

#define SCR_WIDTH  800
#define SCR_HEIGHT 600
#define GAME_UPDATE_RATE 33

IEngineCore *engine_core = NULL;

game *pGame = NULL;

extern "C" int (CALLBACK *pCreateEngine)(IEngineCore **ppv) = NULL;
HMODULE hServer = NULL;

//--------------------------------------------------------------------------------------------------
void Init()
{
	pGame = new game(engine_core,SCR_WIDTH,SCR_HEIGHT);
	#ifndef _DEBUG
	pGame->scene(LOGO);
	#else
	pGame->scene(GAME);
	#endif
}
void Free()
{
	if (pGame!=NULL) delete pGame;
}
void Process()
{
	if (pGame!=NULL) pGame->process();
}
void Render()
{
	if (pGame!=NULL) pGame->render();
}
//--------------------------------------------------------------------------------------------------
int GetEngine(IEngineCore **ppv)
{
	if(hServer == NULL)
	{
		#ifndef _DEBUG
		hServer = ::LoadLibraryA(std::string("DeeProEngine.dll").c_str());
		#else
		hServer = ::LoadLibraryA(std::string("..\\..\\release\\DeeProEngine.dll").c_str());
		//hServer = ::LoadLibraryA(std::string("..\\..\\..\\DeeProEngine\\bin\\Core.dll").c_str());
		#endif

		if(hServer == NULL) 
		{
			MessageBoxA(NULL,"Couldn't load \"DeeProEngine.dll\"!","FatalError!",MB_ICONERROR);
			return -1;
		}
	}

	if(pCreateEngine == NULL)
	{
		pCreateEngine = reinterpret_cast<int (CALLBACK *)(IEngineCore **)>
			(::GetProcAddress(hServer,("GetEngine")));
		if(pCreateEngine == NULL) 
		{
			MessageBoxA(NULL,"Corrupted or wrong \"DeeProEngine.dll\"!","FatalError!",MB_ICONERROR);
			return -1;
		}
	}

	return (*pCreateEngine)(ppv);
}
//--------------------------------------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	if (GetEngine(&engine_core)==-1)
		return 1;
	
	#ifdef _DEBUG
	TEngWindow wnd = {SCR_WIDTH,SCR_HEIGHT,32,false,false,1};
	#else
	TEngWindow wnd = {SCR_WIDTH,SCR_HEIGHT,32,false,true,1};
	#endif
	
	engine_core->AddProcedure(PROC_INIT, &Init);
	engine_core->AddProcedure(PROC_FREE, &Free);
	engine_core->AddProcedure(PROC_PROCESS, &Process);
	engine_core->AddProcedure(PROC_RENDER, &Render);

	
  if (SUCCEEDED(engine_core->InitializeEngine(NULL,"Invaders Must Die", wnd, GAME_UPDATE_RATE, "", ELT_HTML)))
  {
		#ifdef _DEBUG
		engine_core->Con_Visible(true);
		engine_core->Con_Exec("fps_in_caption 1");
		#endif

		engine_core->StartEngine();
		engine_core->Release();
	}

	return 0;
}
