#ifndef AppCoreH
#define AppCoreH

#include <Windows.h>
#include <DPE_Application_Include.h>
#include "imdmap.h"
#include <System.hpp>
#include <SysUtils.hpp>

class AppCore
{
private:

	static AppCore 		*_pInstance;
	HMODULE 			_hServer;
	ILog 				*_log;
	bool				_dev;

	IEngineCore 		*_pEngineCore;
	ICoreRenderer		*_pCoreRenderer;

	IManagersFactory	*_pFactory;
	IResourceManager	*_pResMan;

	TEngWindow 			_wind;
	HWND				_handle;

	imdmap 				*_gamemap;

	void _render();
	void _process();
	void _init();
	void _free();

	static void (AppCore::*p_render)();
	static void (AppCore::*p_process)();
	static void (AppCore::*p_init)();
	static void (AppCore::*p_free)();


	static void Render();
	static void Process();
	static void Init();
	static void Free();

	void wndproc(IEvent *pEvent);

public:

	imdmap* map();
	void resetmap();

	AppCore(HWND rendertarget, bool developer);
	~AppCore();

};

#endif
