#include "imdmap.h"
#include <SysUtils.hpp>

inline char* DATA_PATH(String resource)
{
	if (FileExists("..\\release\\data.zip"))
	return String("..\\release\\data.zip|"+resource).t_str();
	else
	return String("..\\release\\data\\"+resource).t_str();
}

imdmap::imdmap(IEngineCore *engcore)
{
	_pEngineCore = engcore;

	_pEngineCore->FileSystem(&_pFS);
	_pEngineCore->PluginByType((ICommonPlugin**)&_pFactory,Pl_SCENES);
	_pFactory->GetResourceManager(_pResMan);
	_pEngineCore->PluginByType((ICommonPlugin**)&_pCoreRenderer,Pl_RENDER);

	_loadobjectsdb();
	_loadtextures();

	CameraX = 0;
	CameraY = 0;
	_header.count = 0;
	_header.color1 = 0;
	_header.color2 = 0;
	_pEngineCore->Con_Write("Map created.");
}

void imdmap::_drawobj(TMapObj __obj)
{
   if(!__obj.ispoly)
   {
	 if(obj_base[__obj.idx].special!=-1)
	 {
		ICoreRenderer::_2D_VERTEX v[2];
		v[0].x = __obj.XCoord[0] + CameraX;
		v[0].y = __obj.YCoord[0] + CameraY;
		v[0].r = v[0].g = v[0].b = v[0].a = 1.f;
		v[1] = v[0];
	   String txt;
	   switch (obj_base[__obj.idx].special)
	   {
		   case 0: txt = "";
		   v[1].x+=50;
		   v[1].y+=100;
		   break;
		   case 1: txt = "";
		   v[1].x+=50;
		   v[1].y+=100;
		   break;
		   case 2: txt = " ";
		   v[1].x+=50;
		   v[1].y+=100;
		   break;
		   case 3: txt = "";
		   v[1].x+=100;
		   v[1].y+=50;
		   break;
		   case 4: txt = "";
		   v[1].x+=50;
		   v[1].y+=100;
		   break;
		   case 5: txt = "";
		   v[1].x+=25;
		   v[1].y+=25;
		   break;
		   case 6: txt = "";
		   v[1].x+=25;
		   v[1].y+=25;
		   break;
		   case 7: txt = "";
		   v[1].x+=25;
		   v[1].y+=25;
		   break;
	   }
	   _pCoreRenderer->DrawRect(v);
	   _pCoreRenderer->DrawTextA(__obj.XCoord[0] + CameraX,__obj.YCoord[0] + CameraY-15,1.0,0.0,0.0,1.0,txt.t_str());
	 }
	 else
	 {
	  int _cx, _cy;
	  switch(__obj.ground)
	  {
		  case 0:
		  _cx = CameraX/2;
		  _cy = CameraY/2;
		  break;
		  case 1:
		  _cx = CameraX;
		  _cy = CameraY;
		  break;
		  case 2:
		  _cx = CameraX*2;
		  _cy = CameraY*2;
		  break;
	  }
	  textures[__obj.idx]->Draw(Point2D_Int(__obj.XCoord[0] + _cx,__obj.YCoord[0] + _cy),Dimension2D_UInt(Point2D_Int(__obj.w,__obj.h)));
	 }
   }
   else
   {
	  //
   }
}

void imdmap::loadmap(char* filename)
{
  IFile *file;
  _pFS->GetFile(DATA_PATH("maps\\"+String(filename)),&file,(FS_OPEN_FLAGS)(FS_READ | FS_BINARY));

  unsigned int read;

  file->Read((void*)&_header,sizeof(TMapHeader),read);

  map.clear();

  for (int i = 0; i < _header.count; i++)
  {
  TMapObj t;
  file->Read((void*)&t,sizeof(TMapObj),read);
  map.push_back(t);
  }

  file->Release();

  CameraX = 0;
  CameraY = 0;
  _pEngineCore->Con_Write(("Map \""+String(filename)+"\" loaded.").t_str());
}

void imdmap::savemap(char* filename)
{
 /*
   int cur_idx = 0;
   TMapObj _t;

   for(int i = 0; i<map.size(); i++)
	   if(map[i].ground==0)
	   {
		   _t = map[cur_idx];
		   map[cur_idx] = map[i];
		   map[i]=_t;
		   cur_idx++;
	   }

   for(int i = cur_idx; i<map.size(); i++)
	   if(map[i].ground==1)
	   {
		   _t = map[cur_idx];
		   map[cur_idx] = map[i];
		   map[i]=_t;
		   cur_idx++;
	   }

	for(int i = cur_idx; i<map.size(); i++)
	   if(map[i].ground==2)
	   {
		   _t = map[cur_idx];
		   map[cur_idx] = map[i];
		   map[i]=_t;
		   cur_idx++;
	   }
  */
   IFile *file;
   _pFS->GetFile(DATA_PATH("maps\\"+String(filename)),&file,(FS_OPEN_FLAGS)(FS_WRITE | FS_BINARY | FS_TRUNK));

   unsigned int written;

   _header.count = map.size();

   file->Write((void*)&_header,sizeof(TMapHeader),written);

   for (int i = 0; i < map.size(); i++)
	file->Write((void*)&map[i],sizeof(TMapObj),written);

   file->Release();
   _pEngineCore->Con_Write(("Map \""+String(filename)+"\" saved.").t_str());
}

void imdmap::DrawMap()
{
  ICoreRenderer::_2D_VERTEX v[2];
  v[0].y = v[0].x = 0;
  v[0].a = 1.f;
  v[0].r = (float)255/GetRValue(_header.color1);
  v[0].g = (float)255/GetGValue(_header.color1);
  v[0].b = (float)255/GetBValue(_header.color1);

  v[1].x = 800;
  v[1].y = 600;
  v[1].a = 1.f;
  v[1].r = (float)255/GetRValue(_header.color2);
  v[1].g = (float)255/GetGValue(_header.color2);
  v[1].b = (float)255/GetBValue(_header.color2);

  _pCoreRenderer->DrawRect(v);

  if (map.size()>0)
  {

	for(int i=0; i<map.size(); i++)
	if(map[i].ground == 0)  _drawobj(map[i]);
	if (mouseobj.ground==0) _drawobj(mouseobj);

	for(int i=0; i<map.size(); i++)
	if(map[i].ground == 1)  _drawobj(map[i]);
	if (mouseobj.ground==1) _drawobj(mouseobj);

	for(int i=0; i<map.size(); i++)
	if(map[i].ground == 2)  _drawobj(map[i]);
	if (mouseobj.ground==2) _drawobj(mouseobj);

  } else _drawobj(mouseobj);
}

void imdmap::AddToMapCurObj()
{
   map.push_back(mouseobj);
}

imdmap::~imdmap()
{
	_saveobjectsdb();
	_freetextures();
	_pCoreRenderer->Release();
	_pFS->Release();
	_pResMan->Release();
	_pFactory->Release();
_pEngineCore->Con_Write("Map deleted.");
}

void imdmap::DeleteMapObj(int x, int y)
{
	if(map.size()>0)
	{
	  for(int i = map.size()-1; i>=0; i--)
	  {
		int _cx, _cy;
		switch(map[i].ground)
		{
		  case 0:
		  _cx = CameraX/2;
		  _cy = CameraY/2;
		  break;
		  case 1:
		  _cx = CameraX;
		  _cy = CameraY;
		  break;
		  case 2:
		  _cx = CameraX*2;
		  _cy = CameraY*2;
		  break;
		}
		  if(Rect2D_Int(map[i].XCoord[0]+_cx,map[i].YCoord[0]+_cy,map[i].XCoord[0]+_cx+map[i].w,map[i].YCoord[0]+_cy+map[i].h).pointInside(Point2D_Int(x,y)))
		  {
			mouseobj = map[i];
			map.erase(map.begin()+i);
			_pEngineCore->Con_Write(("Object \""+IntToStr(i)+"\" deleted.").t_str());
			break;
		  }
	  }
	}
}

void imdmap::deletefrombase(int idx)
{
obj_base.erase(obj_base.begin()+idx);
ITexture* t = textures[idx];
if(t)t->Release();
textures.erase(textures.begin()+idx);
_pEngineCore->Con_Write(("Object \""+IntToStr(idx)+"\" deleted from obj_base.").t_str());
}

void imdmap::addtobase(TDB_Obj obj)
{
   _pResMan->Load(DATA_PATH(String("map_objects\\"+String(obj.tex_name))),obj.tex_name);
   ITexture *t;
   _pResMan->GetTexture(obj.tex_name,t);
   textures.push_back(t);
   obj_base.push_back(obj);
   _pEngineCore->Con_Write(("Object \""+String(obj.name)+"\" added to obj_base.").t_str());
}

void imdmap::_loadtextures()
{
if(obj_base.size()>0)
  for (int i = 0; i < obj_base.size(); i++)
  if(strlen(obj_base[i].tex_name)==0)
  {
	textures.push_back(NULL);
  }
  else
  {
	  _pResMan->Load(DATA_PATH(String("map_objects\\"+String(obj_base[i].tex_name))),obj_base[i].tex_name);
	  ITexture *t;
	  _pResMan->GetTexture(obj_base[i].tex_name,t);
	  textures.push_back(t);
  }

_pEngineCore->Con_Write("All textures loaded.");
}

void imdmap::_freetextures()
{
  if(textures.size()>0)
  for (int i = 0; i < textures.size(); i++)
  if(textures[i]!=NULL) textures[i]->Release();
  _pResMan->FreeAll(DOT_TEXTURE);
_pEngineCore->Con_Write("All textures freed.");
}

void imdmap::_saveobjectsdb()
{
	 IFile *file;
	 _pFS->GetFile(DATA_PATH("mobjects.db"),&file,(FS_OPEN_FLAGS)(FS_WRITE | FS_BINARY | FS_TRUNK));

	 unsigned int written;

	 int count = obj_base.size();
	 file->Write((void*)&count,sizeof(int),written);

	 for (int i = 0; i < obj_base.size(); i++)
		file->Write((void*)&obj_base[i],sizeof(TDB_Obj),written);

	file->Release();
_pEngineCore->Con_Write("obj_base saved to \"mobjects.db\".");
}

void imdmap::_loadobjectsdb()
{
	 obj_base.clear();

	 TDB_Obj _t;
	 strcpy(_t.name,"");
	 _t.special = 0;
	 strcpy(_t.tex_name,"");
	 _t.width  = 50;
	 _t.height = 100;
	 for (int i = 0; i < 8; i++) {
	 _t.borderX[i] = 0;
	 _t.borderY[i] = 0;
	 }
	 _t.isstatic = true;
	 _t.ispassable = true;
	 _t.ispoly = false;
	 _t.density = 1.0f;

	 obj_base.push_back(_t);

	 strcpy(_t.name,"");
	 _t.special = 1;
	 obj_base.push_back(_t);

	 strcpy(_t.name," ");
	 _t.special = 2;
	 obj_base.push_back(_t);

	 _t.width  = 100;
	 _t.height = 50;

	 strcpy(_t.name,"");
	 _t.special = 3;
	 obj_base.push_back(_t);

	 _t.width  = 25;
	 _t.height = 25;

	 strcpy(_t.name,"");
	 _t.special = 4;
	 obj_base.push_back(_t);

	 strcpy(_t.name,"");
	 _t.special = 5;
	 obj_base.push_back(_t);

	 strcpy(_t.name,"");
	 _t.special = 6;
	 obj_base.push_back(_t);

	 strcpy(_t.name,"");
	 _t.special = 7;
	 obj_base.push_back(_t);

	 if (FAILED(_pFS->FileExists(DATA_PATH("mobjects.db"))))
		return;

	 IFile *file;
	 _pFS->GetFile(DATA_PATH("mobjects.db"),&file);

	 obj_base.clear();

	 unsigned int read;
	 int count;

	 file->Read((void*)&count,sizeof(int),read);

	 for (int i = 0; i < count; i++)
	 {
		file->Read((void*)&_t,sizeof(TDB_Obj),read);
		obj_base.push_back(_t);
	 }

	 file->Release();
_pEngineCore->Con_Write("obj_base loaded.");
}
