#ifndef imdmapH
#define imdmapH

#include <DPE_Application_Include.h>
#include <vector>
using namespace std;

#define GetRValue(rgb)      (LOBYTE(rgb))
#define GetGValue(rgb)      (LOBYTE(((WORD)(rgb)) >> 8))
#define GetBValue(rgb)      (LOBYTE((rgb)>>16))

struct TDB_Obj
{
	char name[64];
	int  special; //-1 for non special, 0 - player respawn, 2 - enemy ... e.t.c.
	char tex_name[64];
	int width;
	int height;
	int borderX[8];
	int borderY[8];
	bool isstatic;
	bool ispassable;
	bool ispoly;
	float density;
};

struct TMapObj
{
	int idx;
	int ground;
	int XCoord[8];
	int YCoord[8];
	int w;
	int h;
	bool isstatic;
	bool ispassable;
	bool ispoly;
	float density;
};

struct TMapHeader
{
	int color1;
	int color2;
	int count;
};

class imdmap
{
private:

	IEngineCore 		*_pEngineCore;
	IFileSystem			*_pFS;

	IManagersFactory	*_pFactory;
	IResourceManager	*_pResMan;
    ICoreRenderer       *_pCoreRenderer;

	void _loadobjectsdb();
	void _saveobjectsdb();
	void _loadtextures();
	void _freetextures();
	void _drawobj(TMapObj obj);

public:

	TMapHeader _header;

	vector<TMapObj>   map;
	vector<TDB_Obj>   obj_base;
	vector<ITexture*> textures;

	TMapObj mouseobj;
	int CameraX, CameraY;
	void DrawMap();

	void AddToMapCurObj();
	void DeleteMapObj(int x, int y);

	void addtobase(TDB_Obj obj);
	void deletefrombase(int idx);

	void loadmap(char* filename);
	void savemap(char* filename);

	imdmap(IEngineCore *engcore);
	~imdmap();

};

#endif
