unit DBossOnOff;

interface

uses
  DUtils,
  DGraph,
  DCore,
  DGame,
  DMap,
  DMath;


type
  TCourse = (Left, Right, Bottom, Top);

type
  TTentacle = object
  private
    FTentacle: array [0..4] of TEnemy;
    FCourse: TCourse;
    FTime: Integer;
  public
    procedure Create(Pos: TVec2f; Course: TCourse);
    procedure Render;
    procedure Update;
  end;

type
  TBossOnOff = class(TEnemy)
  protected
    procedure Stream; override;
    FBody: array [0..7] of TEnemy;
    Ftentacles: array [0..14] of TTentacle;
  public
    constructor Create(Pos: TVec2f);
    procedure Update; override;
    procedure Render; override;
  end;


const
  GreenColor: TVec4f = (x: 0.03; y: 0.8; z: 0.2; w: 1.0);
  RedColor: TVec4f = (x: 0.6; y: 0.17; z: 0.17; w: 1.0);
  

implementation

procedure TBossOnOff.Stream;
begin
  inherited;
  // :      
end;

constructor TBossOnOff.Create(Pos: TVec2f);
var
  I: Byte;
begin
  inherited Create;
  FHalf := Vec2f(15, 15);
  Self.Pos := Pos;
  FHP := 100; // 
  // :         ( Enemy.Damage(...)).     1.
  for I := 0 to 7 do
  begin
    FBody[I] := TSimpleEnemy.Create;
    FBody[I].Color := GreenColor;
    FBody[I].Pos := Vec2f(sin(I * pi / 4), cos(I * pi / 4)) * 35 + Pos;
  end;
end;

procedure TBossOnOff.Update;
begin
end;

procedure TBossOnOff.Render;
var
  I: Byte;
begin
  for I := 0 to 7 do
    FBody[I].Render;
end;

procedure TTentacle.Create(Pos: TVec2f; Course: TCourse);
var
  I: Byte;
begin
  for I := 0 to 4 do
  begin
    FTentacle[I] := TSimpleEnemy.Create;
    FTentacle[I].Pos := Pos;
	  
  end;
end;

procedure TTentacle.Render;
var
  I: Byte;
begin
  for I := 0 to 4 do
    FTentacle[I].Render;	  
end;

procedure TTentacle.Update;
begin

end;

initialization 
  Factory.Regist(TBossOnOff);
end.
