{$MACRO ON}
{$WARNINGS OFF}
unit DLevel2;

interface

uses
  DMath,
  DGraph,
  DLevelData,
  DEnemy,
  DCore,
  DMap,
  DGame,
  DWeapon;

{$DEFINE T64 := IsTile: True; Tile: (x:64; y:64)}
{$DEFINE T128 := IsTile: True; Tile: (x:128; y:128)}

{$DEFINE CBLACK := Color: (x:0; y:0; z:0; w:1)}

const
  KP1 = 1300;
  KP2 = 2000;
  KP3 = 3000;
  KP4 = 5000;

  Name = 'level2';
  Music = 'music1.xm';
  NextLevel = 'level2';
  Heap = 'DATA\tiles\Heap.bit';
  Center: TRect = (A:(x: 200; y: 250); B:(x: 440; y:400));
  //Player: TVec2f = (x:KP2; y:300);
  Player: TVec2f = (x:20; y:400);
  Sky1: TVec4f = (x:72/255; y:178/255; z:129/255; w:1.0);
  Sky2: TVec4f = (x:26/255; y:92/255;  z:89/255;  w:1.0);

  L2B = 'DATA\Tiles\Lines2Brown.tga';
  RG = 'DATA\Tiles\RombGreen.tga';
  //Black: TVec4f = (x:0; y:0; z:0; w:1);
  //t64: TVec2f = (x:64; y:64);

  Blocks: array[0..1-1] of TBlockData = (
      (Tex:L2B; Rect:(A:(x:-10e+6; y:-10e+6);B:(x:-10e+6; y:-10e+6)); T64; 
        Blend:bmNo; CBLACK; Speed: 0){, 
       (Tex:L2B; Rect:(A:(x:90; y:320);B:(x:380; y:520)); T64; 
        Blend:bmNo; CBLACK; Speed: 0), 
       (Tex:L2B; Rect:(A:(x:0; y:450);B:(x:640; y:520)); T64; 
        Blend:bmNo; CBLACK; Speed: 0), 
       (Tex:L2B; Rect:(A:(x:320; y:400);B:(x:640; y:520)); T64; 
        Blend:bmNo; CBLACK; Speed: 0), 

       (Tex:L2B; Rect:(A:(x:700; y:420);B:(x:1000; y:520)); T64; 
        Blend:bmNo; CBLACK; Speed: 1.0; Pos2: (x: 700; y: 40))}
  );

  Entries: array[0..5-1] of TEntryData = (
      (Rect:(A:(x:KP3; y:-1000);B:(x:KP3+300; y:200)); Name: 'epic';
        _Type:etJump2Pattern; Pattern:164),
        //(Rect:(A:(x:90-8; y:320-128);B:(x:90+128; y:320)); Name: 'DATA\textures\TreeWhite.bit'; _Type:etTex),

        (Rect:(A:(x:KP2+400; y:40);B:(x:KP2+528; y:168)); Name: 'DATA\textures\CycleKoh.bit'; _Type:etTex; Blend: bmAlpha), //  , KP2
        (Rect:(A:(x:KP2+90; y:320-128);B:(x:KP2+90+128; y:320)); Name: 'DATA\textures\LowTree.bit'; _Type:etTex; Blend: bmAlpha), // KP2, 
        (Rect:(A:(x:KP2+90; y:320-32);B:(x:KP2+90+32; y:320)); Name: 'DATA\textures\wheel.bit'; _Type:etTex; Blend: bmAlpha), // Lab
        (Rect:(A:(x:KP1+250-64; y:270-128);B:(x:KP1+250+64; y:270)); Name: 'DATA\textures\HighTree.bit'; _Type:etTex; Blend: bmAlpha)

        {(Rect:(A:(x:300-128; y:60-127);B:(x:300; y:60)); Name: 'DATA\textures\Bush.bit'; _Type:etTex),
        (Rect:(A:(x:300+128; y:60-127);B:(x:300+2*128; y:60)); Name: 'DATA\textures\Plant.bit'; _Type:etTex),
        (Rect:(A:(x:300+2*128; y:60-127);B:(x:300+3*128; y:60)); Name: 'DATA\textures\WeedRect.bit'; _Type:etTex),
        (Rect:(A:(x:300+3*128; y:60-127);B:(x:300+4*128; y:60)); Name: 'DATA\fonts\FixedSys.bit'; _Type:etTex)}

        //(Rect:(A:(x:0; y:0);B:(x:640; y:480)); Name: ''; _Type:etTag; Tag: 'respawn1')
        //(Rect:(A:(x:0; y:0);B:(x:640; y:480)); Name: 'respawn1'; _Type:etRespawn)
    ); 

// :   -  !      .
procedure Load;

implementation

function HighTree(X, Y: Single): TEntry;
begin
  Result := TEntryTexture.Create(Game.Map, 'DATA\textures\HighTree.bit', Rect(Vec2f(X-64, Y-128), Vec2f(X+64, Y)), bmAlpha, Vec4f(0.6, 0.9, 0.6, 1.0)); 
end;

function Tree(X, Y: Single): TEntry;
begin
  Result := TEntryTexture.Create(Game.Map, 'DATA\textures\TreeWhite.bit', Rect(Vec2f(X-64, Y-128), Vec2f(X+64, Y)), bmAlpha, Vec4f(0.6, 0.9, 0.6, 1.0)); 
end;

function LowTree(X, Y: Single): TEntry;
begin
  Result := TEntryTexture.Create(Game.Map, 'DATA\textures\LowTree.bit', Rect(Vec2f(X-64, Y-128), Vec2f(X+64, Y)), bmAlpha, Vec4f(0.6, 0.9, 0.6, 1.0)); 
end;

function Block1(X1, Y1, X2, Y2: Single): TBlock;
begin
  with Result do begin
    Tex := Core.Graph.LoadTex(RG);
    Rect := DMath.Rect(Vec2f(X1, Y1), Vec2f(X2, Y2));
    Tile := Vec2f(32, 32);
    Blend := bmNo;
    Color := Vec4f(0.5, 1, 0, 1);
    Speed := 0;
  end;
end;

function Block2(X1, Y1, X2, Y2: Single): TBlock;
begin
  with Result do begin
    Tex := Core.Graph.LoadTex('DATA\tiles\CellGreen.tga');
    Rect := DMath.Rect(Vec2f(X1, Y1), Vec2f(X2, Y2));
    Tile := Vec2f(16, 16);
    Blend := bmNo;
    Color := Vec4f(0.5, 1, 0, 1);
    Speed := 0;
  end;
end;

function Lift(X1, Y1, X2, Y2: Single; Finish: TVec2f): TBlock;
begin
  with Result do begin
    Tex := Core.Graph.LoadTex('DATA\Tiles\CellCross1.tga');
    Rect := DMath.Rect(Vec2f(X1, Y1), Vec2f(X2, Y2));
    Tile := Vec2f(64, 64);
    Blend := bmDiffuse;
    Color := Vec4f(0.5, 1, 0, 1);
    Speed := 240/(Y1 - Finish.Y);
    Pos1 := Vec2f(X1, Y1);
    Pos2 := Finish;
  end;
end;

procedure AddWeapon(X, Y: Single; W: CWeapon);
  var
    Item: TWeaponItem;
begin
  Item := TWeaponItem.Create(W);
  Item.Pos := Vec2f(X, Y);
  Game.AddItem(Item);
end;

function ToColumn(X, Y: Single): TVec2f;
begin
  Result.X := KP2 + X*80;
  Result.Y := 440 - Y*80;
end;

procedure Column1(A, B, Y: Single);
begin
  Game.Map.AddBlock(Block1(KP2 + A*80, 440 - Y*80, KP2 + B*80, 2000));
end;

procedure Column2(A, B, Y: Single);
begin
  Game.Map.AddBlock(Block2(KP2 + A*80, 440 - Y*80, KP2 + B*80, 2000));
end;

procedure ColumnLift(X, A, B: Single);
begin
  X := KP2 + X*80;
  A := 440 - A*80;
  B := 440 - B*80;
  Game.Map.AddBlock(Lift(X - 64*3, A - 1.5*64, X, A, Vec2f(X - 64*3, B)));
end;

procedure Load;
  var
    Pos: TVec2f;
    I: Integer;
begin
  //Game.Map.AddEntry(Tree(-128, 180-128)); // 0
  //Game.Map.AddEntry(HighTree(KP1+250-64, 270128)); // KP1
  //Game.Map.AddEntry(Tree(KP1+100-64, 350-128)); // 1 
  //Game.Map.AddEntry(LowTree(KP2+90, 320-128)); // KP2
  {
  Game.Map.AddEntry(TEntryText.Create(Vec2f(440, 120), Vec2f(1, 1), 
                    Vec4f(0.8, 0.4, 0.8, 1), '')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(440, 152), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), '. : 1')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(440, 184), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), '. : 2')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(440, 216), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), 'Help: 3')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP2+300, 120), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), ':')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP3, 120), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), '')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP3, 152), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1), ' ;)')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP3, 184), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1),  '  ')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP3, 216), Vec2f(1, 1), 
                    Vec4f(0.6, 0.9, 0.6, 1),  '.')); // KP2}
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP1 - 350, 350), Vec2f(0.5, 4), 
                    Vec4f(0.8, 0.4, 0.8, 1), '')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP1 - 350, 350), Vec2f(0.5, 3), 
                    Vec4f(0.8, 0.4, 0.8, 1), '')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP1 - 350, 350), Vec2f(0.5, 2), 
                    Vec4f(0.8, 0.4, 0.8, 1), '')); // KP2
  Game.Map.AddEntry(TEntryText.Create(Vec2f(KP1 - 350, 350), Vec2f(0.5, 1), 
                    Vec4f(0.8, 0.4, 0.8, 1), '')); // KP2
  Game.Map.AddEntry(TEntrySave.Create(Game.Map,  KP1-200, 200, 'saved01'));
  //Game.Map.AddEntry(TEntrySave.Create(Game.Map, KP3+1000-128, -128, 'saved02'));
  //Game.Map.AddEntry(TEntryJump2Pattern.Create(Game.Map, 'epic', Rect(Vec2f(KP3, -1000), Vec2f(KP3+300, 200)), 162));
  {Game.Map.AddEntry(TEntryRespawnRect.Create('respG', Vec2f(KP3+1500, -36),
                                             Vec2f(-15, 0),
                                             20, 1));
  Game.Map.AddEntry(TEntryTag.Create(Game.Map, 'respGtag', 
                                     Rect(Vec2f(KP3+300, -400), Vec2f(KP3+600, 0)),
                                     'respG'));}
  {Game.Map.AddEntry(TEntryMusic.Create('DATA\music\boss0.xm', 
                                   Rect(Vec2f(KP3+1010, -1000), 
                                        Vec2f(10000, 1000))));}
  {Game.Map.AddEntry(TEntryBossDoj.Create(Game.Map, 'boss', 
                                         Rect(Vec2f(KP3+1500, -500),
                                              Vec2f(KP3+1500, -500))));
  Game.Map.AddEntry(TEntryTag.Create(Game.Map, 'bosstag', 
                                     Rect(Vec2f(KP3+1010, -1000), 
                                          Vec2f(10000, 1000)),
                                     'boss'));}

  //  
  Column2( 7, 14, 19);
  Column1( 2,  8, 18);
  Column2(16, 18, 18);
  
      Game.Map.AddEntry(TEntryWheelRespawn.Create('w1', Rect(ToColumn(7.8, 24), ToColumn(7.8, 24)), Game.Map.BlocksCount, Vec2f(-5, 5)));

  Column1( 7,  9, 17);
  Column2(11, 18, 16);
  Column2( 5,  8, 16);
  Column1( 4,  7, 15);
  Column2( 3, 12, 14);


  //  
  Column2( 2,  4, 11);

      Game.Map.AddEntry(TEntryWheelRespawn.Create('w1', Rect(ToColumn(10, 12), ToColumn(10, 10)), Game.Map.BlocksCount, Vec2f(5, 5)));
      Game.Map.AddEntry(TEntryWheelRespawn.Create('w1', Rect(ToColumn(10, 12), ToColumn(6, 12)), Game.Map.BlocksCount, Vec2f(5, 5)));
      Game.Map.AddEntry(TEntryWheelRespawn.Create('w1', Rect(ToColumn(10, 12), ToColumn(10, 12)), Game.Map.BlocksCount, Vec2f(-5, 5)));

  Column2( 2,  9,  9);

  Column1( 7, 13,  8);
  Column2( 0,  5,  7);
  
      Game.Map.AddEntry(TEntryTimer.Create(2000, 'w1'));

  Column2( 8, 12,  7);
  Column1( 4, 10,  6);
  Column2( 9, 11,  5);
  Column1( 2,  8,  4);
  Column2( 1,  7,  3);

        //Game.AddEnemy(TWheel.Create(ToColumn(10, 12), Game.Map.BlocksCount));

  Game.Map.AddBlock(Block1(KP1-200, 200,  KP1-200+128, 200+1000)); // 1  
  Game.Map.AddBlock(Block1(KP1+100,   270, KP1+400, 520)); // 1    

  Column1( 6, 18,  2);
  Column2( 3,  8,  1);

  ColumnLift(1.8, 9, 14);

  Game.Map.AddBlock(Block1(KP1,       350, KP1+200, 520)); // 1 
  AddWeapon(KP1-380, 400-30, TPinkWeapon);
  AddWeapon(KP1-310, 400-30, TPinkWeapon);
  AddWeapon(ToColumn(0.1, 6.9).X, ToColumn(0.1, 7.1).Y, TShotGun);
  AddWeapon(ToColumn(3.1, 14.9).X, ToColumn(3.1, 14.9).Y, TLaser);
  //AddWeapon(KP4-150, 320, TSimpleWeapon);

  Game.Map.AddBlock(Block1(0,         440, 10000,   520)); // 
 // Game.AddEnemy(TWheel.Create(Vec2f(100, 100), 1000));
  //Game.Map.AddBlock(Block1(KP1+700+320,   400, KP1+700+640, 520));
  Game.Map.AddBlock(Block1(KP1-450,       400, KP1-250,     460)); //  
  Game.Map.AddBlock(Block1(-640,      100, 0,       600)); //   
  Game.Map.AddBlock(Block1(-640,      0, 0,       520)); //   
  Game.Map.AddEntry(TEntryTexture.Create(Game.Map, 'DATA\textures\Lab.bit', Rect(ToColumn(5, 13), ToColumn(5, 13) + Vec2f(256, 256)), bmAlpha, Vec4f(0.6, 0.9, 0.6, 1.0)));

  Pos := ToColumn( 9, 19); Game.Map.AddEntry(LowTree(Pos.X, Pos.Y));
  Pos := ToColumn(13, 19); Game.Map.AddEntry(Tree(Pos.X, Pos.Y));
  Pos := ToColumn( 4, 18); Game.Map.AddEntry(Tree(Pos.X, Pos.Y));
  Pos := ToColumn( 8, 17); Game.Map.AddEntry(HighTree(Pos.X, Pos.Y));
  Pos := ToColumn( 6, 16); Game.Map.AddEntry(HighTree(Pos.X, Pos.Y));
  Pos := ToColumn(12, 16); Game.Map.AddEntry(LowTree(Pos.X, Pos.Y));
  Pos := ToColumn( 5, 15); Game.Map.AddEntry(HighTree(Pos.X, Pos.Y));
  Pos := ToColumn( 4,  9); Game.Map.AddEntry(LowTree(Pos.X, Pos.Y));
  Pos := ToColumn( 8,  8); Game.Map.AddEntry(LowTree(Pos.X, Pos.Y));
  Pos := ToColumn(11,  8); Game.Map.AddEntry(Tree(Pos.X, Pos.Y));
  Pos := ToColumn( 1,  7); Game.Map.AddEntry(Tree(Pos.X, Pos.Y));
  Pos := ToColumn(5.5, 6); Game.Map.AddEntry(LowTree(Pos.X, Pos.Y));
  Pos := ToColumn(10,  5); Game.Map.AddEntry(HighTree(Pos.X, Pos.Y));
  Pos := ToColumn( 6,  4); Game.Map.AddEntry(Tree(Pos.X, Pos.Y));
  Pos := ToColumn( 3,  3); Game.Map.AddEntry(LowTree(Pos.X, Pos.Y));
  Pos := ToColumn( 9,  2); Game.Map.AddEntry(Tree(Pos.X, Pos.Y));
  Pos := ToColumn( 5,  1); Game.Map.AddEntry(LowTree(Pos.X, Pos.Y));

  Game.Map.AddEntry(TEntryRespawnRect.Create('resp1', Vec2f(90, 20), Vec2f(0, 5), 20, 1));
  Game.Map.AddEntry(TEntryTimer.Create(2000, 'resp1'));

  //Game.AddEnemy(TEnemyTexture.Create(Vec2f(100, 440), 'DATA\textures\wheel.bit', Vec4f(0.8, 0.2, 0.2, 1.0)));
  for I := 0 to 11 do begin
    Game.AddEnemy(TEnemyTexture.Create(ToColumn(13+I*8/20, 2), 
                  'DATA\textures\bayonet.bit', Vec4f(0.8, 0.2, 0.2, 1.0)));
    Game.AddEnemy(TEnemyTexture.Create(ToColumn(13+I*8/20, 0), 
                  'DATA\textures\bayonet.bit', Vec4f(0.8, 0.2, 0.2, 1.0)));
  end;

  Pos := ToColumn(2.1, 10.8);
  Game.Map.AddEntry(TEntrySave.Create(Game.Map,  Pos.X, Pos.Y, 'saved01'));
  Pos := ToColumn(16.1, 17.8);
  Game.Map.AddEntry(TEntrySave.Create(Game.Map,  Pos.X, Pos.Y, 'saved02'));
  Pos := ToColumn(16.1, 30);
  Game.Map.AddEntry(TEntryTotalWin.Create(Game.Map, '', Rect(Pos, Pos + Vec2f(500, 500))));
end;

end.
