uses
  DUtils,
  ResImage,
  ResBMP;

var
  I, J: Integer;

  Data: TData;
  Image: TImage;
  Loader: TBmpLoader;
  B: Byte;

begin
  if ParamCount < 2 then begin
    Writeln('bmp2tga <input> <output>');
    Writeln('input must be bmp file');
    Exit;
  end;
  Loader := TBMPLoader.Create(nil);
  Data := TData.Create(ParamStr(1));
  Image := TImage(Loader.Load(ParamStr(1), Data));
  if Image = nil then begin
    Writeln('input must be bmp file');
  end else begin
    Data.Clear;
    Data.WriteInt(Image.Width);
    Data.WriteInt(Image.Height);
    Data.WriteInt(0);
    if Image.BitsPerPixel = 3 then
      {for J := 0 to Header.Height - 1 do 
        for I := 0 to Header.Width - 1 do 
          with Data, Image do begin
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*3 + 2]);
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*3 + 1]);
            WriteByte(PArrayOfBytes(Texels)[(J*Width + I)*3 + 0]);
            WriteByte(255);
          end}
      for I := 0 to Image.Width*Image.Height div 8 - 1 do 
        with Data, Image do begin
          B := 0;
          for J := 0 to 7 do
            B := B or (Ord(PArrayOfBytes(Texels)[(I*8+J)*3 + 2] > 254) shl J);
          WriteByte(B);
        end
    else 
      for I := 0 to Image.Width*Image.Height div 8 do 
        with Data, Image do begin
          B := 0;
          for J := 0 to 7 do
            B := B or (Ord(PArrayOfBytes(Texels)[(I+J)*4 + 2] > 254) shl J);
          WriteByte(B);
        end;
    Data.WriteToFile(ParamStr(2));
  end;
  Data.Free; 
  Loader.Free;
end.
