﻿package elm.core {
	import elm.core.*;
	import flash.display.*;
	import flash.utils.getDefinitionByName;
	
	public class Gfx {
		//public static var root:MovieClip;
		private static var clip:Layer;
		//public static var Width:Number;
		//public static var Height:Number;
		
		//private static var autoLayer:Array;
		
		public static function init(clip:Layer):void {
			//Gfx.root = PreloaderClass.clip;
			Gfx.clip = clip;
			//Width = clip.stage.stageWidth;
			//Height = clip.stage.stageHeight;
			//autoLayer = [];
			Log.Message("elm.core.Gfx inited. ("+Width+"x"+Height+")");
		}
		public static function createLayer(parent:Layer, name:String, depth:uint, auto:Boolean = true):Layer {
			if(!parent) {
				//if(auto) autoLayer.push(name);
				parent = Game.getState() as Layer;
				if (!parent) {
					Log.Message("Create system layer '"+name+"'.");
					parent = clip;
				}
			}
			var m:Layer = new Layer();
			m.name = name;
			var d:uint = parent.depthLayer.length;
			for(var i:uint = 0; i < parent.depthLayer.length; i++) {
				if(parent.depthLayer[i] >= depth) {
					d = i;
					break;
				}
			}
			if(auto) parent.autoLayer.push(name);
			parent.depthLayer.splice(d, 0, depth);
			return parent.addChildAt(m, d) as Layer;
		}
		public static function getLayerByName(parent:Layer, name:String):Layer {
			if(!parent) parent = Game.getState() as Layer;
			return parent.getChildByName(name) as Layer;
		}
		public static function removeLayer(parent:Layer, layer:Layer) {
			if (!parent) parent = Game.getState() as Layer;
			var index:int = parent.autoLayer.indexOf(layer.name);
			if (index >= 0) parent.autoLayer.splice(index, 1);
			index = parent.getChildIndex(layer);
			if(index >= 0) {
				parent.depthLayer.splice(index, 1);
				parent.removeChildAt(index);
			}
		}
		/*public static function removeLayerByName(parent:Layer, name:String) {
			if(!parent) parent = clip;
			var layer:Layer = parent.getChildByName(name) as Layer;
			parent.removeChild(layer);
		}*/
		public static function freeLayers(name:String = null) {
			var state:State = Game.getState(name);
			var layer:Layer;
			var index:int;
			for(var i:Number = 0; i < state.autoLayer.length; i++) {
				layer = state.getChildByName(state.autoLayer[i]) as Layer;
				index = state.getChildIndex(layer);
				if(index >= 0) {
					state.depthLayer.splice(index, 1);
					state.removeChildAt(index);
				}
			}
			state.autoLayer = [];
		}
		public static function createMovie(layer:Layer, idName:String, name:String, obj:Object = null):DisplayObject {
			if (!layer) layer = Game.getState() as Layer;
			var classDefintion:Class = Game.getClassByName(idName);
			if(classDefintion) {
				var instance = new classDefintion();
				for(var key in obj) instance[key] = obj[key];
				layer.addChild(instance);
				instance.name = name;
				return instance as DisplayObject;
			} else {
				return null;
			}
		}
		public static function addMovie(layer:Layer, movie:DisplayObject, name:String = null, obj:Object = null):DisplayObject {
			if(!movie) return null;
			if(!layer) layer = Game.getState() as Layer;
			for(var key in obj) movie[key] = obj[key];
			layer.addChild(movie);
			if(name) movie.name = name;
			return movie;
		}
		public static function makeMovie(idName:String, name:String, obj:Object = null):DisplayObject {
			var classDefintion:Class = Game.getClassByName(idName);
			if(classDefintion) {
				var instance = new classDefintion();
				for (var key in obj) instance[key] = obj[key];
				instance.name = name;
				return instance as DisplayObject;
			} else {
				return null;
			}
		}
		public static function removeMovieByName(layer:Layer, name:String):void {
			if(!layer) layer = Game.getState() as Layer;
			removeMovie(layer, layer.getChildByName(name));
		}
		public static function removeMovie(layer:Layer, movie:DisplayObject):void {
			if (!movie) return;
			if(!layer) layer = Game.getState() as Layer;
			layer.removeChild(movie);
		}
		/*public static function removeMovieA(movie:DisplayObject):void {
			var layer:DisplayObject = movie.parent as DisplayObject;
			layer.removeChild(movie);
		}*/
		public static function getMovie(layer:Layer, name:String):DisplayObject {
			return layer.getChildByName(name) as DisplayObject;
		}
		public static function createText(layer:Layer, name:String, x:Number, y:Number, w:Number, h:Number, obj:Object, filters:Array):Text {
			if(!layer) layer = Game.getState() as Layer;
			var t:Text = new Text(x, y, w, h, obj);
			t.name = name;
			if(filters) t.filters = filters;
			layer.addChild(t);
			return t;
		}
		public static function setText(layer:Layer, name:String, str:String):void {
			if(!layer) layer = Game.getState() as Layer;
			var t:Text = layer.getChildByName(name) as Text;
			if(t) t.text = str;
		}
		public static function getText(layer:Layer, name:String):String {
			if(!layer) layer = Game.getState() as Layer;
			var t:Text = layer.getChildByName(name) as Text;
			if(t) return t.text;
			else return "";
		}
		public static function get Width():Number { return clip.stage.stageWidth; }
		public static function get Height():Number { return clip.stage.stageHeight; }
	}
	
	// end package
}
