﻿package elm.game {
	import Box2D.Common.Math.*;
	import elm.core.*;
	import elm.types.*;
	import elm.utils.*;
	
	public class Camera2D {
		private var layer:Layer;
		private var width:Number;
		private var height:Number;
		private var screen_width_half:Number;
		private var screen_height_half:Number;
		private var speed:Number;
		private var pos:Vec2;
		private var pos_d:Vec2;
		
		public function Camera2D(l:Layer, w:Number, h:Number, s:Number) {
			layer = l;
			width = w;
			height = h;
			speed = s;
			screen_width_half = Game.Width / 2;
			screen_height_half = Game.Height / 2;
			pos = new Vec2();
			pos_d = new Vec2();
		}
		public function Set(x:Number, y:Number):void {
			pos_d.Set(x, y);
			pos.Set(x, y);
		}
		public function SetV(v:b2Vec2):void {
			pos_d.SetV(v);
			pos.SetV(v);
		}
		public function Move(x:Number, y:Number):void {
			pos_d.Set(x, y);
		}
		public function MoveV(v:b2Vec2):void {
			pos_d.SetV(v);
		}
		public function Update(delta:Number):void {
			pos.MoveTo(speed * delta, pos_d, true);
			if (pos.x < screen_width_half) pos.x = screen_width_half;
			if (pos.x > width - screen_width_half) pos.x = width - screen_width_half;
			if (pos.y < screen_height_half) pos.y = screen_height_half;
			if (pos.y > height - screen_height_half) pos.y = height - screen_height_half;
			if (layer) {
				layer.x = -(pos.x-screen_width_half);
				layer.y = -(pos.y-screen_height_half);
			} else {
				trace("Error: Layer not found.");
			}
		}
	}
}