package elm.input {
	import elm.core.*;
	import flash.events.*;

	public class InputDispatcher extends EventDispatcher {	
		private var keymap:Array;
	
		public function InputDispatcher() {
			keymap = [];
		}
		
		public function init():void {
			Game.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			Game.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			Game.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
			Game.addEventListener(KeyboardEvent.KEY_UP, onKeyUp);
		}
		public function free():void {
			Game.removeEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
			Game.removeEventListener(MouseEvent.MOUSE_UP, onMouseUp);
			Game.removeEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
			Game.removeEventListener(KeyboardEvent.KEY_UP, onKeyUp);
			
			keymap = null;
		}
		
		public function add(name:String, key:Array = null):void {
			keymap.push({name:name, key:key, pressed:false});
		}
		public function remove(name:String):void {
			for(var i:int = 0; i < keymap.length; i++) {
				if(keymap[i].name == name) {
					keymap.splice(i, 1);
					return;
				}
			}
		}
		
		public function frame():void {
		}
		public function onMouseDown(e:MouseEvent):void {
			for(var i:int = 0; i < keymap.length; i++) {
				if (!keymap[i].pressed) {
					var is_mouse:Boolean = false;
					if (!keymap[i].key || keymap[i].key.length == 0) is_mouse = true;
					else {
						for (var j:int = 0; j < keymap[i].key.length; j++) {
							if(keymap[i].key[j] == -1) {
								is_mouse = true;
							}
						}
					}
					if (is_mouse) {
						keymap[i].pressed = true;
						dispatchEvent(new InputEvent(keymap[i].name, true));
						return;
					}
				}
			}
		}
		public function onMouseUp(e:MouseEvent):void {
			for(var i:int = 0; i < keymap.length; i++) {
				if (keymap[i].pressed) {
					var is_mouse:Boolean = false;
					if (!keymap[i].key || keymap[i].key.length == 0) is_mouse = true;
					else {
						for (var j:int = 0; j < keymap[i].key.length; j++) {
							if(keymap[i].key[j] == -1) {
								is_mouse = true;
							}
						}
					}
					if (is_mouse) {
						keymap[i].pressed = false;
						dispatchEvent(new InputEvent(keymap[i].name, false));
						return;
					}
				}
			}
		}
		public function onKeyDown(e:KeyboardEvent):void {
			for (var i:int = 0; i < keymap.length; i++) {
				if (!keymap[i].key) continue;
				if (!keymap[i].pressed) {
					for (var j:int = 0; j < keymap[i].key.length; j++) {
						if(keymap[i].key[j] == e.keyCode) {
							keymap[i].pressed = true;
							dispatchEvent(new InputEvent(keymap[i].name, true));
							return;
						}
					}
				}
			}
		}
		public function onKeyUp(e:KeyboardEvent):void {
			for (var i:int = 0; i < keymap.length; i++) {
				if (!keymap[i].key) continue;
				if (keymap[i].pressed) {
					for (var j:int = 0; j < keymap[i].key.length; j++) {
						if(keymap[i].key[j] == e.keyCode) {
							keymap[i].pressed = false;
							dispatchEvent(new InputEvent(keymap[i].name, false));
							return;
						}
					}
				}
			}
		}
	}
}