﻿package elm.state {
	import elm.core.*;
	import elm.gfx.*;
	import flash.events.*;
	import flash.display.*;
	import flash.media.*;
	import flash.filters.*;
	
	public class Fader extends State {
		private var attr:Object;
			
		public function Fader() {
		}
		override public function init(attr:* = null):Boolean {
			if(!attr) attr = {};
			if(!attr.color) attr.color = 0x000000;
			if(!attr.alpha) attr.alpha = 0;
			if(!attr.state) attr.state = "mainmenu";
			if(!attr.attr) attr.attr = null;
			
			this.attr = attr;
			alpha = attr.alpha;
			
			graphics.clear();
			graphics.beginFill(attr.color, 1);
			graphics.drawRect(0, 0, Game.Width, Game.Height);
			
			Log.Message("Fader init.");
			return true;
		}
		override public function free():void {
			Log.Message("Fader free.");
		}
		override public function frame():void {
			Game.setState(attr.state, Game.MODE_BACK, attr.attr);
		}
		override public function onMouseClick(e:MouseEvent):void {
		}
		override public function onKeyDown(e:KeyboardEvent):void {
		}
		override public function isShow():Boolean {
			alpha += Game.delta;
			if (alpha >= 1) {
				alpha = 1;
				return true;
			}
			return false;
		}
		override public function isHide():Boolean {
			alpha -= Game.delta;
			if (alpha <= 0) {
				alpha = 0;
				return true;
			}
			return false;
		}
		public static function start(state:String, color:int = 0xFFFFFF, alpha:Number = 0, attr:Object = null, fader:String = "fader"):void {
			Game.setState(fader, Game.MODE_FRONT, {color:color, alpha:alpha, state:state, attr:attr});
		}
	}
}