﻿package elm.types {
	import Box2D.Common.Math.b2Vec2;
	import flash.geom.Point;
	
	public class Vec2 extends b2Vec2 {
		public function Vec2(x:Number = 0, y:Number = 0) {
			super(x, y);
		}
		public function Is(v:b2Vec2):Boolean {
			return (x == v.x && y == v.y);
		}
		override public function Copy():b2Vec2 {
			return new Vec2(x, y);
		}
		public function SetA(length:Number, angle:Number):void {
			x = 0; y = 0; Move(length, angle);
		}
		public function SetP(p:Point):void {
			x = p.x; y = p.y;
		}
		public function Move(dist:Number, angle:Number) {
			var a:Number = Math.PI / 180 * angle;
			x = x + Math.sin(a) * dist;
			y = y - Math.cos(a) * dist;
		}
		public function MoveTo(dist:Number, to:Vec2, is_stop:Boolean = true):void {
			if(is_stop) {
				var dst:Number = DistanceTo(to);
				if(dst < dist) {
					x = to.x; y = to.y;
				} else {
					Move(dist, AngleTo(to));
				}
			} else {
				Move(dist, AngleTo(to));
			}
		}
		public function AngleTo(v:b2Vec2):Number {
			if(x == v.x && y == v.y) return 0;
			var angle:Number = Math.atan((v.y - y) / (v.x - x)) * 180 / Math.PI;
			if(v.x >= x)
				return angle + 90;
			else
				return angle - 90;
		}
		public function Angle():Number {
			var v:Vec2 = new Vec2();
			return v.AngleTo(this);
		}
		public function DistanceTo(v:b2Vec2):Number {
			return Math.sqrt((v.x - x) * (v.x - x) + (v.y - y) * (v.y - y));
		}
	}
}