﻿package elm.utils {
	public class Angle {
		public static function approach(val:Number, a:Number, a_to:Number):Number { // a1 - begin, a2 - end
			var tmp:Number = a - a_to;
			if(tmp > 0) {
				if(tmp < val) {
					return normal(a_to);
				} else {
					if(tmp < 180) {
						return normal(a - val);
					} else {
						return normal(a + val);
					}
				}
			} else if(tmp < 0) {
				tmp = -tmp;
				if(tmp < val) {
					return normal(a_to);
				} else {
					if(tmp < 180) {
						return normal(a + val);
					} else {
						return normal(a - val);
					}
				}
			} else
				return normal(a_to);
		}
		public static function approachRad(val:Number, a:Number, a_to:Number):Number {
			var tmp:Number = a - a_to;
			if(tmp > 0) {
				if(tmp < val) {
					return normal(a_to);
				} else {
					if(tmp < Math.PI) {
						return normalRad(a - val);
					} else {
						return normalRad(a + val);
					}
				}
			} else if(tmp < 0) {
				tmp = -tmp;
				if(tmp < val) {
					return normalRad(a_to);
				} else {
					if(tmp < Math.PI) {
						return normalRad(a + val);
					} else {
						return normalRad(a - val);
					}
				}
			} else
				return normal(a_to);
		}
		public static function normal(a:Number):Number {
			if(a >= 360) return a-360;
			else if(a < 0) return a+360;
			return a;
		}
		public static function normalRad(a:Number):Number {
			if (a >= Math.PI * 2) return a - Math.PI * 2;
			else if (a < 0) return a + Math.PI * 2;
			return a;
		}
		public static function delta(a1:Number, a2:Number):Number {
			var tmp:Number = normal(a2) - normal(a1);
			if (tmp > 0) {
				if(tmp > 180)
					tmp = 360 - tmp;
			} else if (tmp < 0) {
				if(tmp < -180)
					tmp = 360 + tmp;
			} else
				tmp = 0;
			return tmp;
		}
		static public function toRad(deg:Number):Number {
			return Math.PI / 180 * deg;
		}
		static public function toDeg(rad:Number):Number {
			return rad / Math.PI * 180;
		}
	}
}