package game {
	import game.actor.*;
	import game.actor.player.*;
	import game.actor.enemies.*;
	import game.actor.bullets.*;
	import game.actor.powerups.*;
	import game.actor.triggers.*;
	import game.actor.boxes.*;
	import game.room.entity.*;
	
	public class EntityClassMap {
		
		private static var map:Object;
		
		{
			map = {};

			// ACTORS
			map["Actor"] = Actor;
			map["Player"] = PlayerActor;
			map["Larva"] = Larva;
			
			// ENEMIES
			map["Enemy"] = Enemy;
			map["Larva"] = Larva;
			map["EnemyPost"] = EnemyPost;
			map["Tank"] = Tank;
			map["Grenadir"] = Grenadir;
			map["Boss"] = Boss;
			
			// POWERUPS
			map["HealthRecharge"] = HealthRecharge;
			map["Life"] = Life;
			map["GunPistol"] = GunPistol;
			map["GunRocket"] = GunRocket;
			map["GunGrenade"] = GunGrenade;
			map["GunAutomatic"] = GunAutomatic;
			
			// BULLETS
			map["Bullet"] = Bullet;
			map["PistolBullet"] = PistolBullet;
			map["RocketBullet"] = RocketBullet;
			map["GrenadeBullet"] = GrenadeBullet;
			map["AutomaticBullet"] = AutomaticBullet;
			map["LarvaBullet"] = LarvaBullet;
			map["SoldierBullet"] = SoldierBullet;
			map["TankBullet"] = TankBullet;
			map["BossBullet"] = BossBullet;
			
			// TRIGGERS
			map["PortalTrigger"] = PortalTrigger;
			
			// BOXES
			map["Box"] = Box;
			
			// ROOM ENTITIES
			map["Entity"] = Entity;
			map["Ladder"] = Ladder;
			map["Platform"] = Platform;
			map["SolidPlatform"] = SolidPlatform;
		}
		
		public static function getEntityClass(name:String):Class {
			if (map[name]) return map[name];
			return null;
		}
	}
	
}