package game.actor {
	import Box2D.Collision.b2ContactPoint;
	import Box2D.Collision.Shapes.b2Shape;
	import Box2D.Dynamics.*;
	import Box2D.Dynamics.Contacts.b2ContactResult;
	import elm.gfx.Animation;
	import flash.display.DisplayObject;
	import physic.*;
	import game.*;
	import game.room.entity.*;

	public class Actor extends Entity implements ContactRecipient, PhysicRecipient {
		
		ManagerAccess var is_alive:Boolean = true;
		ManagerAccess var is_die_quietly:Boolean = true;
		protected var body:b2Body = null;
		protected var o:Animation = null;
		protected var ani:String = null;
		protected var actor_manager:ActorManager = null;
		
		// game data
		public var health:Number = 1;
		public var is_gravity:Boolean = true;
		public var is_ground:Boolean = false;
		public var is_fall_through_platforms:Boolean = false;

		public function Actor(attrIn:Object) {
			super(attrIn);
			o = attr.o;
			if (o) o.stop();
		}
		public override function free():void {
			if (o) {
				o.alpha = 0;
				o = null;
			}
			body = null;
			actor_manager = null;
			
			super.free();
		}		
		public function update(delta:Number):void {
			if (o && ani) {
				o.Update(ani, delta);
			}
		}
		public function render():void {
			if (body && o) {
				o.x = body.GetPosition().x;
				o.y = body.GetPosition().y;
			}
		}
		
		public function isAlive():Boolean {
			use namespace ManagerAccess;
			return is_alive;
		}
		public function die(quietly:Boolean = true):void {
			use namespace ManagerAccess;
			if (!is_alive) return;
			is_die_quietly = quietly;
			dispatchEvent(new ActorEvent(this, ActorEvent.DEATH));
		}
		public function onDeath():void {
		}
		public override function getVisualObject():DisplayObject {
			return o;
		}
		
		public function setActorManager(actorManagerIn:ActorManager):void {
			actor_manager = actorManagerIn;
		}
		
		public function getBodyDef():b2BodyDef {
			return null;
		}
		public function setBody(bodyIn:b2Body):void {
			body = bodyIn;
			// add shape <
		}
		public function getBody():b2Body {
			return body;
		}
		public function onContactUpdate(shape:b2Shape, reverse:int, contactPoint:b2ContactPoint):void {
			// super.onContactUpdate(shape, contactPoint);
		}
		public function onContactRemove(shape:b2Shape, reverse:int, contactPoint:b2ContactPoint):void {
			// super.onContactRemove(shape, contactPoint);
		}
		public function onContactResult(shape:b2Shape, reverse:int, contactResult:b2ContactResult):void {
			// super.onContactResult(shape, contactResult);
		}
	}
}
