﻿package game.actor 
{
	import elm.game.CooldownTimer;
	import elm.types.Vec2;
	import elm.utils.*;
	import flash.display.MovieClip;
	import flash.geom.Point;
	import game.*;
	import game.room.Room;
	import state.Gameplay;
	
	/**
	 * ...
	 * @author elmortem
	 */
	public class ActorGun {
		private var attr:Object;
		private var info:Object = null;
		private var room:Room = null;
		
		private var gunShootCooldown:CooldownTimer;
		
		public function ActorGun(attrIn:Object) {
			attr = attrIn;
			gunShootCooldown = new CooldownTimer(0);
		}
		public function setRoom(roomIn:Room):void {
			room = roomIn;
		}
		public function setGun(infoIn:Object):void {
			info = infoIn;
			attr.movie["gun"].gotoAndStop(info.frame);
			trace("Set gun: "+info.name);
			start();
		}
		public function start():void {
			gunShootCooldown.start(Number(info.time));
		}
		public function stop():void {
			gunShootCooldown.stop();
		}
		public function update(delta:Number):void {
			gunShootCooldown.update(delta);
		}
		public function isComplete():Boolean {
			return gunShootCooldown.isComplete();
		}
		public function shoot(angle:Number, point:Vec2):void {
			start();
			if (!room) {
				trace("Room not found.");
				return;
			}
			var defClass:Class = EntityClassMap.getEntityClass(info.bullet);
			if (defClass) {
				var p:Point = attr.movie["gun"]["bullet"].localToGlobal(new Point());
				p = Gameplay.stageToWorld(p);
				var v:Vec2 = new Vec2(p.x, p.y);
				room.add(new defClass( { owner:attr.owner, x:v.x, y:v.y, angle:angle, point:point } ));
			} else {
				trace("Bullet "+info.bullet+" not found.");
			}
		}
		public function getAngle(v:Vec2):Number {
			//if (!info) return 45;
			var p:Point = attr.movie.localToGlobal(new Point());
			p = Gameplay.stageToWorld(p);
			var u:Vec2 = new Vec2(p.x, p.y);
			
			return Angle.normal(u.AngleTo(v));
		}
	}
	
}