﻿package game.actor.boxes {
	import Box2D.Collision.b2ContactPoint;
	import Box2D.Collision.Shapes.b2Shape;
	import elm.utils.*;
	import Box2D.Collision.Shapes.b2MassData;
	import Box2D.Collision.Shapes.b2PolygonDef;
	import Box2D.Dynamics.*;
	import game.actor.Actor;
	import game.actor.WalkingActor;

	public class Box extends Actor {
		public static const DOWN_ANGLE:Number = 90.0 * (Math.PI / 180.0);
		public static const DOWN_ANGLE_RANGE:Number = 55.0 * (Math.PI / 180.0);
		
		public function Box(attrIn:Object) {
			super(attrIn);
			
			health = 30;
		}
		
		public override function update(delta:Number):void {
			/*if (is_ground) is_gravity = false;
			else is_gravity = true;*/
		}
		
		public override function render():void {
			super.render();
			var a:Number = Angle.toDeg(body.GetAngle());
			o.rotation = a;
		}
		
		public override function getBodyDef():b2BodyDef {
			var def:b2BodyDef = new b2BodyDef();
			def.userData = this;
			def.allowSleep = true;
			def.fixedRotation = false;
			def.position.Set(attr.x, attr.y);
			
			return def;
		}
		public override function setBody(bodyIn:b2Body):void {
			super.setBody(bodyIn);
			
			var def:b2PolygonDef = new b2PolygonDef();
			def.userData = this;
			def.SetAsBox(attr.width/2, attr.height/2);
			def.density = 1;
			def.friction = 1;
			def.restitution = 0.01;
			
			var m:b2MassData = new b2MassData();
			m.mass = attr.width * attr.height * 0.22;
			m.I = attr.width * attr.height * 200;
			
			body.CreateShape(def);
			//body.SetMass(m);
			body.SetMassFromShapes();
			//m.I = body.GetInertia();
			body.SetMass(m);
		}
		
		public override function onContactUpdate(shape:b2Shape, reverse:int, contactPoint:b2ContactPoint):void {
			super.onContactUpdate(shape, reverse, contactPoint);
			
			var normalAngle:Number = Math.atan2(contactPoint.normal.y * reverse, contactPoint.normal.x * reverse);
			if (Math.abs(normalAngle - DOWN_ANGLE) < DOWN_ANGLE_RANGE) {
				//leftmostFloorAngle  = Math.min( leftmostFloorAngle,  normalAngle );
				//rightmostFloorAngle = Math.max( rightmostFloorAngle, normalAngle );
				is_ground = true;
			}
		}
	}
}