﻿package game.actor.bullets {
	import elm.types.Vec2;
	import elm.utils.*;
	import Box2D.Collision.b2ContactPoint;
	import Box2D.Collision.Shapes.b2PolygonDef;
	import Box2D.Collision.Shapes.b2Shape;
	import Box2D.Dynamics.*;
	import game.actor.Actor;
	import game.actor.DamagedActor;

	public class Bullet extends Actor {
		public var timer:Number = 0;
		
		public function Bullet(attrIn:Object) {
			super(attrIn);
		}
		
		public override function update(delta:Number):void {
			if (timer >= 0) {
				timer -= delta;
				if (timer < 0) {
					die();
				}
			}
		}
		public override function render():void {
			super.render();
			if (o && body) {
				o.rotation = attr.angle; // Angle.toDeg(body.GetAngle());
			}
		}
		
		public function damageActor(actor:DamagedActor, contactPoint:b2ContactPoint):void {
			// override
		}
		
		public override function getBodyDef():b2BodyDef {
			var def:b2BodyDef = new b2BodyDef();
			def.userData = this;
			def.fixedRotation = false;
			def.position.Set(attr.x, attr.y);
			def.angle = Angle.toRad(attr.angle);
			def.isBullet = true;
			
			return def;
		}
		public override function setBody(bodyIn:b2Body):void {
			super.setBody(bodyIn);
			
			var def:b2PolygonDef = new b2PolygonDef();
			def.userData = this;
			def.SetAsBox(2, 2);
			def.density = 1;
			def.friction = 1;
			def.restitution = 0;
			
			body.CreateShape(def);
			body.SetMassFromShapes();
		}
		
		public override function onContactUpdate(shape:b2Shape, reverse:int, contactPoint:b2ContactPoint):void {
			if (!isAlive()) return;
			super.onContactUpdate(shape, reverse, contactPoint);
			
			if (shape.GetUserData() is DamagedActor) damageActor(shape.GetUserData() as DamagedActor, contactPoint);
			if (!shape.GetUserData()) die();
		}
	}
}