﻿package game.actor.bullets {
	import Box2D.Collision.Shapes.b2CircleDef;
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import elm.core.*;
	import elm.gfx.Animation;
	import Box2D.Collision.b2ContactPoint;
	import elm.types.Vec2;
	import flash.display.MovieClip;
	import game.actor.DamagedActor;
	
	public class LarvaBullet extends Bullet {
		private static const SPEED:Number = 100;
		private static const DAMAGE:Number = 5;
		
		public function LarvaBullet(attrIn:Object) {
			super(attrIn);
			
			o = Gfx.makeMovie("gfx.LarvaBullet", "bullet" + id, { x:attr.x, y:attr.y } ) as Animation;
			
			is_gravity = false;
			timer = 5;
		}
		public override function free():void {
			o = null;
		}
		
		public override function update(delta:Number):void {
			var v:b2Vec2 = body.m_linearVelocity;
			if (v.Length() < getSpeed()) {
				v.Normalize();
				v.Multiply(getSpeed());
			}
			super.update(delta);
		}
		
		public override function damageActor(actor:DamagedActor, contactPoint:b2ContactPoint):void {
			if(actor != attr.owner) actor.damage({damage:getDamage()});
			die();
		}
		
		public function getDamage():Number {
			return DAMAGE;
		}
		public function getSpeed():Number {
			return SPEED;
		}
		
		public override function setBody(bodyIn:b2Body):void {
			body = bodyIn;
			
			var def:b2CircleDef = new b2CircleDef();
			def.userData = this;
			def.radius = 7;
			def.density = 1;
			def.friction = 1;
			def.restitution = 0;
			
			body.CreateShape(def);
			body.SetMassFromShapes();
			
			var v:Vec2 = new Vec2();
			v.Move(getSpeed(), attr.angle);
			body.m_linearVelocity.SetV(v);
		}
		
	}
	
}