﻿package game.actor.bullets {
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2Body;
	import elm.core.*;
	import elm.gfx.Animation;
	import Box2D.Collision.b2ContactPoint;
	import elm.types.Vec2;
	import flash.display.MovieClip;
	import game.actor.DamagedActor;
	
	public class PistolBullet extends Bullet {
		private static const SPEED:Number = 200;
		private static const DAMAGE:Number = 5;
		
		public function PistolBullet(attrIn:Object) {
			super(attrIn);
			
			o = Gfx.makeMovie("gfx.PistolBullet", "bullet" + id, { x:attr.x, y:attr.y } ) as Animation;
			
			is_gravity = false;
			timer = 3;
		}
		public override function free():void {
			o = null;
		}
		
		public override function update(delta:Number):void {
			var v:b2Vec2 = body.m_linearVelocity;
			if (v.Length() < SPEED) {
				v.Normalize();
				v.Multiply(SPEED);
			}
			var u:Vec2 = new Vec2();
			u.SetV(body.m_linearVelocity);
			attr.angle = u.Angle();
			
			super.update(delta);
		}
		
		public override function damageActor(actor:DamagedActor, contactPoint:b2ContactPoint):void {
			if(actor != attr.owner) actor.damage({damage:getDamage()});
			die();
		}
		public function getDamage():Number {
			return DAMAGE;
		}
		
		public override function setBody(bodyIn:b2Body):void {
			super.setBody(bodyIn);
			
			if (body) {
				var v:Vec2 = new Vec2();
				v.Move(SPEED, attr.angle);
				body.m_linearVelocity.SetV(v);
			}
		}
		
	}
	
}