﻿package game.actor.enemies {
	import Box2D.Collision.Shapes.b2PolygonDef;
	import elm.game.CooldownTimer;
	import elm.types.Vec2;
	import Box2D.Dynamics.*;
	import Box2D.Collision.Shapes.b2CircleDef;
	import flash.events.WeakFunctionClosure;
	import game.actor.Actor;
	
	public class EnemyPost extends Enemy {
		private static const GEN_TIME:Number = 10;
		
		var test_timer:Number = 0;
		var pos:Vec2 = new Vec2();
		
		private var genCooldown:CooldownTimer;
		
		public function EnemyPost(attrIn:Object) {
			super(attrIn);
			
			is_gravity = false;
			genCooldown = new CooldownTimer(GEN_TIME);
			genCooldown.start();
		}
		
		public override function update(delta:Number):void {
			test_timer += delta;
			
			if (genCooldown.isComplete()) {				
				var p:Vec2 = new Vec2();
				p.SetV(body.GetPosition());
				p.x += o["point"].x;
				p.y += o["point"].y;
				room.add(new Soldier( { x:p.x, y:p.y } ));
				
				genCooldown.start();
			}
			
			if (player) {
				if(pos.DistanceTo(player.getBody().GetPosition()) < 700) {
					genCooldown.update(delta);
				}
			} else {
				if (actor_manager) player = actor_manager.findPlayer();
			}
		}
		
		public override function getBodyDef():b2BodyDef {
			var def:b2BodyDef = new b2BodyDef();
			def.userData = this;
			def.fixedRotation = true;
			def.position.Set(attr.x, attr.y);
			
			return def;
		}
		public override function setBody(bodyIn:b2Body):void {
			super.setBody(bodyIn);
			
			var def:b2PolygonDef = new b2PolygonDef();
			def.userData = this;
			def.SetAsBox(32, 64);
			def.density = 0;
			def.friction = 1;
			def.restitution = 0;
			def.isSensor = true;
			
			body.CreateShape(def);
			body.SetMassFromShapes();
			
			pos.SetV(body.GetPosition());
		}
	}
	
}