﻿package game.actor.powerups {
	import elm.gfx.Animation;
	import Box2D.Collision.b2ContactPoint;
	import Box2D.Collision.Shapes.b2CircleDef;
	import Box2D.Collision.Shapes.b2Shape;
	import Box2D.Dynamics.*;
	import game.actor.Actor;
	import game.actor.player.PlayerActor;
	
	public class Powerup extends Actor {
		
		public function Powerup(attrIn:Object) {
			super(attrIn);
			
			o.Set("ani", 5, 1, 9, Animation.PINPONG, true);
			ani = "ani";
			
			is_gravity = false;
			health = 0;
		}
		
		public function givePowerup(playerActor:PlayerActor) {
			// override
		}
		
		public override function update(delta:Number):void {
			super.update(delta);
			
			if (health > 0) {
				health -= delta;
				if (health < 0) {
					die();
				}
			}
		}
		
		public override function getBodyDef():b2BodyDef {
			var def:b2BodyDef = new b2BodyDef();
			def.userData = this;
			def.fixedRotation = true;
			def.position.Set(attr.x, attr.y);
			
			return def;
		}
		public override function setBody(bodyIn:b2Body):void {
			super.setBody(bodyIn);
			
			var def:b2CircleDef = new b2CircleDef();
			def.userData = this;
			def.radius = 18;
			def.density = 0;
			def.friction = 1;
			def.restitution = 0;
			def.isSensor = true;
			
			body.CreateShape(def);
			body.SetMassFromShapes();
		}
		
		public override function onContactUpdate(shape:b2Shape, reverse:int, contactPoint:b2ContactPoint):void {
			super.onContactUpdate(shape, reverse, contactPoint);
			
			if (shape.GetUserData() is PlayerActor) {
				givePowerup(shape.GetUserData() as PlayerActor);
			}
		}
	}
	
}