﻿package game.actor.triggers {
	import Box2D.Collision.b2ContactPoint;
	import Box2D.Collision.Shapes.b2CircleDef;
	import Box2D.Collision.Shapes.b2Shape;
	import Box2D.Dynamics.b2Body;
	import Box2D.Dynamics.b2BodyDef;
	import game.actor.Actor;
	import game.actor.player.PlayerActor;
	
	public class PortalTrigger extends Actor {
		
		public function PortalTrigger(attrIn:Object) {
			super(attrIn);
			
			if (o) {
				o.Set("ani", 10, 1, 43, 0, true);
				ani = "ani";
			}
		}
		
		public override function getBodyDef():b2BodyDef {
			var def:b2BodyDef = new b2BodyDef();
			def.userData = this;
			def.fixedRotation = true;
			def.position.Set(attr.x, attr.y);
			
			return def;
		}
		public override function setBody(bodyIn:b2Body):void {
			super.setBody(bodyIn);
			
			var def:b2CircleDef = new b2CircleDef();
			def.userData = this;
			def.radius = 32;
			def.density = 0;
			def.friction = 1;
			def.restitution = 0;
			def.isSensor = true;
			
			body.CreateShape(def);
			body.SetMassFromShapes();
		}
		
		public override function onContactUpdate(shape:b2Shape, reverse:int, contactPoint:b2ContactPoint):void {
			super.onContactUpdate(shape, reverse, contactPoint);
			
			if (shape.GetUserData() is PlayerActor) {
				(shape.GetUserData() as PlayerActor).gotoPortal(this);
				//givePowerup(shape.GetUserData() as PlayerActor);
			}
		}
	}
}