﻿package game.room {
	import flash.display.*;
	import flash.events.EventDispatcher;
	import game.*;
	
	public class Room extends EventDispatcher {
		public static const MAP_WIDTH:int = 3840;
		public static const MAP_HEIGHT:int = 960;
		private var attr:Object;
		public var list:Array;
		
		public function Room(attrIn:Object) {
			attr = attrIn;
			list = [];
		}
		public function free():void {
			removeAll();
		}
		
		public function add(entityIn:Entity):Entity {
			if (!entityIn) {
				trace("Entity is null.");
				return null;
			}
			entityIn.setRoom(this);
			var id:int = list.push(entityIn) - 1;
			list[id].addEventListener(EntityEvent.KILLED, onKilled);
			dispatchEvent(new EntityEvent(entityIn, EntityEvent.ADD));
			return entityIn;
		}
		public function removeAll():void {
			for (var i:int = 0; i < list.length; i++) {
				dispatchEvent(new EntityEvent(list[i], EntityEvent.REMOVE));
			}
			list = [];
		}
		public function remove(entityIn:Entity):void {
			var id:int = list.indexOf(entityIn);
			if (id >= 0) {
				dispatchEvent(new EntityEvent(list[id], EntityEvent.REMOVE));
				list.splice(id, 1);
			}
		}
		public function build():void {			
			for (var i:int = 0; i < (attr.scene as MovieClip).numChildren; i++) {
				var m:DisplayObject = (attr.scene as MovieClip).getChildAt(i);
				var defClass:Class = EntityClassMap.getEntityClass(m.name);
				if (defClass) {
					trace("Create "+m.name+" entity.");
					try {
						var entity:Entity = add(new defClass( { x:m.x, y:m.y, width:m.width, height:m.height, o:m } ));
						//m.name = "entity" + entity.id;
					} catch (err:Error) {
						trace(err.message);
					}
				}
			}
			
			if (!attr || !attr.xml_str) return;
			var xml:XML = new XML(attr.xml_str);
			/*
			var id:int;
			var defClass:Class;
			var entityAttr:Object;
			for(...) {
				entityAttr = ...;
				defClass = EntityClassMap.map[...];
				add(new defClass(entityAttr));
			}
			*/
		}
		public function onKilled(e:EntityEvent):void {
			//list_killed.push(e.entity);
			remove(e.entity);
		}
	}
}