﻿package game.room.entity {
	import elm.gfx.*;
	import Box2D.Collision.Shapes.b2PolygonDef;
	import Box2D.Dynamics.*;
	import flash.display.*;
	import physic.*;
	import game.*;

	public class Ladder extends Entity implements PhysicRecipient {
		protected var body:b2Body = null;
		protected var o:MovieClip = null;
		
		public function Ladder(attrIn:Object) {
			super(attrIn);
			
			o = attr.o;
		}
		public override function free():void {
			body = null;
			o = null;
			attr = null;
		}
		
		public function getBodyDef():b2BodyDef {
			var def:b2BodyDef = new b2BodyDef();
			def.userData = this;
			def.position.Set(attr.x, attr.y);
			return def;
		}
		public function setBody(bodyIn:b2Body):void {
			body = bodyIn;
			
			var def:b2PolygonDef = new b2PolygonDef();
			def.userData = this;
			def.SetAsBox(attr.width / 2 - 10, attr.height / 2);
			def.density = 1;
			def.friction = 0;
			def.restitution = 0;
			def.isSensor = true;
			body.CreateShape(def);
		}
		public function getBody():b2Body {
			return body;
		}
		public override function getVisualObject():DisplayObject {
			return o;
		}
	}
}