﻿package game.room.entity {
	import Box2D.Collision.Shapes.b2PolygonDef;
	import Box2D.Dynamics.*;
	import flash.display.MovieClip;
	import physic.PhysicRecipient;
	
	public class SolidPlatform extends Platform {
		var o:MovieClip;
		
		public function SolidPlatform(attrIn:Object) {
			super(attrIn);
			
			o = attr.o;
		}
		
		public override function getBodyDef():b2BodyDef {
			var def:b2BodyDef = new b2BodyDef();
			def.userData = this;
			def.fixedRotation = true;
			def.allowSleep = true;
			def.position.Set(attr.x, attr.y);
			
			return def;
		}
		public override function setBody(bodyIn:b2Body):void {
			super.setBody(bodyIn);
			
			var def:b2PolygonDef = new b2PolygonDef();
			def.userData = this;
			def.SetAsBox(attr.width/2, attr.height/2);
			def.density = 0;
			def.friction = 1;
			def.restitution = 0;
			
			body.CreateShape(def);
			body.SetMassFromShapes();
		}
	}
	
}