﻿package physic {
	import Box2D.Collision.Shapes.b2FilterData;
	import Box2D.Collision.Shapes.b2Shape;
	import Box2D.Dynamics.b2ContactFilter;
	import game.actor.*;
	import game.actor.bullets.Bullet;
	import game.actor.bullets.TankBullet;
	import game.actor.enemies.EnemyPost;
	import game.actor.enemies.Tank;
	import game.room.entity.Platform;

	public class ContactFilter extends b2ContactFilter {
		
		public override function ShouldCollide(shape1:b2Shape, shape2:b2Shape):Boolean {	
			if (shape1.GetUserData() is Platform) {
				if (!(shape1.GetUserData() as Platform).isCollised(shape2)) return false;
			}
			if (shape2.GetUserData() is Platform) {
				if(!(shape2.GetUserData() as Platform).isCollised(shape1)) return false;
			}
			
			if (shape1.GetUserData() is WalkingActor) {
				if (!(shape1.GetUserData() as WalkingActor).isCollised(shape1)) return false;
			}
			if (shape2.GetUserData() is WalkingActor) {
				if (!(shape2.GetUserData() as WalkingActor).isCollised(shape2)) return false;
			}
			
			if ((shape1.GetUserData() is Bullet && shape2.GetUserData() is EnemyPost) || (shape2.GetUserData() is Bullet && shape1.GetUserData() is EnemyPost)) return false;
			if ((shape1.GetUserData() is TankBullet && shape2.GetUserData() is Tank) || (shape2.GetUserData() is TankBullet && shape1.GetUserData() is Tank)) return false;
			
			var filter1:b2FilterData = shape1.GetFilterData();
			var filter2:b2FilterData = shape2.GetFilterData();
			
			if (filter1.groupIndex == filter2.groupIndex && filter1.groupIndex != 0) {
				return filter1.groupIndex > 0;
			}
			
			var collide:Boolean = (filter1.maskBits & filter2.categoryBits) != 0 && (filter1.categoryBits & filter2.maskBits) != 0;
			
			return collide;
		}
	}
}