unit Main;

interface

uses
  Windows,
  Messages,
  OpenGL,
  Global,
  Use_Text,
  Use_OpenGL,
  Use_Geometry,
  Use_JPG,
  _Objects,
  Use_3d,
  Use_Parts;

procedure TactTimer;
procedure Create_prog;
procedure Kill_Prog;

implementation

procedure Set_Ambient(r,g,b:single);
Var p:TVector4f;
begin
 p[0]:=r; p[1]:=g; p[2]:=b; p[3]:=1;      { }
 glLightFV(Gl_LIGHT0,GL_AMBIENT,@p);          { }
end;

procedure Load_Level(filename:string);
Var i:integer;
 Lev:TLevel;
 f:File of TLevel;
begin
  AssignFile(f,filename);
  Reset(f);
  read(f,Lev);
  for i:=0 to Max_Planes do
   begin
    Plane[i]:=Lev.Plane[i];
   end;
  for i:=0 to Max_Enemies do
   begin
    Enemy[i]:=Lev.Enemy[i];
   end;
  for i:=0 to Max_Bonus do
   begin
    Bonus[i]:=Lev.Bonus[i];
   end;
 Lev_begin:=Lev.Lev_begin;
 Lev_end:=Lev.Lev_end;
 Hero.need_ang:=271;
 Hero.R:=true;
 Hero.Weapon:=1;
 Hero.Life:=4;
 Hero.HP:=5;
end;

procedure Act(Action:byte);
begin
  mbl:=false;
  mbr:=false;
  case Action of
   0:;
   1:Menu.Visible_Group:=1;//new game
   2:Menu.Visible_Group:=2;//author
   3:Menu.Visible_Group:=3;//exit
   4:Menu.Visible_Group:=0;//to menu
   5:Mode:=false;//exit form game
   10:Mode:=false;//exit form game
   6:Menu.Visible_Group:=0;//to menu
   7:if Level>1 then begin
      Menu.Visible_Group:=4;
      GameState:=gs_game;//continue game
     end;
   8:begin
      GameState:=gs_game;//new game
      Level:=1;
      Menu.Visible_Group:=4;
      Load_Level('Data/Levels/Lev1.txt');
   //   Load_Level('Test1.txt');
     end;

  101:begin //next_level
      Level:=Level+1;
      hero.HP:=Default_HP;
      hero.Point:=Vector(0,0);
      hero.Weapon:=0;
      hero.Action:=0;
      case Level of
       2:begin
          Load_Level('Data/Levels/Lev2.txt');
          //loadJPGTexture('DATA/fon1.jpg',_Fon);
        end;
       3:begin
          Load_Level('Data/Levels/Lev3.txt');
          loadJPGTexture('DATA/fon1.jpg',_Fon);
        end;
       4:Load_Level('Data/Levels/Last_Level.txt');
       5:begin
          Menu.Visible_Group:=7;
          GameState:=gs_menu;//new game
         end;//Load_Level('Data/Levels/Lev2.txt');
      end;
     // Menu.Visible_Group:=0;
    //  GameState:=gs_menu;//new game
     end;
  end;
end;

procedure Save_Level(filename:string);
Var i:integer;
 Lev:TLevel;
 f:File of TLevel;
begin
  for i:=0 to Max_Planes do
   begin
    Lev.Plane[i]:=Plane[i];
   end;
  for i:=0 to Max_Enemies do
   begin
    Lev.Enemy[i]:=Enemy[i];
   end;                  
  for i:=0 to Max_Bonus do
   begin
    Lev.Bonus[i]:=Bonus[i];
   end;
 Lev.Lev_begin:=Lev_begin;
 Lev.Lev_end:=Lev_end;
 AssignFile(f,filename);
 Rewrite(f);
 write(f,Lev);
 Hero.need_ang:=271;
 Hero.R:=true;
 Hero.Weapon:=1;
 Hero.Life:=4;
 Hero.HP:=5;
end;

procedure Check_Keys;       { }
Var
  Speed:Single;
  Vect:Single;
  _Down:boolean;
  i,j:integer;
//P:TPoint;
begin
 DX:=((+MX-PW/2)*0.0111/mash){+kx};
 DY:=((-MY+PH/2)*0.0111/mash){+ky}; {   }
{    }
 if not Edit_mode then
 begin   //control mode
 AX:=-3;
 AY:=0;
 if GameState=gs_game then
 begin
  Speed:=0.06;
  if (key[68] or key[39]) then
     begin
       Hero.need_ang:=271;
       Hero.r:=true;
       hero.run:=true;
       Hero.Point[0]:=Hero.Point[0]+Speed;
       {key[68]:=false;key[39]:=false;}end else
  if (key[65] or key[37]) then
     begin
       Hero.need_ang:=90;
       Hero.r:=false;
       hero.run:=true;
       Hero.Point[0]:=Hero.Point[0]-Speed;
      {key[65]:=false;key[37]:=false;}end
     else
     begin
       hero.run:=false;
     end;
  if (key[87] or key[38]) then
   begin Hero.u:=true;{key[87]:=false;key[38]:=false;}end else hero.u:=false;
  if (key[83] or key[40]) then
   begin Hero.d:=true;{key[83]:=false;key[40]:=false;}end else hero.d:=false;
  if hero.R then
   speed:=1 else
    speed:=-1;
  if key[32] then   {prigok}
   begin
     if Hero.jump_faze=0 then
       begin
        Hero.anim:=0;
       end;
     if (key[83] or key[40]) and Hero.can_fall then //jump down
     begin
       Hero.Point[1]:=Hero.Point[1]-0.01;
       //Hero.jump_faze:=16;
     end else
     if (Hero.Action<>1) then
     begin
       if Hero.Action=3 then
        Hero.Vector[1]:=Hero.Vector[1]+0.14
       else
        Hero.Vector[1]:=Hero.Vector[1]+0.16;
       Hero.jump_faze:=15;
     end;
     {if (Hero.jump_faze<=15)  then
      begin
       Hero.Vector[1]:=Hero.Vector[1]+0.013;//plus(Hero.Vector,Vector(0,0.02-Hero.jump_faze*0.00));
       Hero.jump_faze:=Hero.jump_faze+1;
       Add_Particle(Hero.Point[0]-0.1*speed+Random(10)/100-0.005,Hero.Point[1]+0.4+Random(10)/100-0.005,0,
          0+Random(10)/400-0.00125,-0.05+Random(10)/400-0.00125,0,Random(2),60);
       end;   }
     Hero.Action:=1;
     //key[32]:=false;
   end;
  If MW>0 then Mash:=Mash+(Mash)*0.3;
  If MW<0 then Mash:=Mash-(Mash)*0.3;
  If Mash>400 then Mash:=400;
  If Mash<0.1 then Mash:=0.1;
  MW:=0;
  if key[17] or key[90] then
  begin
    case Hero.Action of
     0:if hero.u then
        begin
         if hero.run then
           Fire(Hero.Point[0]+0.1*speed,Hero.Point[1]+0.75,0.16*speed,0.14,Hero.Weapon) else
           Fire(Hero.Point[0]-0.05*speed,Hero.Point[1]+0.8,0.0,0.2,Hero.Weapon);
        end
        else
        if Hero.d then
        begin
         if hero.run then
           Fire(Hero.Point[0]+0.05*speed,Hero.Point[1]+0.5,0.16*speed,-0.14,Hero.Weapon) else
           Fire(Hero.Point[0]+0.2*speed,Hero.Point[1]+0.34,0.21*speed,0.0,Hero.Weapon);
        end
         else
         Fire(Hero.Point[0]+0.2*speed,Hero.Point[1]+0.6,0.21*speed,0.0,Hero.Weapon);
     1:if hero.u then
         Fire(Hero.Point[0]+0.1*speed,Hero.Point[1]+0.75,0.14*speed,0.14,Hero.Weapon)
        else
        if Hero.d then
         Fire(Hero.Point[0]+0.05*speed,Hero.Point[1]+0.5,0.14*speed,-0.14,Hero.Weapon)
        else
         Fire(Hero.Point[0]+0.2*speed,Hero.Point[1]+0.6,0.2*speed,0.0,Hero.Weapon);
    end;
   end;
 end;
 end else
 begin   //edit mode
  AX:=AX-(MY-trunc(PH/2))/15;
  If AX<-180 then AX:=-180;
  If AX>180 then AX:=180;
  AY:=AY+(MX-trunc(PW/2))/15;
  SetCursorPos(Trunc(PW/2),Trunc(PH/2));
  if key[112] then {f1-load}
   Load_level('test.txt');
  if key[113] then {f1-save}
   Save_level('test.txt');

  if (key[68] or key[39]) then
   begin
    EX:=EX+1;
    key[68]:=false;key[39]:=false; //rigth
   end;
  if (key[65] or key[37]) then
   begin
    EX:=EX-1;
    key[65]:=false;key[37]:=false; //left
   end;
  if (key[87] or key[38]) then
   begin
    EY:=EY+1;
    key[87]:=false;key[38]:=false;//up
   end;
  if (key[83] or key[40]) then
   begin        
    EY:=EY-1;
    key[83]:=false;key[40]:=false;//down
   end;
  if key[107] then begin key[107]:=false;if panel_len<10 then Panel_len:=Panel_Len+1;end;
  if key[109] then begin key[109]:=false;if panel_len>0 then Panel_len:=Panel_Len-1;end;
  if key[81] then Panel_tip:=0; //rock
  if key[87] then Panel_tip:=1;//metall
  if key[17] then begin key[17]:=false; if panel_tip<3 then panel_tip:=panel_tip+1 else panel_tip:=0;  end;
  if key[219] then begin key[219]:=false;if Enemy_life<30 then Enemy_life:=Enemy_life+1;end;//enemy life +- []
  if key[221] then begin key[219]:=false;if Enemy_life>1 then Enemy_life:=Enemy_life-1;end;
  if key[13] then begin key[13]:=false;if Enemy_tip<10 then Enemy_tip:=Enemy_tip+1 else Enemy_tip:=0;end;//enter - change enemy type
  if key[188] then begin key[188]:=false;Enemy_poz:=Enemy_poz-1;end;//enemy pozition < >
  if key[190] then begin key[190]:=false;Enemy_poz:=Enemy_poz+1;end;
  if key[57] then begin key[57]:=false;Lev_Begin:=EX;end;//begin and end of the lever ()
  if key[48] then begin key[48]:=false;Lev_end:=EX;end;
  if key[85] then begin key[85]:=false;add_Bonus(EX,EY,1);end;
  if key[73] then begin key[73]:=false;add_Bonus(EX,EY,2);end;
  if key[80] then begin key[80]:=false;add_Bonus(EX,EY,3);end;
  if key[79] then begin key[79]:=false;add_Bonus(EX,EY,4);end;
  if key[32] then
  begin
   key[32]:=false;
   _Down:=true;
   for i:=0 to Max_Planes do
    if Point_in_Rect(EX,EY,
      Plane[i].Point[0]-0.2,Plane[i].Point[1]-0.2,
      Plane[i].Point[0]+Plane[i].Len-0.2,Plane[i].Point[1]+0.2) and
     Plane[i].real then
    begin
     Plane[i].real:=false;
     _Down:=false;
     for j:=0 to Max_Enemies do
       if (Enemy[j].platforma=i) then
        Enemy[j].tip:=0;
     break;
    end;
   if _down then
    begin  //add platform and unit
     i:=Add_plane(EX,EY,Panel_Len,Panel_tip,not Key[16]); //if shift down - you can jump in panel
     add_Enemy(EX+Enemy_Poz,EY,Enemy_tip,Enemy_life,i);
    end;
  end;
 end;
 if key[192] then //to edit mode;
  begin
    Edit_Mode:=not Edit_Mode;
    key[192]:=false;
  end;

 if mbl then
  begin
  // mbl:=false;
  end;
 if key[27] then
  begin
   key[27]:=false;
   Menu.Visible_Group:=0;
   GameState:=gs_menu;
  end;
 if key[112] then Act(8); 
end;

procedure Render;    {}
Var
  i,j:integer; { }
  M:TMatrix4f;
  P:TVector4f;
begin
 glclear(GL_Color_Buffer_Bit xor GL_Depth_Buffer_Bit);  {}
 glLoadIdentity();     {}
 glEnable(GL_Blend);
 glDisable(GL_Texture_2d);
 Menu.Render;
 for i:=1 to Hero.HP do
   begin
     glColor3f(0.2,0.2,3);
     put_Sprite(-5.3+i*0.2,4,1,0.15);
     glColor4f(0.2,0.2,0.2,0.2);
     put_Sprite(-5.3+i*0.2+0.04,4-0.04,1,0.15);
   end;
 //Menu.TE[Menu_Lifes].Text:=IntToStr(Hero.Life);
{render}
 glColor3f(5,5,5);
 put_sprite(DX,DY,1,0.1);
// glTranslatef(0,0,TCM);
 glRotatef(AX,1,0,0);
 glRotatef(-AY,0,1,0);
 p[0]:=0.1;  p[1]:=0.7;
 p[2]:=-0.7; p[3]:=0;
 glLightFV(Gl_LIGHT0,Gl_Position,@p);
 glColor3f(5,5,5);
{fon}
 glEnable(GL_Texture_2d);
 glBindTexture(GL_Texture_2D,_Fon);
 glBegin(GL_QUADS);
 glTexCoord2f(0,0);
 glVertex3f(-17,-19,20);
 glTexCoord2f(1,0);
 glVertex3f( 17,-19,20);
 glTexCoord2f(1,1);
 glVertex3f( 17, 15,20);
 glTexCoord2f(0,1);
 glVertex3f(-17, 15,20);
 glend;
{/fon}
 Put_Planes();
 //Rock.Anim(1);
 //Rock.Render(man.Texture);
 put_hero();
 Put_Enemies();
//glDisable(GL_BLEND);
 glColor4f(1,1,1,1);
 glBindTexture(GL_Texture_2d,_Bullets);
 Put_Bullets();
 glBindTexture(GL_Texture_2d,_Parts);
 Render_Parts();
 Put_Bonus();
 if Edit_Mode then
 begin
 glDisable(GL_Texture_2d);
  menu.font.Put_Text('X: '+IntToStr(EX),4.5,4);
  menu.font.Put_Text('Y: '+IntToStr(EY),4.5,3.5);
  menu.font.Put_Text('Panel: '+IntToStr(Panel_len)+'('+IntToStr(Panel_tip)+')',4,3);
  menu.font.Put_Text('Enemy: '+IntToStr(Enemy_tip)+'('+IntToStr(Enemy_life)+','+IntToStr(Enemy_poz)+')',3.5,2.5);
 glPushMatrix();
 for i:=1 to Panel_len do
 begin
  glLoadMatrixf(@m_Matrix);
  M:=stm(0.5+i,-1,0);
  glMultMatrixf(@M);
 case Panel_tip of
  0:begin  {land+grass}
       Rock1.Render(Rock.Texture);
    end;
  1:begin                       {metall}
   //   for i:=1 to Panel_len do
       Metall1.Render(Metall.Texture);
    end;{stone}
  2:;{iron}
 end;
 glLoadMatrixf(@m_Matrix);
 M:=stm(0.5+Enemy_Poz,-1,0);
 glMultMatrixf(@m);
 Rob.Render(Rob.Texture);
 end;
 glPopMatrix();
 glBegin(GL_Lines);
 glVertex3f(Lev_begin-kx,-100,0);
 glVertex3f(Lev_begin-kx,100,0);
 glend();
 glBegin(GL_Lines);
 glVertex3f(Lev_end-kx,-100,0);
 glVertex3f(Lev_end-kx,100,0);
 glend();
 end;
 glRotatef(AY,0,1,0);
 glRotatef(-AX,1,0,0);
// glTranslatef(0,0,-TCM);
 {render}
 glFlush();
 SwapBuffers(glhDC);
end;

procedure TactTimer;  { }
begin
 Check_Keys;    {    }
 Engine_Parts();
 case GameState of
  gs_game:Act(move_objects()+100);
  gs_menu:Act(Menu.Check(DX,DY,mbl or mbr));
  gs_info:;
 end;     
 if not Mode then Kill_Prog;
 Render;        {}
end;

procedure Create_prog;{ }
Var i,j,x,y:integer;
begin
 //ShowCursor(false);  { }
 glClearColor(0.0,0.0,0.0,5);
 enable_bind_tex;
 glShadeModel(GL_SMOOTH);
 glEnable(GL_Depth_Test);
// glEnable(GL_Blend);
// glDisable(GL_LIGHTING);
 glEnable(GL_CULL_FACE);

 KX:=30;
 KY:=0;
 man:=TMesh.Create;
 Rock:=TMesh.Create;
 Rock1:=TMesh.Create;
 Metall:=TMesh.Create;
 Metall1:=TMesh.Create;
 Minigun:=TMesh.Create;
 Terminator:=TMesh.Create;
 Rob:=TMesh.Create;
 Peller:=TMesh.Create;
 Vert:=TMesh.Create;
 man.LoadFromMMSFile('DATA/Models/soldier.mms');
 Rock.LoadFromMMSFile('DATA/Models/Rock.mms');
 Rock1.LoadFromMMSFile('DATA/Models/Rock1.mms');
 Metall.LoadFromMMSFile('DATA/Models/Metall.mms');
 Metall1.LoadFromMMSFile('DATA/Models/Metall1.mms');
 Minigun.LoadFromMMSFile('DATA/Models/minigun.mms');
 Terminator.LoadFromMMSFile('DATA/Models/Terminator.mms');
 Rob.LoadFromMMSFile('DATA/Models/Rob.mms');
 Peller.LoadFromMMSFile('DATA/Models/Peller.mms');
 Vert.LoadFromMMSFile('DATA/Models/Vertolet.mms');

 Minigun.MeshScale(1/65);
 minigun.Anim(0);
 Rock.Anim(0);
 Rock.MeshScale(1/50);
 Rock1.MeshScale(1/50);
 Metall.MeshScale(1/50);
 Metall1.MeshScale(1/50);
 Terminator.MeshScale(1/50);
 Rob.MeshScale(1/60);
 Peller.MeshScale(1/55);
 Peller.MeshTranslate(0,0.5,0);
 Vert.MeshScale(1/40);
 //Vert.MeshRotate(Rotate_Y(180));
{up }
 minigun.MeshTranslate(0,0,0.5);
 Terminator.MeshTranslate(0,1,0);
 minigun.MeshTranslate(0,1,0);
 Rob.MeshTranslate(0,1,0);
 Peller.MeshTranslate(0,1,0);
 Vert.MeshTranslate(0,1,0);
// Rock.MeshScale(0.0095);
{ man.LoadFromMMSFile('DATA/Models/trooper.mms');
 man.Add_Load('DATA/Models/gun.mms');
 man.SaveMMSFile('DATA/Models/soldier.mms');   }
 man.MeshScale(0.0095);
// man.MeshScale(0.03);
 man.Anim(22);
 man.MeshMirrorX;
// man.Ligth:=false;
 loadJPGTexture('DATA/Models/trooper.jpg',man.Texture);
 loadJPGTexture('DATA/Models/Rock.jpg',Rock.Texture);
 loadJPGTexture('DATA/Models/Metall.jpg',Metall.Texture);
 loadJPGTexture('DATA/Models/minigun.jpg',minigun.Texture);
 loadJPGTexture('DATA/Models/Terminator.jpg',Terminator.Texture);
 loadJPGTexture('DATA/Models/Rob.jpg',Rob.Texture);
 loadJPGTexture('DATA/Models/Peller.jpg',Peller.Texture);
 loadJPGTexture('DATA/Models/Vertolet.jpg',Vert.Texture);
//  LoadJPGTexture('DATA/particles.jpg',_Parts);
 LoadJPGATexture('DATA/particles.jpg','DATA/particles_alpha.jpg',_Parts);
 LoadJPGATexture('DATA/Bullets.jpg','DATA/Bullets_alpha.jpg',_Bullets);
 LoadJPGATexture('DATA/Bonus.jpg','DATA/Bonus_alpha.jpg',_Bonus);
 loadJPGTexture('DATA/fon.jpg',_Fon);
 Set_Ambient(0.1,0.1,0.3);
Menu:=TMenu.Create(glHDC);
//  Menu:=TMenu.Create(glHDC,'MagistralC-Bold.otf',   'MagistralC-Bold');
 Menu.Visible_Group:=0;
 Menu.add_text_element(' ',-5,3.2,3,0.4,7,0);
 Menu.add_text_element(' ',-5,2.6,2,0.4,1,0);
 Menu.add_text_element('',-5,2,2,0.4,2,0);
 Menu.add_text_element('',-5,1.4,2,0.4,3,0);

 Menu.add_text_element('',-4,0.8,0.5,0.4,6,3);
 Menu.add_text_element('',-4,1.4,0.5,0.4,5,3);

 Menu.add_text_element(' another opinion',-5,2.6,0,0,0,2);
 Menu.add_text_element(': Mefistofel',-5,2,0,0,0,2);
 Menu.add_text_element('   47  IGDC.RU',-5,1.4,4,0,0,2);
 Menu.add_text_element('11.06.09',-5,0.8,4,0,0,2);
 Menu.add_text_element('',-5,0,4,0.4,4,2);

 Menu.add_text_element('',-4,2.6,4,0.4,8,1);
 Menu.add_text_element('',-4,2,4,0.4,4,1);
 Menu.add_text_element(' !',-1,1,4,0.4,10,7);
{Menu.add_text_element('123',-5,1,-4,0.6,0);
 Menu.add_text_element('123',-5,0.5,-4,0.6,0);
 Menu.add_text_element('123',-5,0,-4,0.6,0);}
 Menu.Set_Shadow(20,20,20);
 Menu.Set_Color(250,250,250);
 Menu.Set_Active_Color(0,0,250);
 Menu.add_text_element('PTS',-6,4,-12,1,0,0);  {}
 {}
// Menu_Lifes:=Menu.add_text_element('12',-5.45,3.9,-7.45,7.9,0,4);
 Hero.need_ang:=271;
 Hero.R:=true;
 Hero.Weapon:=0;
 Hero.Life:=4;
 Hero.HP:=Default_HP;
 Lev_begin:=-12;
 Lev_end:=25;
 hero.HP:=Default_HP;
 hero.Point:=Vector(0,0);
 hero.Weapon:=0;
 hero.Action:=0;     
 Change_Resolution(1024,768);  { }
 {test}
{ for i:=0 to 50 do
  add_Enemy(Random(30),Random(10),1+Random(4)); }
end;

procedure Kill_Prog;
begin
 Restore_Resolution;
 KillTimer(0,TactH);     { }
 ShowCursor(True);        { }
 ExitProcess(0);
end;

end.
