unit Use_3d;

interface

{
 0.006
 3d mesh model
 mms loader (can also save)
                Mefistofel
}

Uses OpenGl,Use_Geometry,SysUtils{};

type
 TFace = array [0..2] of integer;{triangle Face}
 TVertex = array of TPoint;
 TFaces = Array of TFace; 
 TFloatValue = (fvExtended, fvCurrency);

 TMesh = class
 private
 public
  num_Vertex:cardinal;
  num_Faces:cardinal;
  num_Tex_Vertex:cardinal;
  num_anim:cardinal;
  Current_Anim:single;
  RM:TMatrix;{rotate Matrix}
  Vertex:Array of TVertex; {array of vertex coords (array for animation)}
  Render_Vertex:TVertex;   {vertex coords for render}
  Face:TFaces;             {number each vertex in triangles}
  TexV:Array of TVect;     {texture coordinates}
  Tex:Array of TFace;      {number each texture vertex in triangles }
  Normal:Array of TPoint;  {normals fop each point}
  Texture:cardinal;        {texture num}
  Textured,                {if true tren enable texture}
  Ligth,                   {if true then enable ligth, else - without}
  Blend,                   {if true - enable blending}
  Modulate:boolean;        {if true then modulate? else - decal}
  constructor Create();
  procedure Anim(L:single);{animation between L and L+1 frame}
  procedure AnimBetween(L:single;B,E:integer);{animation between L and N frame}
  procedure Render(tx:cardinal);
  procedure Rotate(Angs:TMatrix);   {rotate model for render}
  procedure Scale(F:Single);        {scale model for render}
  procedure Translate(T:TPoint);overload;
  procedure Translate(X,Y,Z:single);overload;
  procedure RenderRestore;
  procedure MeshRotate(Angs:TMatrix);
  procedure MeshScale(F:Single);                 {Scale all Mesh(and all mesh animation)}
  procedure MeshTranslate(T:TPoint);overload;    {translate all Mesh(and all mesh animation)}
  procedure MeshTranslate(X,Y,Z:single);overload;{translate all Mesh(and all mesh animation)}
  procedure MeshMirrorX;            {mirror for X all Mesh(and all mesh animation)}
  procedure MeshMirrorY;            {mirror for Y all Mesh(and all mesh animation)}
  procedure MeshMirrorZ;            {mirror for Z all Mesh(and all mesh animation)}
  procedure MeshRotate90X(side:boolean);{90 digrees rotation on X of all mesh forward or bacward(true side is 1 false side is -1)}
  procedure MeshRotate90Y(side:boolean);{90 digrees rotation on Y of all mesh forward or bacward(true side is 1 false side is -1)}
  procedure MeshRotate90Z(side:boolean);{90 digrees rotation on Z of all mesh forward or bacward(true side is 1 false side is -1)}
  procedure set_val(Var s:string;M,c:byte;var i:Cardinal; var j:Cardinal;var z:Cardinal; var L:Cardinal);
  procedure LoadFromMMSFile(FileName:String); {load geometry and animation from mms file}
  procedure Add_Load(Name:String);   {adding new geometry in this mesh}
  procedure SaveMMSFile(Name:String); {save mms format vith minimum faces,norms and tex}
 end;

Var
  Man,
  Rock,Rock1,
  Metall,Metall1:TMesh;
  Box:TMesh;
  Terminator,Rob,peller,Vert:TMesh;

implementation
{!!!}
//Var
// anim:byte;
 //test_:boolean = false;
  {Meshes}

constructor TMesh.Create();
begin
 num_Vertex:=5;
 num_Faces:=5;
 num_Tex_Vertex:=5;
 Textured:=true;
 Ligth:=true;
 Blend:=false;
 Modulate:=true;
 Texture:=255+Random(256);{ :)}
 SetLength(Vertex,5);
 SetLength(Face,5);
 SetLength(TexV,5);
 SetLength(Tex,5);
 SetLength(Normal,5);
 SetLength(Render_Vertex,num_vertex);
 RM:=Matrix(0,0,0,0,0,0,0,0,0);
end;

procedure TMesh.Anim(L:single);
Var i,a:cardinal;
begin
 if L<0 then L:=0;
 If L>num_Anim then L:=num_Anim;
 if (Current_Anim=L) then exit;
 a:= Trunc(L);
 If (L=a) then
  Render_Vertex:=copy(Vertex[a]) else
  For i:=0 to num_vertex do
   begin
    Render_Vertex[i]:=Between(Vertex[a][i],Vertex[a+1][i],L-a);
   end;
 Current_Anim:=L;
end;

procedure TMesh.AnimBetween(L:single;B,E:integer);{animation between L and N frame}
Var i:cardinal;
begin
 if B<0 then B:=0;
 If B>num_Anim then B:=num_Anim;
 if E<0 then E:=0;
 If E>num_Anim+1 then E:=num_Anim+1;
 if L<0 then L:=0;
 if L>1 then L:=1;
 If (L=0) then
  Render_Vertex:=copy(Vertex[B]) else
  For i:=0 to num_vertex do
   begin
    Render_Vertex[i]:=Between(Vertex[B][i],Vertex[E][i],L);
   end;
end;

procedure TMesh.Render(tx:cardinal);
Var i,j:integer;
begin
 if Self.Modulate then
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_Modulate) else
    glTexEnvi(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_Decal);
 if Self.Textured then
  begin
   glEnable(GL_Texture_2d);
   glBindTexture(GL_Texture_2d,Tx);
  end;
 if Self.Blend then
  begin
   glEnable(GL_Blend);
   glDepthMask(false);
  end;
 if Self.Ligth then glEnable(GL_Lighting);
 glBegin(GL_Triangles);
 glColor4f(1,1,1,1);
 for i:=0 to num_Faces do
 for j:=0 to 2 do
  begin
   gltexcoord2fv(@TexV[Tex[i][j]]);
   glNormal3fv(@Normal[Face[i][j]]);
   glvertex3fv(@Render_Vertex[Face[i][j]]);
  end;
 glEnd;
 if Self.Blend then begin glDepthMask(true);end;
end;

procedure TMesh.RenderRestore;
begin
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.Scale(F:Single);
Var i,j:integer;
begin
 for i:=0 to num_Vertex do
  Render_Vertex[i]:=multi(Render_Vertex[i],F);
end;

procedure TMesh.Translate(T:TPoint);
Var i:integer;
begin
 for i:=0 to num_Vertex do
  Render_Vertex[i]:=plus(Render_Vertex[i],T);
end;

procedure TMesh.Translate(X,Y,Z:single);
Var i:integer;
begin
 for i:=0 to num_Vertex do
  Render_Vertex[i]:=plus(Render_Vertex[i],Point(X,Y,Z));
end;

procedure TMesh.Rotate(Angs:TMatrix);
Var i,j:integer;
begin
 for i:=0 to num_Vertex do
  Render_Vertex[i]:=multi(Angs,Render_Vertex[i]);
end;

procedure TMesh.MeshRotate(Angs:TMatrix);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i]:=multi(Angs,Vertex[j][i]);
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.MeshScale(F:Single);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i]:=multi(Vertex[j][i],F);
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.MeshTranslate(T:TPoint);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i]:=plus(Vertex[j][i],T);
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.MeshTranslate(X,Y,Z:single);
Var i,j:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i]:=plus(Vertex[j][i],Point(X,Y,Z));
 Render_Vertex:=copy(Vertex[0]);
end;

procedure TMesh.MeshMirrorX;
Var i,j:integer;Temp:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i][0]:=-Vertex[j][i][0];
 for i := 0 to num_Faces do
 begin
  Temp:=Self.Face[i][0];
  Self.Face[i][0]:=Self.Face[i][2];
  Self.Face[i][2]:=Temp;
  Temp:=Self.Tex[i][0];
  Self.Tex[i][0]:=Self.Tex[i][2];
  Self.Tex[i][2]:=Temp;
 end;
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshMirrorY;
Var i,j:integer;Temp:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i][1]:=-Vertex[j][i][1];
 for i := 0 to num_Faces do
 begin
  Temp:=Self.Face[i][0];
  Self.Face[i][0]:=Self.Face[i][2];
  Self.Face[i][2]:=Temp;
  Temp:=Self.Tex[i][0];
  Self.Tex[i][0]:=Self.Tex[i][2];
  Self.Tex[i][2]:=Temp;
 end;
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshMirrorZ;
Var i,j:integer;Temp:integer;
begin
 for j:=0 to num_Anim do
 for i:=0 to num_Vertex do
  Vertex[j][i][2]:=-Vertex[j][i][2];   
 for i := 0 to num_Faces do
 begin
  Temp:=Self.Face[i][0];
  Self.Face[i][0]:=Self.Face[i][2];
  Self.Face[i][2]:=Temp;
  Temp:=Self.Tex[i][0];
  Self.Tex[i][0]:=Self.Tex[i][2];
  Self.Tex[i][2]:=Temp;
 end;
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshRotate90X(side:boolean);{90 digrees rotation on X of all mesh forward or bacward(true side is 1 false side is -1)}
Var
 i,j,s:integer;
 Temp:Single;
begin
 if side then s:=-1 else s:=1;
 for j:=0 to num_Anim do
 begin
  for i:=0 to num_Vertex do
   begin
    Temp:=Vertex[j][i][2];
    Vertex[j][i][2]:=s*Vertex[j][i][1];
    Vertex[j][i][1]:=s*-Temp;
   end;
 end;
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshRotate90Y(side:boolean);{90 digrees rotation on Y of all mesh forward or bacward(true side is 1 false side is -1)}
Var
 i,j,s:integer;
 Temp:Single;
begin
 if side then s:=-1 else s:=1;
 for j:=0 to num_Anim do
 begin
  for i:=0 to num_Vertex do
   begin
    Temp:=Vertex[j][i][2];
    Vertex[j][i][2]:=s*Vertex[j][i][0];
    Vertex[j][i][0]:=s*-Temp;
   end;
 end;
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.MeshRotate90Z(side:boolean);{90 digrees rotation on Z of all mesh forward or bacward(true side is 1 false side is -1)}
Var
 i,j,s:integer;
 Temp:Single;
begin
 if side then s:=-1 else s:=1;
 for j:=0 to num_Anim do
 begin
  for i:=0 to num_Vertex do
   begin
    Temp:=Vertex[j][i][1];
    Vertex[j][i][1]:=s*Vertex[j][i][0];
    Vertex[j][i][0]:=s*-Temp;
   end;
 end;
 Render_Vertex:=copy(Vertex[0]);
 Current_Anim:=0;
end;

procedure TMesh.set_val(Var s:string;M,c:byte;var i:Cardinal; var j:Cardinal;var z:Cardinal; var L:Cardinal);
begin
 if (S<>'') then
  case m of
   1:case c of
      0:begin     {vertex nums}
         num_Vertex:=StrToInt(S);
         num_anim:=L;
         SetLength(Vertex,num_Anim+1);
         SetLength(Vertex[L],num_Vertex+1);
         SetLength(Normal,num_Vertex+1);
         i:=0;
         z:=0;
        end;
      1:begin Vertex[L][i][0]:=StrToFloat(S); end; {x}
      2:begin Vertex[L][i][1]:=StrToFloat(S); end; {y}
      3:begin Vertex[L][i][2]:=StrToFloat(S);
        if (i<num_Vertex) then i:=i+1;end; {z}
      4:begin Face[j][0]:=StrToInt(S)-1; end; {a}
      5:begin Face[j][1]:=StrToInt(S)-1; end; {b}
      6:begin Face[j][2]:=StrToInt(S)-1;
        if (j<num_Faces) then j:=j+1;end; {c}
      10:begin      {faces num}
          num_Faces:=StrToInt(S);
          SetLength(Face,num_Faces+1);
          j:=0;
         end;
     end;
   3:case c of
      0:begin      {textures num}
         num_Tex_Vertex:=StrToInt(S);
         SetLength(TexV,num_Tex_Vertex+1);
         SetLength(Tex,num_Faces+1);
         i:=0;j:=0;
         L:=L+1;
        end;
      1:begin texV[i][0]:=StrToFloat(S); end; {x}
      2:begin texV[i][1]:=StrToFloat(S);
        if (i<num_Tex_Vertex) then i:=i+1;end; {y}
      4:begin tex[j][0]:=StrToInt(S)-1; end; {a}
      5:begin tex[j][1]:=StrToInt(S)-1; end; {b}
      6:begin tex[j][2]:=StrToInt(S)-1;
        if (j<num_Faces) then j:=j+1;end;{c}
     end;
   4:case c of
      1:begin Normal[i][0]:=StrToFloat(S); end; {x}
      2:begin Normal[i][1]:=StrToFloat(S); end; {y}
      3:begin Normal[i][2]:=StrToFloat(S);
        if (i<num_Vertex) then i:=i+1;end; {z}
     end;
  end;
 S:='';
end;

procedure TMesh.LoadFromMMSFile(FileName:String);
Var
 F:File of Char;
 i,j,z,l:cardinal;{counters}
 S:string;
 a:char;
 Mode:byte;{trigger}    {0-none       1-Vertex num(vc)}
                        {2-Faces num  3-textures num  }
                        {4-normals                    }
 cnt:byte;              {0- num       1-x 2-y 3-z     }
                        {4-a 5-b 6-c                  }
begin
 mode:=0;
 cnt:=0;
 i:=0;
 j:=0;
 z:=0;
 l:=0;
 AssignFile(F,FileName);
 Reset(F);
 S:='';
 Repeat
  a:='q';
  read(F,a);
  Case a of
   'e','E','0','1'..'9','-':S:=S+a;{numbers (with minus and point for float)}
   '.',',':S:=S+',';
   'X','x':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=1;end;
   'Y','y':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=2;end;
   'Z','z':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=3;end; {float vertex and texture coords}
   'A','a':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=4;end;
   'B','b':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=5;end;
   'C','c':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=6;end; {int faces and textures for them}
   'V','v':begin set_val(s,Mode,cnt,i,j,z,l);mode:=1;cnt:=0;end;{prefix col vertex}
   'F','f':begin set_val(s,Mode,cnt,i,j,z,l);mode:=1;cnt:=10;end;{prefix col faces}
   'N','n':begin set_val(s,Mode,cnt,i,j,z,l);if (mode<>4) then i:=0;mode:=4;cnt:=0;end;{prefix normal}
   'T','t':begin set_val(s,Mode,cnt,i,j,z,l);mode:=3;cnt:=0;end;{prefix texture}
   'q','Q':begin set_val(s,Mode,cnt,i,j,z,l);cnt:=0;mode:=3;end;{part of 'Tex' word}
   else begin set_val(s,Mode,cnt,i,j,z,l);cnt:=0;end;
  end;
 Until Eof(F);
 CloseFile(F);
 for i:=0 to num_Vertex do
  Normal[i]:=Normalize(Normal[i]);{ }
 SetLength(Render_Vertex,num_vertex+1);
 Render_Vertex:=copy(Vertex[0]);  
 Current_Anim:=0;
end;

procedure TMesh.Add_Load(Name:String);
Var LoadMesh:TMesh;
i,z,q:Integer;
begin
 LoadMesh:=TMesh.Create;
 LoadMesh.LoadFromMMSFile(Name);
 SetLength(self.Normal,self.num_Vertex+LoadMesh.num_Vertex+2);
 For z:=0 to self.num_anim do
  begin
   SetLength(self.Vertex[z],self.num_Vertex+LoadMesh.num_Vertex+2);
   q:=z;
   for i:=0 to LoadMesh.num_Vertex do
    begin
     if q>LoadMesh.num_anim then q:=LoadMesh.num_anim;{esli animacii v dobavlyaemom meshe men`she}
     self.Vertex[z][i+self.num_Vertex]:=LoadMesh.Vertex[q][i];
    end;
  end;
 SetLength(self.Tex ,self.num_Faces+LoadMesh.num_Faces+2);
 SetLength(self.Face,self.num_Faces+LoadMesh.num_Faces+2);
 For i:=0 to LoadMesh.num_Faces do
  begin
   Face[i+self.num_Faces][0]:=LoadMesh.Face[i][0]+self.num_Vertex;
   Face[i+self.num_Faces][1]:=LoadMesh.Face[i][1]+self.num_Vertex;
   Face[i+self.num_Faces][2]:=LoadMesh.Face[i][2]+self.num_Vertex;
   Tex[i+self.num_Faces][0]:=LoadMesh.Tex[i][0]+self.num_Tex_Vertex;
   Tex[i+self.num_Faces][1]:=LoadMesh.Tex[i][1]+self.num_Tex_Vertex;
   Tex[i+self.num_Faces][2]:=LoadMesh.Tex[i][2]+self.num_Tex_Vertex;
  end;
 SetLength(TexV,num_Tex_Vertex+LoadMesh.num_Tex_Vertex+2);
 For i:=0 to LoadMesh.num_Tex_Vertex do
  begin
   TexV[i+self.num_Tex_Vertex]:=LoadMesh.TexV[i];
  end;
 num_Vertex:=num_Vertex+LoadMesh.num_Vertex+1;
 num_Tex_Vertex:=num_Tex_Vertex+LoadMesh.num_Tex_Vertex+1;
 num_Faces:=num_Faces+LoadMesh.num_Faces+1;
 Render_Vertex:=copy(Vertex[0]);  
 Current_Anim:=0;
{}
end;

procedure TMesh.SaveMMSFile(name:string);
Var
 F:File of Char;
 i,j,z,l:cardinal;{counters}
 S:string;
 a:char;
 procedure Save_str(str:string);
 var q:byte;
  begin
   for q:=1 to Length(str) do
    begin
     a:=str[q];
     Write(F,a);
    end;
  end;
begin
 AssignFile(F,Name);
 Rewrite(F);
 for j:=0 to num_anim-1 do
 begin
 Save_str(' V');
 Save_str(intToStr(num_Vertex));
 Save_str(' F');
 Save_str(intToStr(num_Faces));
 Save_str(#13);
  for i:=0 to num_Vertex do
  begin
   Save_str('X'+floatToStrF(Vertex[j][i][0],ffGeneral,7,2));
   Save_str('Y'+floatToStrF(Vertex[j][i][1],ffGeneral,7,2));
   Save_str('Z'+floatToStrF(Vertex[j][i][2],ffGeneral,7,2));
  // Save_str(#13);
  end;
 Save_str(#13);
 Save_str(' tq'+intToStr(num_tex_vertex));
 end;
 j:=num_anim;
 begin
 Save_str(' V');
 Save_str(intToStr(num_Vertex));
 Save_str(' F');
 Save_str(intToStr(num_Faces));
 Save_str(#13);
  for i:=0 to num_Vertex do
  begin
   Save_str('X'+floatToStrF(Vertex[j][i][0],ffGeneral,7,2));
   Save_str('Y'+floatToStrF(Vertex[j][i][1],ffGeneral,7,2));
   Save_str('Z'+floatToStrF(Vertex[j][i][2],ffGeneral,7,2));
//   Save_str(#13);
  end;
 Save_str(#13);
 end;
 for i:=0 to num_Faces do
 begin
  Save_str(' a'+intToStr(Face[i][0]+1));
  Save_str(' b'+intToStr(Face[i][1]+1));
  Save_str(' c'+intToStr(Face[i][2]+1));
//  Save_str(#13);
 end;
 Save_str(#13);
 Save_str(' tq'+intToStr(num_tex_vertex));
 Save_str(#13);
 for i:=0 to num_tex_vertex do
 begin
  Save_str('tx'+floatToStrF(TexV[i][0],ffGeneral,7,2));
  Save_str('ty'+floatToStrF(TexV[i][1],ffGeneral,7,2));
//   Save_str(#13);
 end;
 Save_str(#13);
 for i:=0 to num_Faces do
 begin
  Save_str('ta'+intToStr(Tex[i][0]+1));
  Save_str('tb'+intToStr(Tex[i][1]+1));
  Save_str('tc'+intToStr(Tex[i][2]+1));
//  Save_str(#13);
 end;       
 for i:=0 to num_Vertex do
 begin
  Save_str('NX'+floatToStrF(Normal[i][0],ffGeneral,7,2));
  Save_str('NY'+floatToStrF(Normal[i][1],ffGeneral,7,2));
  Save_str('NZ'+floatToStrF(Normal[i][2],ffGeneral,7,2));
//   Save_str(#13);
 end;
 CloseFile(F);
end;

end.
