unit Use_Parts;     {particles mechanism}

interface

uses
 Global,
 Use_Geometry,
 OpenGl,
 Use_OpenGL;

const
  Max_Parts = 300;

type
  TPart = record
    Point:TPoint;
    Vector:TPoint;
    Size:Single;
    life:byte;
    tip:byte;
  end;
 {
  TParticle = record
    Point:TPoint;
    Vector:TPoint;
    life:byte;
    tip:byte;
  end;      }

procedure add_Particle(X,Y,Z,VX,VY,VZ:single;tip:byte;life:byte);    
procedure Render_Parts;
procedure Engine_Parts;

Var Parts:array [0..Max_Parts] of TPart;
 Wind:TPoint = (-0.01,-0.003,0);

implementation

procedure put_part(P:TPoint;Mash:single;tip,life:byte);
Var
  Size:single;
  A,B:byte;
begin
  case tip of
    0:begin    {iskri}
        A:=0;
        B:=0;
        size:=0.1+(50-life)*0.0015;
        glColor4f(5,5,5,life/50);
    end;            {ogon}
    1:begin
        A:=1;
        B:=0;
        size:=0.07+(40-life)*0.01;
        glColor4f(5,5,5,life/60);
    end;            
    2:begin          {dim}
        A:=0;
        B:=1;
        size:=0.1+(30-life)*0.01;
        glColor4f(5,5,5,life/10);
    end;{ogon}
    3:begin
        A:=1;
        B:=1;
        size:=0.02+(20-life)*0.01;
        glColor4f(5,5,5,life/10);
    end;{ogon}
  end;
 gltexcoord2f(A*0.5,B*0.5);
 glVertex3f((P[0]-Size)*Mash,(P[1]-Size)*Mash,P[2]*Mash);
 gltexcoord2f(A*0.5+0.5,B*0.5);
 glVertex3f((P[0]+Size)*Mash,(P[1]-Size)*Mash,P[2]*Mash);
 gltexcoord2f(A*0.5+0.5,B*0.5+0.5);
 glVertex3f((P[0]+Size)*Mash,(P[1]+Size)*Mash,P[2]*Mash);
 gltexcoord2f(A*0.5,B*0.5+0.5);
 glVertex3f((P[0]-Size)*Mash,(P[1]+Size)*Mash,P[2]*Mash);
end;


procedure Render_Parts;
Var i:integer;
begin
 glDepthMask(false);
 glDisable(GL_DEPTH_TEST);
 glBegin(GL_Quads);
 for i:=Max_Parts downto 0 do
   if Parts[i].life>0 then
    begin
     Put_Part(minus(Parts[i].Point,Point(KX,KY,0)),Mash,Parts[i].tip,Parts[i].life);
    end;
 glEnd;
 glEnable(GL_DEPTH_TEST);
 glDepthMask(true);
 {}
end;

procedure Engine_Parts;
Var i:integer;
begin
 for i:=0 to Max_Parts do
   if Parts[i].life>0 then
 begin
   Parts[i].life:=Parts[i].life-1;
   Parts[i].Point:=plus(Parts[i].Point,Parts[i].Vector);
   Parts[i].Point:=plus(Parts[i].Point,Wind);
   case Parts[i].tip of
    0:Parts[i].Vector[1]:=Parts[i].Vector[1]-0.002;{+gravity}
    1:if (Parts[i].life=5) then
      begin
        add_Particle(Parts[i].Point[0],Parts[i].Point[1],Parts[i].Point[2],
                Parts[i].Vector[0],Parts[i].Vector[1],Parts[i].Vector[2],2+Random(2),25);
      end;{ogon}
    2,3:;  {dim}
   end;
 end;
 {}
end;

procedure add_Particle(X,Y,Z,VX,VY,VZ:single;tip:byte;life:byte);
Var i:integer;
begin
 for i:=0 to Max_Parts do
  if Parts[i].life=0 then
   begin
    Parts[i].Point:=Point(X,Y,Z);   
    Parts[i].Vector:=Point(VX,VY,VZ);
    Parts[i].life:=life;
    Parts[i].tip:=tip;
    break;
   end;
 {}
end;

end.
