unit Use_Text;

interface

{
 0.001
 text work module
 menu class}

Uses
 Windows,
 Messages,
 SysUtils,
 Use_Geometry,
 OpenGL;

const
 Max_Texts = 40;

type
 TTextElement = record
  Text:string;
  Action:integer;
  Point:TVect;
  Size:TVect;
  Group:byte;
  alpha:byte;
  Visible:boolean;
  Checked:boolean;
 end;

 TOGLFont = class
    private
    public
    base_Font:integer;
    Max_Font:integer;
    device_generated,
    Textured:boolean;
    constructor Create(var ghDC:HDC);overload;
    constructor Create(var ghDC:HDC;fontfilename,fontname:PAnsiChar);overload;
    function IntToStr(X:integer):string;
    procedure Gen_device_Font(var ghDC:HDC;FontName:PAnsiChar);{   }
    procedure put_device_text(Str:string;X,Y:single);
    procedure put_texture_text(Str:string;X,Y:single);
    procedure Put_Text(Str:string;X,Y:single);  {     }
 end;

 TMenu = class
   private
    TECount:integer;
    procedure put_TE(text:TTextElement);
   public
    Shadowed:boolean;
    Text_Color,
    Active_Color,
    Shadow_Color:TPoint;
    Visible_Group:byte;
    font:TOGLFont;
    TE:array of TTextElement;
    constructor Create(glhDC:HDC);overload;  {rgb text and choosen text color}
    constructor Create(glHDC:HDC;fontfilename,FontName:PAnsiChar);overload;
    procedure Set_Shadow(r,g,b:byte);{rgb shadow color}
    procedure Set_Color(r,g,b:byte);{rgb text color}
    procedure Set_Active_Color(r,g,b:byte);{rgb active color}
    function add_text_element(Text:string;X,Y,SX,SY:single;Action,Group:byte):integer;
    procedure Anim;
    procedure Render;
    function Check(CX,CY:single;Checked:boolean):integer;
   end;

 function IntToStr(X:integer):string;

Var
 Menu:TMenu;

implementation

{------------- font class -----------}


function IntToStr(X:integer):string;
begin
 Str(X, result);
end;

constructor TOGLFont.Create(var ghDC:HDC);
begin
 base_Font:=1;
 Max_Font:=256;
 Self.Gen_device_Font(ghDC,'Comic Sans MS');
end;

constructor TOGLFont.Create(var ghDC:HDC;fontfilename,fontname:PAnsiChar);
begin
 base_Font:=1;
 Max_Font:=256;
 if fontfilename<>'' then
  begin
    AddFontResource(fontfilename);
    SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
    Self.Gen_device_Font(ghDC,fontname);
   // {$IFDEF WIN32}
  //  RemoveFontResource(PChar(fontfilename));
  //  {$ELSE}
  //  RemoveFontResource(StrPCopy(ss, fontfilename));
   // {$ENDIF}
   // SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
  end;
// Self.Gen_device_Font(ghDC);
end;

function TOGLFont.IntToStr(X:integer):string;
begin
 Str(X, result);
end;

procedure TOGLFont.Gen_device_Font(var ghDC:HDC;FontName:PAnsiChar);{   }
Var Font:HFont;
begin
 Font:=createFont(      { }
  -26,0,             //H,W -   -   Windows     
  0,0,                // 
  FW_NORMAL,          //FW_DONTCARE - 0, FW_NORMAL - 400, FW_BOLD - 700,  FW_BLACK - 900.
  0,                  // 
  0,                  // 
  0,                  // 
  DEFAULT_CHARSET,    //   (CHINESEBIG5_CHARSET, GREEK_CHARSET, RUSSIAN_CHARSET, DEFAULT_CHARSET,  ..)
  OUT_TT_ONLY_PRECIS,      //   OUT_TT_PRECIS-   - truetype ,OUT_TT_ONLY_PRECIS  Truetype
  CLIP_DEFAULT_PRECIS,
  ANTIALIASED_QUALITY,
  FF_DONTCARE or DEFAULT_PITCH,  //    ( - DEFAULT_PITCH, FIXED_PITCH  VARIABLE_PITCH)( - FF_DECORATIVE, FF_MODERN, FF_ROMAN, FF_SCRIPT, FF_SWISS, FF_DONTCARE)
  FontName);      //    { 'Comic Sans MS' }
 base_Font:=glGenLists(Max_Font);    {   }
 SelectObject(ghDC,Font);
 wglUseFontBitmaps(ghDC, 0, Max_Font, base_Font); {   }
 Self.device_generated:=true;
end;

procedure TOGLFont.put_device_text(Str:string;X,Y:single);
Var
 i:integer;
 S:Array [0..255] of byte;
 AP:Pointer;
begin
 if Str='' then Exit;            {   }
 For i:=1 to Length(Str) do
  S[i-1]:=byte(Str[i]);          {    }
 AP:=@S[0];
 glPushAttrib(GL_LIST_BIT);      //    
 glListBase(base_Font);         { }
 glRasterPos2f(X, Y);// 
 glCallLists(Length(str),GL_UNSIGNED_BYTE,AP);{ }
 glPopAttrib(); //    
end;

procedure TOGLFont.put_texture_text(Str:string;X,Y:single);
Var
 i:integer;
 S:Array [0..255] of byte;
 AP:Pointer;
begin
 if Str='' then Exit;            {   }
 For i:=1 to Length(Str) do
  S[i-1]:=byte(Str[i]);          {    }
 AP:=@S[0];
 glPushAttrib(GL_LIST_BIT);      //    
 glListBase(base_Font);         { }
 glRasterPos2f(X, Y);// 
 glCallLists(Length(str),GL_UNSIGNED_BYTE,AP);{ }
 glPopAttrib(); //    
end;

procedure TOGLFont.Put_Text(Str:string;X,Y:single);  {     }
begin
 if self.device_generated then
  self.put_device_text(Str,X,Y);
end;


{------------- menu class -----------}

constructor TMenu.Create(glhDC:HDC);
begin
 self.font:=TOGLFont.Create(glHDC);
 Self.Shadowed:=false;
 Self.Shadow_Color:=Point(0.2,0.2,0.2);
 Self.Text_Color:=Point(0.5,0.5,0.5);
 Self.Active_Color:=Point(5,0,0);
 TECount:=5;
 SetLength(TE,TECount+1);
end;

constructor TMenu.Create(glHDC:HDC;fontfilename,FontName:PAnsiChar);
begin
 self.font:=TOGLFont.Create(glHDC,fontfilename,FontName);
 Self.Shadowed:=false;
 Self.Shadow_Color:=Point(0.2,0.2,0.2);
 Self.Text_Color:=Point(0.5,0.5,0.5);
 Self.Active_Color:=Point(5,0,0);
 TECount:=5;
 SetLength(TE,TECount+1);
end;

procedure TMenu.put_TE(text:TTextElement);
begin
 if Text.Checked then
  glColor4f(Self.Active_Color[0],Self.Active_Color[1],Self.Active_Color[2],Text.alpha*0.05) else
   glColor4f(Self.Text_Color[0],Self.Text_Color[1],Self.Text_Color[2],Text.alpha*0.05);
 Font.put_Text(text.Text,text.Point[0],text.Point[1]);
 if Self.Shadowed then {with shadow}
  begin
   glColor4f(Self.Shadow_Color[0],Self.Shadow_Color[1],Self.Shadow_Color[2],Text.alpha*0.025);
   Font.put_Text(text.Text,text.Point[0]+0.05,text.Point[1]-0.05);
  end;
end;

procedure TMenu.Set_Shadow(r,g,b:byte);{rgb shadow color}
begin
 Self.Shadowed:=true;
 Self.Shadow_Color:=Point(5*r/255,5*g/255,5*b/255);
end;

procedure TMenu.Set_Color(r,g,b:byte);{rgb text color}
begin
 Self.Text_Color:=Point(5*r/255,5*g/255,5*b/255);
end;

procedure TMenu.Set_Active_Color(r,g,b:byte);{rgb active color}
begin
 Self.Active_Color:=Point(5*r/255,5*g/255,5*b/255);
end;

function TMenu.add_text_element(Text:string;X,Y,SX,SY:single;Action,Group:byte):integer;
Var i:integer;vis:boolean;
begin
 vis:=false;
 for i:=0 to TECount do
  if (TE[i].Text='') then
   begin
    vis:=true;{svobodnoye mesto naydeno}
    break;
   end;
 if not vis then {massiva  nedostatochno}
  begin
   i:=i+1;
   TECount:=TECount+10;{rasshiryaem massiv}
   SetLength(TE,TECount+1);
  end;
 TE[i].Text:=Text;   {addition of new Text element}
 TE[i].Point:=Vector(X,Y);
 TE[i].Size:=Vector(SX,SY);
 TE[i].Group:=Group;
 TE[i].alpha:=255;
 TE[i].Visible:=false;
 TE[i].Checked:=false;
 TE[i].Action:=Action;
 add_text_element:=i;
end;

procedure TMenu.Anim;
Var i:integer;
begin
 for i:=0 to TECount do      {ne plavnaya animaciya}
  if (TE[i].Group=Self.Visible_Group) then
   TE[i].Visible:=true else           {if Text element in visible Group then make them visible}
   TE[i].Visible:=false;
end;

procedure TMenu.Render;
Var i:integer;
begin
 Self.Anim;
 for i:=0 to TECount do               {drawning}
  if TE[i].Visible then
   put_TE(TE[i]);
end;

function TMenu.Check(CX,CY:single;Checked:boolean):integer;
Var i,Action:integer;
begin
 for i:=0 to TECount do
  if TE[i].Visible then
   if Point_in_Rect(Vector(CX,CY),TE[i].Point,plus(TE[i].Point,TE[i].Size)) then
    begin
     TE[i].Checked:=true;
     if Checked then
      Action:=TE[i].Action;
    end else
     TE[i].Checked:=false;
 Check:=Action;
end;

end.
