unit _Objects;

interface

Uses
  Use_OpenGl,
  opengl,
  Global,
  use_parts,
  Use_Geometry,
  Use_3d;

const
  Max_Planes=1000;
  Max_Bullets = 1000;
  Max_Enemies = 300;
  Max_Bonus = 300;

type
  TPlane = record
    real:boolean;
    Point:TVect;{position}
    tip:byte;
    Len:byte; {dlinna}
    _can_fall:boolean;{mogno prignut vniz}
  end;

  TEnemy = record
    Point:TVect;
    tip:byte;
    Life:integer;
    Reload:integer;
    ang,needang:single;
    platforma:integer;{platform numb}
    State:byte;{0-hide 1-stand and fire 2-run 3-jump}
    _stand:boolean;
    _hide:boolean;
    anim:integer;
  end;

  THero = record
    Point:TVect;
    Vector:TVect;
    Life,HP:integer;
    jump_faze:byte;
    Weapon:byte;{0-usual 1-fast 2-splash 3-rossip}
    Reload:byte;
    {for animation}
    Action:byte;{0-stand 1- jump 2- run etc 3-vis 4-podjem iz viseniya}
    R,run,
    u,d,
    can_fall:boolean;
    anim:integer;
    ang,need_ang:single;
  end;

  TBullet = record
    Point:TVect;
    Vector:TVect;
    tip:byte;
  end;

  TBonus = record
    Point:TVect;
    tip:byte;
  end;

  TLevel = record
   Plane:array [0..Max_Planes] of TPlane;
   Bullets:array [0..Max_Bullets] of TBullet;
   Enemy:Array[0.. Max_Enemies] of TEnemy;
   Bonus:Array[0.. Max_Bonus] of TBonus;
   Lev_begin,Lev_end:single;
  end;

procedure Put_Bullets();
procedure Put_Bonus();
procedure Put_Enemies();
procedure Put_Plane(Point:TVect;Len:byte;tip:byte);
procedure Put_Planes();
procedure put_hero();
function move_objects():byte;
function add_plane(X,Y:Single;Len,tip:byte;icf:boolean):integer;
procedure add_Bullet(X,Y,VX,VY:Single;tip:byte);
procedure add_Bonus(X,Y:Single;tip:byte);
procedure add_Enemy(X,Y:Single;tip,life:byte;platf:integer);
function Fire(X,Y,VX,VY:Single;tip:byte):byte;
function stm(x,y,z:single):TMatrix4f;overload;
function stm(x,y,z:single;M:TMatrix):TMatrix4f;overload;

Var
  Plane:array [0..Max_Planes] of TPlane;
  Bullets:array [0..Max_Bullets] of TBullet;
  Enemy:Array[0.. Max_Enemies] of TEnemy;
  Bonus:Array[0.. Max_Bonus] of TBonus;
  Lev_begin,Lev_end:single;
  Hero:THero;
  HeroSize:single = 0.1;
  Minigun:TMesh;
  m_Matrix:TMatrix4f;

implementation

procedure Put_Tile(X,Y,Z,M:single;i,j:byte;f:single);
begin
 glbegin(GL_Quads);
  gltexcoord2f(i*0.5+0.002,j*0.5+0.002);
  glvertex3f(-f/2+x*M,-f/2+y*M,Z*M);    {}
  gltexcoord2f(i*0.5+0.5-0.002,j*0.5+0.002);
  glvertex3f(+f/2+x*M,-f/2+y*M,Z*M);
  gltexcoord2f(i*0.5+0.5-0.002,j*0.5+0.5-0.002);
  glvertex3f(+f/2+x*M,+f/2+y*M,Z*M);
  gltexcoord2f(i*0.5+0.002,j*0.5+0.5-0.002);
  glvertex3f(-f/2+x*M,+f/2+y*M,Z*M);
 glend;
end;


function stm(x,y,z:single):TMatrix4f;overload;
begin
 stm[0,0]:=1; stm[1,0]:=0; stm[2,0]:=0; stm[3,0]:=x;
 stm[0,1]:=0; stm[1,1]:=1; stm[2,1]:=0; stm[3,1]:=y;
 stm[0,2]:=0; stm[1,2]:=0; stm[2,2]:=1; stm[3,2]:=z;
 stm[0,3]:=0; stm[1,3]:=0; stm[2,3]:=0; stm[3,3]:=1;
end;

function stm(x,y,z:single;M:TMatrix):TMatrix4f;overload;
begin
 stm[0,0]:=M[0,0]; stm[1,0]:=M[1,0]; stm[2,0]:=M[2,0]; stm[3,0]:=x;
 stm[0,1]:=M[0,1]; stm[1,1]:=M[1,1]; stm[2,1]:=M[2,1]; stm[3,1]:=y;
 stm[0,2]:=M[0,2]; stm[1,2]:=M[1,2]; stm[2,2]:=M[2,2]; stm[3,2]:=z;
 stm[0,3]:=0; stm[1,3]:=0; stm[2,3]:=0; stm[3,3]:=1;
end;

procedure Put_Plane(Point:TVect;Len:byte;tip:byte);
Var
i:integer;
z:Single;
m:TMatrix4f;
begin
 glColor4f(1,1,1,1);
 z:=Point[1]/5;
 case tip of
  0:begin  {land+grass}
      for i:=1 to Len do
       if i mod 2 = 1 then
       begin
          m:=stm(point[0]+i-1+0.5,point[1]-1,z+0.8);
        //  glPushMatrix();
          glLoadMatrixf(@m_Matrix);
          glMultMatrixf(@m);
          Rock.Render(Rock.Texture);
       end else
       begin
          m:=stm(point[0]+i-1+0.5,point[1]-1,z+0.8);
          glLoadMatrixf(@m_Matrix);
          glMultMatrixf(@m);
          Rock1.Render(Rock.Texture);
       end;
    end;
  1:begin                       {metall}
      for i:=1 to Len do
       if i mod 2 = 1 then
       begin
          m:=stm(point[0]+i-1+0.5,point[1]-1,z+0.8);
          glLoadMatrixf(@m_Matrix);
          glMultMatrixf(@m);
          Metall.Render(Metall.Texture);
       end else
       begin
          m:=stm(point[0]+i-1+0.5,point[1]-1,z+0.8);
          glLoadMatrixf(@m_Matrix);
          glMultMatrixf(@m);
          Metall1.Render(Metall.Texture);
       end;
    end;{stone}
  2:;{iron}
{  else begin
      for i:=1 to Len do
       put_cube(plus(Point,Vector(i-1,0)));
    end;
} end;
  if Len=0 then
  begin
    m:=stm(point[0]+0.5,point[1]-1,z+0.8);
    glLoadMatrixf(@m_Matrix);
    glMultMatrixf(@m);
    Metall1.Render(Metall.Texture);
  //  put_mall(Vector(0,0));
  end;
end;

procedure Put_Bonus();
Var
  i:integer;
  a,b:byte;
begin
 glPushMatrix();       
 glLoadMatrixf(@m_Matrix);
  glBindTexture(Gl_Texture_2d,_bonus);
  for i:=0 to Max_Bonus do
   if bonus[i].tip>0 then
    begin
     a:=(bonus[i].tip+1) mod 2;
     b:=trunc((bonus[i].tip+1)/2);
     Put_Tile(Bonus[i].Point[0]-kx,Bonus[i].Point[1]-ky,Bonus[i].Point[1]/5-0.125-kz,1,a,b,0.4);
    end;
 glPopMatrix();
end;

procedure Put_Planes();
Var
  i:integer;
  size:integer;
begin
 glGetFloatv(GL_MODELVIEW_MATRIX,@m_Matrix);
 glPushMatrix();
 size:=20;
 if Edit_Mode then   
  size:=400;
 for i:=0 to Max_Planes do
  if plane[i].real then
     if Point_in_Rect(
              plane[i].Point,
              plus(Hero.Point,Vector(-size-20,-size)),
              plus(Hero.Point,Vector(size,size))) then
   begin
     Put_Plane(plus(Vector(-kx,-ky),plane[i].Point),plane[i].Len,plane[i].tip);
   end;
 glPopMatrix();
end;


procedure put_hero();
Var x,y,z:single;
m:TMatrix4f;
begin
 x:=Hero.Point[0]-KX;
 y:=Hero.Point[1]-KY;
 z:=(Hero.Point[1]-KY)/5;
 glColor3f(0.2,0.2,1);
 glPushMatrix();
 m:=stm(x,y,z,rotate_Y(-Hero.ang));
 glLoadMatrixf(@m_Matrix);
 glMultMatrixf(@m);
 man.Render(man.Texture);
 glPopMatrix();
// man.Rotate(Rotate(Hero.ang,0,-1,0));
// minigun.Render(Minigun.Texture);
{ rock.Rotate(Rotate(Hero.ang,0,1,0));
 rock.Render(Rock.Texture);   }
end;

procedure Put_Enemies();
Var
  i:integer;
  z:single;       
  m:TMatrix4f;  
  size:integer;
begin
 glColor4f(1,1,1,1);
 glGetFloatv(GL_MODELVIEW_MATRIX,@m_Matrix);
 glPushMatrix();              
 size:=20;
 if Edit_Mode then   
  size:=400;
 for i:=0 to Max_Enemies do
    if (Enemy[i].tip>0) and (Enemy[i].Life>0) then
     if Point_in_Rect(
              Enemy[i].Point,
              plus(Hero.Point,Vector(-size,-size)),
              plus(Hero.Point,Vector(size,size))) then
     case Enemy[i].tip of
      1:begin {minigun}
          z:=Enemy[i].Point[1]/5-0.5;
          m:=stm(Enemy[i].Point[0]+0.5-kx,Enemy[i].Point[1]-1-ky,z+0.8-kz);
          glLoadMatrixf(@m_Matrix);
          glMultMatrixf(@m);
          Minigun.Anim(Enemy[i].anim/100);
          Minigun.Render(minigun.Texture);
       end;
      2:begin {Terminator}
          z:=Enemy[i].Point[1]/5-0.5;
          m:=stm(Enemy[i].Point[0]+0.5-kx,Enemy[i].Point[1]-1.01-ky,z+1-kz,rotate_Y(Enemy[i].ang));
          glLoadMatrixf(@m_Matrix);
          glMultMatrixf(@m);
          Terminator.Render(Terminator.Texture);
       end;
      3:begin {Robot}
          z:=Enemy[i].Point[1]/5-0.5;
          m:=stm(Enemy[i].Point[0]+0.5-kx,Enemy[i].Point[1]-1-ky,z+1-kz,rotate_Y(Enemy[i].ang));
          glLoadMatrixf(@m_Matrix);
          glMultMatrixf(@m);
          Rob.Anim(Enemy[i].anim/100);
          Rob.Render(Rob.Texture);
       end;
      4:begin {Peller}
          z:=Enemy[i].Point[1]/5-0.5;
          m:=stm(Enemy[i].Point[0]+0.5-kx,Enemy[i].Point[1]-1-ky,z+0.8-kz);
          Enemy[i].anim:=Enemy[i].anim+55;
          if (Enemy[i].anim>400) then Enemy[i].anim:=Enemy[i].anim-400;
          Peller.Anim(Enemy[i].anim/100);
          glLoadMatrixf(@m_Matrix);
          glMultMatrixf(@m);
          Peller.Render(Peller.Texture);
       end;
      5:begin {Vertolet}
        if Enemy[i].State=1 then
         begin
          z:=Enemy[i].Point[1]/5-0.5;
          m:=stm(Enemy[i].Point[0]+0.5-kx,Enemy[i].Point[1]-1.01-ky,z+1-kz,multi(rotate_Y(Enemy[i].ang),rotate_Z(30)));
          Enemy[i].anim:=Enemy[i].anim+55;
          if (Enemy[i].anim>400) then Enemy[i].anim:=Enemy[i].anim-400;
          Vert.Anim(Enemy[i].anim/100);
          glLoadMatrixf(@m_Matrix);
          glMultMatrixf(@m);
          Vert.Render(Vert.Texture);
         end;
       end;
     end;
 glPopMatrix();
end;
procedure Put_Bullets();
Var
  i:integer;
  a,b:byte;
begin
 glColor3f(5,5,5);
 for i:=0 to Max_Bullets do
  if Bullets[i].tip>0 then
   begin
    b:=trunc((Bullets[i].tip-1)/2);
    a:=(Bullets[i].tip-1) mod 2;
    {case Bullets[i].tip of
     1:begin
      a:=0;
      b:=0;
     end;
     2:begin
      a:=1;
      b:=0;
     end;
    end;   }
 //   Put_Sprite(Bullets[i].Point[0]-kx,Bullets[i].Point[1]-ky,1,0.1);
    Put_Tile(Bullets[i].Point[0]-kx,Bullets[i].Point[1]-ky,Bullets[i].Point[1]/5-0.125-kz,1,a,b,0.1);
   end;
end;

function Fire(X,Y,VX,VY:Single;tip:byte):byte;
Var Speed:single;i:byte;
begin
 fire:=0;
 if (Hero.Reload=0) then
 case tip of
  0:begin{usual}
    add_Bullet(X,Y,VX+Random(10)/1000-0.005,VY+Random(10)/1000-0.005,tip+1);
    Hero.Reload:=4;
  end;
  1:begin{fast}
    Speed:=1.3;
    add_Bullet(X,Y,VX*Speed,VY*Speed,tip+1);
    Hero.Reload:=3;
  end;
  2:begin{splash}
    Speed:=1.1;
    for i:=0 to 10 do
      begin
       add_Bullet(X,Y,VX*Speed+Random(10)/400-0.0125,VY*Speed+Random(10)/400-0.0125,tip+1);
      end;
    Hero.Reload:=35;
  end;
  3:begin{splash}
    Speed:=1.1;
    for i:=0 to 6 do
      begin
       add_Bullet(X,Y,VX*Speed+Random(10)/100-0.05,VY*Speed+Random(10)/100-0.05,tip+1);
      end;
    Hero.Reload:=20;
  end;
  11:begin {enemy bullets}
    Speed:=1.3;
    add_Bullet(X,Y,VX*Speed,VY*Speed,tip);
    fire:=11;
  end;
  12:begin {enemy rocket}
    Speed:=1.4;
    //for i:=0 to 3 do
      begin
       add_Bullet(X,Y,VX*Speed,VY*Speed+Random(100)/5000-0.01,tip);
      end;
    fire:=65;
  end;
  13:begin {enemy heli minigun}
    Speed:=1.4;
    //for i:=0 to 3 do
//    for i:=0 to 7 do
      begin
       add_Bullet(X,Y,VX*Speed,VY*Speed+Random(100)/10000-0.001,tip);
      end;
    fire:=24;
  end;
 end;
end;

function move_objects():byte;
Var
  i,j,q:integer;
  F_Point:TVector;
begin
 {hero}
 move_objects:=0;
 if Edit_Mode then
 begin           
  KX:=EX-1;
  KY:=EY;
  KZ:=EY/5;
 end
 else
 begin
 {hero}
 Hero.ang:=Get_R(Hero.ang+Head_Rotate(Hero.ang,Hero.need_ang,15));
 Hero.Vector:=plus(Hero.Vector,Vector(0,-0.005));
 F_Point:=plus(Hero.Point,Hero.Vector);
 if Hero.Reload>0 then
  Hero.Reload:=Hero.Reload-1;
 Hero.Action:=1;
 for i:=0 to Max_planes do
   if plane[i].real then
    begin //    
     if(F_Point[0]>=plane[i].Point[0]-HeroSize) and
       (F_Point[0]<=plane[i].Point[0]+plane[i].Len+HeroSize) and
       (Hero.Point[1]>=plane[i].Point[1]) and
       (plane[i].Len>0) and
       (F_Point[1]<=plane[i].Point[1]) then
      begin
        Hero.Point[1]:=plane[i].Point[1];
        Hero.Vector:=Vector(0,0);
        Hero.Action:=0;{end of the jump}
        //break;//??
        Hero.can_fall:=plane[i]._can_fall;
        Hero.jump_faze:=0;
      end;  //   
       if (not plane[i]._can_fall) then
       if(F_Point[0]>plane[i].Point[0]) and
       (F_Point[0]<plane[i].Point[0]+plane[i].Len) and
       (Hero.Point[1]<=plane[i].Point[1]-0.95) and
       (plane[i].Len>0) and
       (F_Point[1]>=plane[i].Point[1]-0.95) then
      begin
        Hero.Point[1]:=plane[i].Point[1]-0.95;
        Hero.Vector:=Vector(0,0);
        //break;//??
        Hero.can_fall:=plane[i]._can_fall;
      end;  //   
     if(F_Point[0]>=plane[i].Point[0]) and
       (F_Point[0]-0.1<=plane[i].Point[0]) and
       (Hero.Point[1]<plane[i].Point[1]) and
       (Hero.Point[1]>=plane[i].Point[1]-0.95) then
      begin
        Hero.Point[0]:=plane[i].Point[0];
        if (F_Point[1]<=plane[i].Point[1]-0.87) and
           (Hero.Point[1]>=plane[i].Point[1]-0.87) then
          begin
            Hero.Point[1]:=plane[i].Point[1]-0.869;
            Hero.Point[0]:=plane[i].Point[0];
            Hero.Vector:=Vector(0,0);
            Hero.Action:=3;{end of the jump}
            Hero.jump_faze:=0;
          end;
      //  Hero.jump_faze:=0;
      end;   //   
     if(F_Point[0]<=plane[i].Point[0]+plane[i].Len) and
       (F_Point[0]+0.1>=plane[i].Point[0]+plane[i].Len) and
       (Hero.Point[1]<plane[i].Point[1]) and
       (Hero.Point[1]>=plane[i].Point[1]-0.95) then
      begin
        Hero.Point[0]:=plane[i].Point[0]+plane[i].Len;
        if (F_Point[1]<=plane[i].Point[1]-0.87) and
           (Hero.Point[1]>=plane[i].Point[1]-0.87) then
          begin
            Hero.Point[1]:=plane[i].Point[1]-0.869;
            Hero.Point[0]:=plane[i].Point[0]+plane[i].Len;
            Hero.Vector:=Vector(0,0);
            Hero.Action:=3;{end of the jump}
            Hero.jump_faze:=0;
          end;
       // Hero.jump_faze:=0;
      end;
    end;
// if Hero.Vector[1]<0 then Hero.jump_faze:=16;

// if Hero.Point then
 Hero.Point:=plus(Hero.Point,Hero.Vector);
 if hero.Point[0]<Lev_Begin then
  Hero.Point[0]:=Lev_Begin;
 if hero.Point[0]>Lev_end then
  Hero.Point[0]:=Lev_end;
  KX:=KX*0.55+Hero.Point[0]*0.45;
  KY:=KY*0.55+Hero.Point[1]*0.45;
  KZ:=KZ*0.55+Hero.Point[1]/5*0.45;
 if KX-5<Lev_begin then kx:=lev_begin+4.9;
 if KX+5>Lev_end then kx:=lev_end-4.9;

 {hero animation}
 man.RenderRestore;
 case Hero.Action of
  0:begin
      //if Hero.a then
      //Hero.anim:=0;
     // man.Anim(Hero.anim/100);
      if hero.run then
      begin
        Hero.anim:=Hero.anim+20;
        if (Hero.anim>900) then Hero.anim:=100;
        if hero.u then  {up}
         man.Anim(Hero.anim/100) else
          if Hero.d then {down}
            man.Anim(20+Hero.anim/100) else
            man.Anim(10+Hero.anim/100);{center}
      end else
      begin
        if hero.u then      {up}
         man.Anim(32) else
        if hero.d then      {down}
         begin
          if Hero.anim>0 then Hero.anim:=-100;
          if Hero.anim<0 then
          Hero.anim:=Hero.anim+20;
          man.Anim(49+Hero.anim/100);
         end;
      end;
    end;
  1:begin
      if (Hero.anim<200) then
       Hero.anim:=Hero.anim+20;
      if Hero.anim>200 then Hero.anim:=100;
      man.Anim(Hero.anim/100);
      if hero.u then  {up}
       man.Anim(37+Hero.anim/100) else
        if Hero.d then {down}
          man.Anim(41+Hero.anim/100) else
          man.Anim(33+Hero.anim/100);{center}
    end;
  2:begin
      //if Hero.anim100 then Hero.anim:=1100;
    end;
  3:begin
       begin
          Hero.anim:=4600;
          man.Anim(Hero.anim/100);
       end;
    end;
 end;
 {bonuses}
 for i:=0 to Max_Bonus do
  if Bonus[i].tip>0 then  
  if Point_In_rect(Hero.Point[0],Hero.Point[1],
      Bonus[i].Point[0]-0.2,Bonus[i].Point[1]-0.5,
      Bonus[i].Point[0]+0.2,Bonus[i].Point[1]+0.2) then
 begin
  case bonus[i].tip of
   1:Hero.Weapon:=3;//Hero.HP:=40{Default_HP};
   2:Hero.Weapon:=1;//Hero.Weapon:=3;
   3:Hero.HP:=Default_HP;
   4:Hero.Weapon:=2;
  end;
  bonus[i].tip:=0;
 end;
 {bullets}
 for i:=0 to Max_Bullets do
  if Bullets[i].tip>0 then
   begin
    if bullets[i].tip=12 then Add_Particle(bullets[i].Point[0]+Random(100)/1000-0.05,bullets[i].Point[1]+Random(100)/1000-0.05
     ,Random(100)/4000-0.0125,Random(100)/4000-0.0125,-0.001,0,3,20);
    Bullets[i].Point:=plus(Bullets[i].Point,Bullets[i].Vector);
    if not Point_in_Rect(
              Bullets[i].Point,
              plus(Hero.Point,Vector(-20,-20)),
              plus(Hero.Point,Vector(20,20))) then
     Bullets[i].tip:=0;
    if Bullets[i].tip>=10 then
     if hero.d and (not Hero.run) then//sit
      begin
       if  Point_in_Rect(
               Bullets[i].Point,
               plus(Hero.Point,Vector(-0.2,0.02)),
               plus(Hero.Point,Vector(0.2,0.4))) then
       begin //Hero Hit
        Hero.HP:=Hero.HP-1;
        Bullets[i].tip:=0;
       end;
      end else   //stand
      if Point_in_Rect(
              Bullets[i].Point,
              plus(Hero.Point,Vector(-0.2,0.02)),
              plus(Hero.Point,Vector(0.2,0.7))) then
      begin //Hero Hit
       Hero.HP:=Hero.HP-1;
       Bullets[i].tip:=0;
      end;
   end;
 if (hero.HP<=0) or (Hero.Point[1]<-30) then
 begin
   for q:=0 to 30 do
    Add_Particle(Hero.Point[0]+0.5,Hero.Point[1]+0.5
    ,0,Random(100)/4000-0.0125,Random(100)/4000-0.0125,0,1,15);
  hero.HP:=Default_HP;
  hero.Point:=Vector(0,0);
  hero.Weapon:=0;
  hero.Action:=0;
 end;
 {enemies}
 for i:=0 to Max_Enemies do
  if (Enemy[i].tip>0) and (Enemy[i].Life>0) then
    if Point_in_Rect(
              Enemy[i].Point,
              plus(Hero.Point,Vector(-20,-20)),
              plus(Hero.Point,Vector(20,20))) then
    begin
     case Enemy[i].tip of
      1:begin {minigun}
         if (enemy[i].State=0) then Enemy[i]._hide:=true else
           Enemy[i]._hide:=false;
         if (Hero.Point[1]+0.2>Enemy[i].Point[1]) and
         (Hero.Point[1]-0.2<Enemy[i].Point[1]) and
         (Hero.Point[0]+5>Enemy[i].Point[0]) and
         (Hero.Point[0]<Enemy[i].Point[0]) then
         Enemy[i].State:=1;
         if (enemy[i].State=1) then Enemy[i].anim:=Enemy[i].anim+8;
         if (enemy[i].anim>400) or (enemy[i].State=2) then
         if (Hero.Point[1]+0.2>Enemy[i].Point[1]) and
         (Hero.Point[1]-0.2<Enemy[i].Point[1]) and
         (Hero.Point[0]+8>Enemy[i].Point[0]) and
         (Hero.Point[0]<Enemy[i].Point[0]) then
          begin {fire in hero}
           enemy[i].State:=2;
           if enemy[i].Reload>0 then enemy[i].Reload:=enemy[i].Reload-1 else
            enemy[i].Reload:=fire(Enemy[i].Point[0]-0.5,Enemy[i].Point[1]+0.6,-0.06,0,11);
           //
          end;
       end;
      2:begin {Terminator}
         case Enemy[i].State of
          0:begin
              Enemy[i].needang:=90;
              Enemy[i].Point[0]:=Enemy[i].Point[0]+0.015;
              if (Enemy[i].Point[0]>plane[Enemy[i].platforma].Point[0]+plane[Enemy[i].platforma].Len-0.6) then
               Enemy[i].State:=1;{}
            end;{go forward}
          1:begin
              Enemy[i].needang:=271;
              Enemy[i].Point[0]:=Enemy[i].Point[0]-0.015;
              if (Enemy[i].Point[0]<plane[Enemy[i].platforma].Point[0]-0.4) then
               Enemy[i].State:=0;   {}
            end;{go backward}
          2:;{fire}
         end;
         if (Hero.Point[1]+1.5>Enemy[i].Point[1]) and
         (Hero.Point[1]-1.5<Enemy[i].Point[1]) and
         (Hero.Point[0]+8>Enemy[i].Point[0]) and
         (Hero.Point[0]<Enemy[i].Point[0]) then
          begin {fire in hero}
           enemy[i].State:=2;
           Enemy[i].needang:=271;
           if enemy[i].Reload>0 then enemy[i].Reload:=enemy[i].Reload-1 else
            enemy[i].Reload:=fire(Enemy[i].Point[0]+0.2,Enemy[i].Point[1]+0.45,-0.06,0,12);
           end else
         if (Hero.Point[1]+1.5>Enemy[i].Point[1]) and
         (Hero.Point[1]-1.5<Enemy[i].Point[1]) and
         (Hero.Point[0]>Enemy[i].Point[0]) and
         (Hero.Point[0]-8<Enemy[i].Point[0]) then
          begin {fire in hero}
           enemy[i].State:=2;
           Enemy[i].needang:=90;
           if enemy[i].Reload>0 then enemy[i].Reload:=enemy[i].Reload-1 else
            enemy[i].Reload:=fire(Enemy[i].Point[0]+0.6,Enemy[i].Point[1]+0.5,0.06,0,12);
           end;
       end;
      3:begin {Robot}
         if (enemy[i].Life<=20) and (Enemy[i].State<>0) then
          begin
             move_objects:=1;
             for q:=0 to 50 do
              Add_Particle(Hero.Point[0]+0.5,Hero.Point[1]+0.5
              ,0,Random(100)/2000-0.025,Random(100)/2000-0.025,0,1,15);
          end;
         case Enemy[i].State of
          0:begin
            Enemy[i].Life:=250;
            Enemy[i].State:=1;
          end;
          1:begin
              Enemy[i].anim:=Enemy[i].anim+6;
              if Enemy[i].anim>=500 then Enemy[i].anim:=100;
              Enemy[i].needang:=90;
              if Random(255)=1 then
               Enemy[i].State:=3;
              if Random(255)=1 then
               add_enemy(Enemy[i].Point[0],Enemy[i].Point[1],4,3,0);

              Enemy[i].Point[0]:=Enemy[i].Point[0]+0.02;
              if (Enemy[i].Point[0]>plane[Enemy[i].platforma].Point[0]+plane[Enemy[i].platforma].Len-0.6) then
               begin
                Enemy[i].State:=2;{}
                add_enemy(Enemy[i].Point[0],Enemy[i].Point[1],4,3,0);
               end;
            end;{go forward}
          2:begin
              Enemy[i].anim:=Enemy[i].anim+6;
              if Enemy[i].anim>=500 then Enemy[i].anim:=100;
              Enemy[i].needang:=271; 
              if Random(255)=1 then
               Enemy[i].State:=3;
              if Random(255)=1 then
               add_enemy(Enemy[i].Point[0],Enemy[i].Point[1],4,3,0);
              Enemy[i].Point[0]:=Enemy[i].Point[0]-0.02;
              if (Enemy[i].Point[0]<plane[Enemy[i].platforma].Point[0]-0.4) then
               Enemy[i].State:=1;   {}
            end;{go backward}
          3..13:
            begin
               q:=trunc(Get_A(Enemy[i].Point,Hero.Point));
               enemy[i].State:= enemy[i].State+1;
               enemy[i].Reload:=fire(Enemy[i].Point[0]+0.5,Enemy[i].Point[1]+0.5,Get_X_V(q,0.03),Get_Y_V(q,0.03),13);{fire}
            end;
          14:Enemy[i].State:=1+Random(2);
         end;
       end;
      4:begin {Peller}
        case Enemy[i].State of
          0:begin {wait}
             if (Hero.Point[1]+5>Enemy[i].Point[1]) and
             (Hero.Point[1]-5<Enemy[i].Point[1]) and
             (Hero.Point[0]+5>Enemy[i].Point[0]) and
             (Hero.Point[0]-5<Enemy[i].Point[0]) then
             begin {fire in hero}
             enemy[i].State:=1;
             end;
             end;
          1..4:begin  {fire}
             if enemy[i].Reload>0 then enemy[i].Reload:=enemy[i].Reload-1 else
              begin
               q:=trunc(Get_A(Enemy[i].Point,Hero.Point));
               enemy[i].State:= enemy[i].State+1;
               enemy[i].Reload:=fire(Enemy[i].Point[0]+0.5,Enemy[i].Point[1]+0.5,Get_X_V(q,0.04),Get_Y_V(q,0.04),13);
              end;
            end;
          5..30: begin  {fire}
             if enemy[i].Reload>0 then enemy[i].Reload:=enemy[i].Reload-1 else
              begin
               q:=trunc(Get_R(Get_A(Enemy[i].Point,Hero.Point)+90));
               enemy[i].Point:=plus(Enemy[i].Point,Get_Vect(q,0.02));
               enemy[i].State:= enemy[i].State+1;
              end;
            end;
          31..45: begin  {fire}
             enemy[i].State:=0;{fire}
          end;
         end;
      end;          
      5:begin {Vertolet - proletaet sverhu}
         Enemy[i]._hide:=true;
         case Enemy[i].State of
          0:begin
             {wait hero}
             Enemy[i].Point:=plus(Plane[Enemy[i].platforma].Point,Vector(-10,4));
             if (Hero.Point[1]+0.5>Enemy[i].Point[1]-4) and
             (Hero.Point[1]-5.5<Enemy[i].Point[1]-4) and
             (Hero.Point[0]+1.5>Enemy[i].Point[0]+10) and
             (Hero.Point[0]-1.5<Enemy[i].Point[0]+10) then
              begin {fire in hero}
               enemy[i].State:=1;
              end;
            end;
          1:begin //fire from helicopter
             Enemy[i].Point[0]:=Enemy[i].Point[0]+0.12;
             if enemy[i].Reload>0 then enemy[i].Reload:=enemy[i].Reload-1 else
               enemy[i].Reload:=fire(Enemy[i].Point[0]+1,Enemy[i].Point[1]-0.5,0.07,-0.07,13);
             if enemy[i].Point[0]>Plane[Enemy[i].platforma].Point[0]+15 then
              enemy[i].State:=2;
            end;
          2:;//all done
         end;
       end;    
      10:begin {Exit}
         Enemy[i]._hide:=true;
             if (Hero.Point[1]>Enemy[i].Point[1]-4) and
             (Hero.Point[1]<Enemy[i].Point[1]+4) and
             (Hero.Point[0]>Enemy[i].Point[0]-4) and
             (Hero.Point[0]<Enemy[i].Point[0]+4) then
              begin {fire in hero}
                move_objects:=1;
               //Load_Level(Lev);
              end;//perehod na drugoi uroven
       end;
     end;
  {   case Enemy[i].tip of
      1:begin
        Enemy[i].anim:=Enemy[i].anim+6;
        if (enemy[i].anim>300) then enemy[i].anim:=0;

      end;
     end;        }
     enemy[i].ang:=Get_R(enemy[i].ang+Head_Rotate(enemy[i].ang,enemy[i].needang,10));
     for j := 0 to Max_Bullets do
      if (Bullets[j].tip>0) and (Bullets[j].tip<=10) then
      if Point_in_Rect(
              Bullets[j].Point,
              plus(enemy[i].Point,Vector(0.15,0.05)),
              plus(enemy[i].Point,Vector(0.55,0.65)))
        and (enemy[i].Life>0) and not enemy[i]._hide then
      begin {enemy dead}
        Bullets[j].tip:=0;
        Enemy[i].Life:=Enemy[i].Life-1;
        for q:=0 to 4 do
         Add_Particle(Bullets[j].Point[0],Bullets[j].Point[1]
          ,0,Random(100)/1000-0.05,Random(100)/1000-0.05,0,0,40);
        if (Enemy[i].Life=0) then
        for q:=0 to 20 do
         Add_Particle(Enemy[i].Point[0]+0.5,Enemy[i].Point[1]+0.5
          ,0,Random(100)/4000-0.0125,Random(100)/4000-0.0125,0,1,15);
         //
      end;
    end;
 end;  
end;

function add_plane(X,Y:Single;Len,tip:byte;icf:boolean):integer;
Var i:integer;
begin
 for i:=0 to Max_Planes do
  if not plane[i].real then
  begin
    plane[i].real:=true;
    plane[i].Point:=Vector(X,Y);
    plane[i].tip:=tip;
    plane[i].Len:=Len;
    plane[i]._can_fall:=icf;
    add_plane:=i;
    break;
  end;
end;

procedure add_Bullet(X,Y,VX,VY:Single;tip:byte);
Var i:integer;
begin
 for i:=0 to Max_Bullets do
  if Bullets[i].tip=0 then
  begin
    Bullets[i].Point:=Vector(X,Y);
    Bullets[i].Vector:=Vector(VX,VY);
    Bullets[i].tip:=tip;
    break;
  end;
end;

procedure add_Bonus(X,Y:Single;tip:byte);
Var i:integer;
begin
 for i:=0 to Max_Bullets do
  if Bonus[i].tip=0 then
  begin
    Bonus[i].Point:=Vector(X,Y);
    Bonus[i].tip:=tip;
    break;
  end;
end;

procedure add_Enemy(X,Y:Single;tip,life:byte;platf:integer);
Var i:integer;
begin
 for i:=0 to Max_Enemies do
  if Enemy[i].tip=0 then
  begin
    Enemy[i].Point:=Vector(X,Y);
    Enemy[i].tip:=tip;
    Enemy[i].Life:=life;
    Enemy[i].platforma:=platf;
    Enemy[i].ang:=90;     
    Enemy[i].needang:=90;
    Enemy[i].State:=0;
    Enemy[i].anim:=0;
   // Enemy[i]._hide:=false;
    //Bullets[i].tip:=tip;
    break;
  end;
end;

end.
