unit e_camera;

interface

uses OpenGL, e_types, e_global;

type
  TCamera = record
    eye, target, up : TPoint;
    fov, cull_near, cull_far : single;
  end;

var
  camera : TCamera = (fov : 30; cull_near : 0.1; cull_far : 300);
  camera_player_pos, camera_offset : TPoint;
  camera_offset_size : single = 0;
  camera_menu_pos : TPoint = (x : 5; y : -41; z : 0);
  camera_shift : single;

procedure MoveCamera(var c : TCamera);

implementation

uses
  e_game, e_main, e_logo;

procedure MoveCamera(var c : TCamera);
begin
with c do
  begin    
    up.x := 0; up.y := 1; up.z := 0;

    gluLookAt(camera_offset.x + eye.x, camera_offset.y + eye.y, eye.z,
              0.1 * camera_offset.x + target.x, 0.1 * camera_offset.y + target.y, target.z,
              up.x, up.y, up.z);
  end;
end;

end.

