unit e_gui_init;

interface

uses windows, e_gui, e_types, e_screen, e_game, e_global, e_textures, e_utils,
     e_sound, e_about, e_gui_utils, e_font;

procedure GUIEventMenu;

procedure GUIGenerateGame;
procedure GUIGenerateMenu;

var
  gui_mouse_right    : boolean = false;

implementation

uses e_main, e_particles, e_console;

var
  fullscreen_string  : TString;
  vsync_string       : TString;
  sound_string       : TString;
  music_string       : TString;
  sens_string        : TString;
  background_string  : TString;
  enemies_string     : TString;
  particles_string   : TString;
  map_string         : TString;
  logo_string        : TString;
  radar_string       : TString;
  options_changed    : boolean = false;

const
  gui_corner_size = 100;

// EVENTS

procedure GUIEventMenu;
begin
GUIHideAll;
menu_main    := true;
end;

//////

// EVENTS



procedure GUIGenerateGame;
var
i : integer;
begin
gui_active := @gui;

with GUIAddLabel(20, 25, 200, 200, 'life  ')^ do
  target := @game.player.life;

with GUIAddLabel(20, 55, 200, 200, 'score ')^ do
  target := @game.player.score;

if not render_debug then
  exit;

with GUIAddLabel(820, 630, 120, 120, 'score     ')^ do
  target := @game.player.score;
with GUIAddLabel(820, 650, 120, 120, 'life      ')^ do
  target := @game.player.life;
with GUIAddLabel(820, 670, 120, 120, 'pos       ')^ do
  target := @game.player.pos_i;
with GUIAddLabel(820, 690, 120, 120, 'map       ')^ do
  target := @game.player.map;
with GUIAddLabel(820, 710, 120, 120, 'stage     ')^ do
  target := @game.stage_progress;
with GUIAddLabel(820, 730, 120, 120, 'script    ')^ do
  target := @game.script;
with GUIAddLabel(820, 750, 120, 120, 'fps       ')^ do
  target := @fps;
end;

procedure GUIGenerateMenu;
var
i : integer;
list : PGUIList;
edit : PGUIEdit;
begin
gui_active := @gui_menu;


end;

end.
