unit e_gui_utils;

interface

uses e_gui, e_types, e_screen, e_global, e_font;

var
  gui_active : PGUIEngine;

  menu_main     : boolean;

procedure GUIHideAll;
function GUIAddStatic(t, x, y, sx, sy : integer) : PGUIStatic;
function GUIAddLabel(x, y, sx, sy : integer; s : string) : PGUILabel;
function GUIAddButton(x, y, sx, sy : integer; s : string) : PGUIButton;
function GUIAddEdit(x, y, sx, sy : integer; s : string) : PGUIEdit;
function GUIAddList(x, y, sx, sy, tx, ty : integer; mode : string = 'list') : PGUIList;
function GUIAddStrings(x, y, sx, sy, tx, ty : integer) : PGUIStrings;

implementation

procedure GUIHideAll;
begin
menu_active  := true;
menu_main    := false;
end;

function GUIAddElement(t : string; x, y, sx, sy, tx, ty : integer; s : string) : PGUIElement;
var
i : integer;
begin
with gui_active^ do
  begin
    i := AddElement(t, nil);
    result := @elements[i];
    with elements[i] do
      begin
        pos                 := GetPoint(x / 1024,  y / 768 * screen.aspect, 0);
        size                := GetPoint(sx / 1024, sy / 768 * screen.aspect, 1);
        text_pos            := GetPoint(tx / 1024, (ty - 20) / 768 * screen.aspect, 0);
        text                := s;
      end;
    elements[i].Initialize('');
  end;
end;

function GUIAddStatic(t, x, y, sx, sy : integer) : PGUIStatic;
begin
result := @TGUIStatic(GUIAddElement('static', x, y, sx, sy, 0, 0, '')^);
with result^ do
  texture := t;   
end;

function GUIAddLabel(x, y, sx, sy : integer; s : string) : PGUILabel;
begin
result := @TGUILabel(GUIAddElement('label', x, y, sx, sy, 0, 0, s)^);
end;

function GUIAddButton(x, y, sx, sy : integer; s : string) : PGUIButton;
var
tx, ty : integer;
begin
tx := 35;
ty := 50;

if x < 0 then
  tx := sx - tx;

result := @TGUIButton(GUIAddElement('button', x, y, sx, sy, tx, ty, s)^);

if x < 0 then
  result^.text_align := faRight;
end;

function GUIAddEdit(x, y, sx, sy : integer; s : string) : PGUIEdit;
var
tx, ty : integer;
begin
tx := 35;
ty := 50;

if x < 0 then
  tx := sx - tx;

result := @TGUIEdit(GUIAddElement('edit', x, y, sx, sy, tx, ty, s)^);

if x < 0 then
  result^.text_align := faRight;
end;

function GUIAddList(x, y, sx, sy, tx, ty : integer; mode : string = 'list') : PGUIList;
begin
result := @TGUIEdit(GUIAddElement(mode, x, y, sx, sy, tx, ty, '')^);
end;

function GUIAddStrings(x, y, sx, sy, tx, ty : integer) : PGUIStrings;
begin
result := @TGUIStrings(GUIAddElement('strings', x, y, sx, sy, tx, ty, '')^);
end;

end.
