unit e_level1;

interface

procedure UpdateScript(count : single);
function GetMap : string;
function GetText : string;
function GetObjects : string;

implementation

uses e_game, e_types, e_camera, e_utils, e_sound;

procedure UpdateScript(count : single);
var
b : boolean;
begin
b := false;

with game do
case script of
  0: begin
       StageParse(1);
       sounds[music1].Play;
       sounds[music2].Stop;
       label_stage1.alpha := 1.5;
       label_stage1.alpha_target := 1.5;
       player.radius := 0;
       player.visible := false;
       player.control := false;
       map_dots_size.x := 10;
       map_dots_size.y := 0.5;
       map_dots_speed  := -0.001;
       player.weapon := 0;
       color := GetColorB(100, 100, 100, 255);
       color_target := color;
       color_dots := color;
       color_dots_target := color_dots;
       camera_shift := 0;
       b := true;

       {script := 13;
       player.visible := true;
       player.control := false;
       player.speed.x := 0.1;
       player.control := true;
       map_dots_size := GetPoint(1, 1, 1);   }

       {script := 21;
       player.control := true;
       player.TrailsSet(1);
       player.pos.x := 1700;
       map_dots_amplitude := 0.1;
       map_dots_size.x := 3;
       map_dots_size.y := 3;
       color_dots_target := GetColor(1, 1, 1, 1);
       label_stage1.alpha_target := -0.1;     }
     end;
  1 : begin
        b := Wait(3);
      end;
  2 : begin
        color_dots_target := GetColor(1, 1, 1, 1);
        label_stage1.alpha_target := -0.1;
        b := player.pos.x > 420;
        SqrAspire(player.speed.x, 0.1, count * 0.0001);
      end;
  3 : begin
        Aspire(map_dots_size.x, 1, count * 0.002);
        if map_dots_size.x < 3 then
          Aspire(map_dots_size.y, 1, count * 0.0001);
        SqrAspire(player.speed.x, 0.03, count * 0.0001);
        b := map_dots_size.x < 2;
      end;
  4 : begin
        Aspire(map_dots_size.x, 1, count * 0.002);
        if map_dots_size.x < 3 then
          Aspire(map_dots_size.y, 1, count * 0.0001);
        Aspire(map_dots_amplitude, 0.1, count * 0.00005);

        b := player.pos.x > 530;
      end;
  5 : begin
        SqrAspire(player.speed.x, 0.3, count * 0.0003);
        b := player.pos.x > 609;
      end;
  6 : begin
        SqrAspire(player.speed.x, 0.01, count * 0.0015);
        Aspire(player.speed.x, 0.01, count * 0.00008);
        b := player.pos.x > 615;
      end;
  7 : begin
        player.jump_start := true;
        player.visible := true;
        player.radius := 0;
        b := true;
      end;
  8 : begin
        SqrAspire(player.speed.x, 0.1, count * 0.0001);
        b := player.pos.x > 670;
      end;
  9 : begin
        player.jump_start := true;
        b := true;
      end;
  10 : begin
        SqrAspire(player.speed.x, 0.1, count * 0.0001);
        b := player.pos.x > 730;
      end;
  11 : begin
        player.jump_start := true;
        b := true;
      end;
  12 : begin
        SqrAspire(player.speed.x, 0.1, count * 0.0001);
        b := player.pos.x > 790;
      end;
  13 : begin
        player.jump_start := true;
        b := true;
      end;
  14 : begin
        SqrAspire(player.speed.x, 0.1, count * 0.0001);
        b := player.pos.x > 812;
      end;
  15 : b := Aspire(player.speed.x, 0, count * 0.00003);
  16 : begin
        player.control := true;
        b := player.pos.x > 1075;
      end;
  17 : begin
        player.TrailsSet(1);
        player.jump_start := true;
        b := true;
      end;
  18 : b := player.pos.x > 1210;
  19 : begin
         player.weapon := 1;
         b := true;
       end;
  20 : b := player.pos.x > 1480;
  21 : begin
         player.color_base := GetColor(0, 0, 0, 1);
         player.color := GetColor(0.8, 0.4, 0, 1);
         color_target := GetColorB(115, 227, 234, 255);
         color_dots_target := GetColor(0, 0, 0, 1);
         b := true;
       end;
  22 : begin
         b := player.pos.x > 1760;
       end;
  23 : begin
         color_target := GetColor(-2, -2, -2, 1);
         color_dots_target := GetColor(-2, -2, -2, 1);
         Aspire(camera_shift, game_width * 1.5, count * 0.008);
         b := (color.r < 0) and (camera_shift > game_width * 1.3);
       end;
  24 : begin
         label_stage2.alpha_target := 1.5;
         b := label_stage2.alpha > 1.3;
       end;
  25 : begin
         stage_number := 2;
         script := 0;
       end;
end;

if b then
  inc(game.script);
end;

function GetMap : string;
var
text : string;
begin
// +n+ height
// -n- height
// %nn% space
text := '+0+!600!+0+%10%+5+%10%+5+%10%+0+!200!+0+';
text := text + '%50%-7-%10%-4-%50%-7-%90%+0+%50%';
text := text + '+5+%50%+3+%30%+4+!100!-1-!100!+0+';
text := text + '+0+%50%-3-%30%-4-%80%+5+%80%+5+%30%-5-!100!+0+';
text := text + '!100!+0+!100!+0+';

result := text;
end;

function GetText : string;
var
text : string;
begin
// #n# size
text := '%20%';
text := text + 'Hello there!';
text := text + ' Imagine a world somewhere.';
text := text + ' Simple, clean and fresh.';
text := text + ' Let''s go.';
text := text + '%20%';
text := text + ' But who wants it to be empty and static? Just a minute.';
text := text + '%20%';
text := text + ' It''s better now. Now you can...';
text := text + ' Hey! What is it?';
text := text + '%10%';
text := text + ' Something has changed.';
text := text + ' Something';
text := text + ' Has appeared.';
text := text + ' Something new, tiny, living.';
text := text + ' Pryo.';
text := text + '%20%';
text := text + '  Why did it come?';
text := text + ' Who knows...';
text := text + '%20%';
text := text + ' Look, Pryo has become older!';
text := text + ' Surely, everything grows, after all.';
text := text + ' And they are as well.';
text := text + '%20%';
text := text + ' H''m. It seems it''s time to bring something new? Let''s try to change anything.';
text := text + '%10%';
text := text + ' It''s looks awesome!';
text := text + '%35%';
text := text + ' I like it here. Welcome!';

result := text;
end;

function GetObjects : string;
var
text : string;
begin
// #n# bonus
// %nn% space
// !nnn! space
// *n* enemy
text := ' %10% #1##2##3# *2* %20% *2* #1##2##3# %10% #1##2##3# *1**1**1* ';

text := '!900!!350!*1*   *1*';
text := text + '%30%*1*  *1*  *1*  *2*';
text := text + '#4#';
text := text + '%50%*1*  *1*  *1*  *2*      *1*  *1*';
text := text + '#4#';
text := text + '%50%*1*  *1*  *1*  *2*      *1*  *1*  *1*';
text := text + '#2#';
text := text + '%50%*1*  *1*  *1*  *2*  *2*  *1*  *1*  *1*';
text := text + '#4#';
text := text + '%50%*1*  *1*  *1*  *2*  *2*  *1*  *1*  *1*';
text := text + '#4#';
text := text + '%50%*1*  *1*  *1*';
text := text + '#5#';
text := text + '%20%*1*  *1*  *1*';
text := text + '%20%*1*  *1*  *1*';

result := text;
end;

end.

