unit e_level2;

interface

procedure UpdateScript(count : single);
function GetMap : string;
function GetText : string;
function GetObjects : string;

implementation

uses e_game, e_types, e_camera, e_utils, e_sound;

procedure UpdateScript(count : single);
var
b : boolean;
begin
b := false;

with game do
case script of
  0: begin
       sounds[music1].Stop;
       sounds[music2].Play;
       player.control := false;
       player.pos.x := 30;
       player.map_min := player.pos.x;
       player.TrailsSet(1);
       if player.weapon <= 0 then
         player.weapon := 1;
       player.color := GetColor(0.8, 0.4, 0, 1);       
       player.color_base := GetColor(0, 0, 0, 1);
         
       StageClear; 
       StageParse(2);
       label_stage2.alpha := 1.5;
       label_stage2.alpha_target := -0.1;

       map_dots_size.x := 2;
       map_dots_size.y := 2;
       map_dots_speed  := -0.002;
       map_dots_amplitude := 0.1;
       
       color := GetColor(0, 0, 0, 1);
       color_dots := GetColor(0, 0, 0, 1);

       color_target := GetColorB(230, 210, 200, 255);
       color_dots_target := GetColor(1, 1, 1, 1);

       b := true;
     end;
  1 : begin
        SqrAspire(camera_shift, 0, count * 0.001);
        b := Aspire(camera_shift, 0, count * 0.005);
        player.pos.x := 30;
      end;
  2 : begin
        player.jump_start := true;
        player.control := true;
        b := true;
      end;
  3 : b := player.pos.x > 220;
  4 : begin
        player.jump_start := true;
        player.TrailsSet(3);
        b := true;
      end;
  5 : b := player.pos.x > 1180;
  6 : begin
        player.jump_start := true;
        player.TrailsSet(5);
        b := true;
      end;
  7 : if player.pos.x > 1330 then
        player.pos.x := 1330;    
end;

if b then
  inc(game.script);
end;

function GetMap : string;
var
text : string;
s : string;
h, a, i, x : integer;
begin
// +n+ height
// -n- height
// %nn% space
text := '+0+!100!+0+';
h := 0;
x := 0;

while x < 800 do
  begin
    a := 50 + random(50);
    x := x + a;
    text := text + '%' + inttostr(a) + '%';
    a := h + random(7) - random(7);
    if a > 7 then
      a := 7;
    if a < -9 then
      a := -9;
    s := '+';
    if a < 0 then
      s := '-';
    text := text + s + inttostr(abs(a)) + s;
    h := a;
  end;

a := 900 - x;
if a < 10 then
  text := text + '%0' + inttostr(a) + '%';
if (a > 10) and (a < 100) then
  text := text + '%' + inttostr(a) + '%';
if a > 100 then
  text := text + '!' + inttostr(a) + '!';
text := text + '%50%-5-!100!-5-!100!+0+%81%+0+';

result := text;
end;

function GetText : string;
var
text : string;
begin
// #n# size
text := '%50%';
text := text + ' I have a gift for you.';
text := text + ' Two gifts, actually.';
text := text + '%05%';
text := text + ' Cool!';

text := text + '%50%';
text := text + ' Do you love fireworks?';
text := text + ' Beautiful, blazing, fluffy fireworks.';

text := text + '%50%';
text := text + ' Anyway, you aren''t reading. It''s your problem.';
text := text + ' Because there is something ahead.';
text := text + ' I don''t know what it is, but I tried to warn you.';

text := text + '%50%';
text := text + ' Excellent, now we can continue.';
text := text + ' But we both know there is';
text := text + ' the end of the world ahead.';

result := text;
end;

function GetObjects : string;
var
text : string;
begin
// #n# bonus
// %nn% space
// !nnn! space
// *n* enemy

text := '';
text := text + '%50%#6#%10%#7#%10%#8#%10%#9#%10%';
text := text + '%10%*1*  *1* #4# *1*  *1* #4# *1*    #1#';
text := text + '%40%*1*  *1* #4# *1*  *1* #4# *1*    #2#';
text := text + '%20%*2*  *2* #5#';

text := text + '%90%*3*  *3*  *3* %10% #4# %10% *1*  *1*  *1* %10% #5# %10% *3*  *3*  *3*';
text := text + '%40%*3*  *3*  *3* #4# %10% *2* #4# *2* %10% #4# *3*  *3*  *3*  #6#';
text := text + '%40%*3* *1* *1* *3* *1* *1* *3* *1* *1* #4# %10% *2* *1* #5# *2* *1* %10% #4# *3* *1* *3* *1*  *3*';
text := text + '%45%#3#%10%#6#';
text := text + '%90%*1*   *1*   *1*   *3*  *3*  *3*  *3*  *3*   *1*   *1*   *1*   *3*  *3*  *3*  *3*  *3*   *2*    *2*';
text := text + '%90%#4#*1*   *1*   *1*   *2*  #5#  *1*   *1*   *1*  #4#';
text := text + '%30%*3*  *3*  *3*  *3*  *3*  *3*#5#';
text := text + '%40%*2*  *1*  *1*  *1*  *1*  *2*#4#';
text := text + '%70%*2*  *1*  *1*  *1*  *1*  *2*  *1*  *1*  *1*  *1* %30% #6# *1*  *1*  *1*';
text := text + '%50%*4*';

result := text;
end;

end.

