unit e_logo;

interface

uses OpenGL, e_models, e_textures, e_camera, e_types, e_utils, e_sound,
     e_gui, e_global, e_font;

const
  logo_time = 9000;

var
  logo_count   : single = 0;

procedure LogoInitialize;
procedure LogoRender;
procedure LogoUpdate(count : single);

implementation

procedure LogoInitialize;
var
i : integer;
begin
if not render_logo then logo_count := logo_time;
end;

procedure LogoRender;
var
i : integer;
s : single;
begin
//ViewPerspective(camera);
//MoveCamera(camera);
ViewOrtho;

glDisable(GL_LIGHTING);
glDisable(GL_DEPTH_TEST);
glEnable(GL_BLEND);
glEnable(GL_TEXTURE_2D);

//glBlendFunc(GL_SRC_ALPHA, GL_ONE);
glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

clear_color := GetColor(0, 0, 0, 1);

glColor4f(1, 1, 1, 1);

if logo_count < 5500 then
  begin
    if logo_count > 1000 then
      font.TextOut(8, 0, 0, 'OUEO factory:', faCenter)
    else
      font.TextOut(8, 0, 0, 'OUEO factory ', faCenter);

    if logo_count > 2000 then
      font.TextOut(5, 0, -1.5, 'Dmitry Grouzdev', faCenter);

    if logo_count > 3000 then
      font.TextOut(5, 0, -3, 'Kirill Zolovkin', faCenter);
  end
else
  begin
    if logo_count > 6500 then
      font.TextOut(8, 0, 0, 'Pryo.', faCenter)
    else
      font.TextOut(8, 0, 0, 'Pryo ', faCenter);
    if logo_count > 7500 then
      font.TextOut(5, 0, -1.5, '(prototype one)', faCenter);
  end;
end;

procedure LogoUpdate(count : single);
begin
logo_count := logo_count + count;
end;

end.
