// Game.cpp: implementation of the CGame class.
//
//////////////////////////////////////////////////////////////////////

#include "Game.h"
#include "GameAll.h"
#include "Player.h"
#include "Enemy.h"

#include <stdio.h>
#include <math.h>

#include "PLD3DEngine\D3DEngine.h"

CD3DEngine Engine;	
extern HWND hWnd;	// from main.cpp

#define NUM_MODELS 12			// Number of models in scene.
#define NUM_STARS 50			// Number of stars in scene.
#define SCREEN_LEFT_PLN -200	// Left border of game screen plane
#define SCREEN_WIDE_PLN 1000	// Wide of game screen plane
#define SCREEN_TOP_PLN 200
#define SCREEN_BOT_PLN -200
//#define NUM_TYPE_PLANETS 2


#define MAX_LEVELS 10

CPlayer Player;
CEnemy Enemy[MAX_ENEMY];

float GS = 0.0f;

int Global_Level[LEVEL_W*MAX_LEVELS][LEVEL_H]; //   (   )
int Level[LEVEL_W][LEVEL_H];		// 
int N_Level = 0;					// N 
//int lev_x_off=0;					//   

//int Level[LEVEL_W][LEVEL_H];

CVector Rocket;

float index_360 = 0.0f;


int t_out_x, t_out_y, t_out_l;
char nStats[255];



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGame::CGame()
{
	bDebugInfo = FALSE;
	bPause = FALSE;
	bSlowRender = FALSE;
		//TRUE;
	bMenu = TRUE;
	ActiveMenu = 0;
	bCredits = FALSE;
	
	//Engine.Screen.Width=1280;
	//Engine.Screen.Height=1024;
	//Engine.Screen.FullScreen=TRUE;
	Engine.Screen.Width=1024;
	Engine.Screen.Height=768;
	
}

CGame::~CGame()
{

}

// Func of approximate compare //
bool Approx (float test_num, float res_num, float approx) 
{
	if ((test_num > res_num - approx)&&(test_num < res_num + approx)) return true;
	else return false;
}


void GenerateEnemy()
{
	// GENERATE ENEMY //
	int n_enemy = N_Level;
	if (N_Level>MAX_ENEMY) n_enemy = MAX_ENEMY;
	for (int i=0;i<n_enemy;i++){
		Enemy[i].pos.x=rand()%(LEVEL_W*50+LEVEL_X_OFFSET);
		Enemy[i].pos.y=rand()%(LEVEL_H/2*50);
	}
}


void NewLevel(int nlev)
{
	/*sprintf(nStats,"Lev:%d; minx:%d; maxx:%d;", N_Level, 1*N_Level, 1*N_Level+LEVEL_W);
	MessageBox(NULL,nStats,"DOWN ERROR",MB_OK | MB_ICONINFORMATION);*/

	for (int y=0;y<LEVEL_H;y++){
		for (int x=0;x<LEVEL_W;x++){
			Level[x][y]=Global_Level[x+(LEVEL_W*N_Level)][y];
		}
	}

	GenerateEnemy();
}


void GenerateLevel()
{
	// NULL GLEVEL //
	// GENERATE BLOCKS //
	for (int y=0;y<LEVEL_H;y++){
		for (int x=0;x<LEVEL_W*MAX_LEVELS;x++){
			Global_Level[x][y] = 0;
		}
	}

	// GENERATE BLOCKS //
	int monetka;
	for (int y=0;y<LEVEL_H;y++){
		for (int x=0;x<LEVEL_W;x++){
			if (y < 10){
				monetka = rand()%7;  // chance of other objects on map.
				if ((int)monetka==1){
					//Level[x][y]=rand()%(NUM_PICES+1);
				} else Level[x][y]=0;
			}
		}
	}

	// LOAD LEVEL //
	FILE *filein, *fileout;
	char oneline[255];
	int file_x, file_y, file_typbl;

	if ((filein = fopen("level.lvl", "rt+")) == NULL)
	{
		MessageBox(NULL,"ERROR: NO LEVEL FILE!","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
	} else {
		while (!feof(filein)) {
		//FindStr(filein,"[cos(fi)]");
		ReadStr(filein, oneline);
		sscanf(oneline, "%d;%d;%d;", &file_x,&file_y,&file_typbl); //ReadStr(filein, oneline); Cos_fi = tmp_cf;
		Global_Level[file_x][file_y]=file_typbl;

		//sprintf(oneline,"%d;%d;%d;", file_x,file_y,file_typbl);
		//MessageBox(NULL,oneline,"DOWN ERROR",MB_OK | MB_ICONINFORMATION);*/
		};
		fclose(filein);
	}

}

void DrawLevel()
{
	char nStats[255];
	for (int y=0;y<LEVEL_H;y++){
		for (int x=0;x<LEVEL_W;x++){
//			sprintf(nStats, "pice:%d", Level[x][y]);
//			MessageBox(NULL, nStats, "Debug!", MB_OK);

			if (Level[x][y]>0){
//				sprintf(nStats, "x:%d,y:%d", x,y);
//				MessageBox(NULL, nStats, "Debug!", MB_OK);
			
				Engine.XObject[4+Level[x][y]].SetPosition(CVector(x*50+LEVEL_X_OFFSET,y*50,0));
				Engine.XObject[4+Level[x][y]].Draw(NULL);
			}
		}
	}

	for (int i=0;i<MAX_ENEMY;i++){
		Engine.XObject[10].SetPosition(Enemy[i].pos);
		Engine.XObject[10].Draw(NULL);
	}
}

void InitRocket()
{
	Rocket.x = -LEVEL_X_OFFSET*1.2f;
	Rocket.y = rand()%500;

}


void PlayerGo()
{
	Player.pos+=Player.vec*(0.1f*GS);

	if (Player.State==STATE_NORM) Player.vec=CVector(0,0,0);
	//if (Player.jump_index>-1) Player.jump_index-=1;
	if (Player.State==STATE_UP) {
		if (Player.jump_index>-1) Player.jump_index-=1;
		//		Player.jump_index-=1;//1.0f*GS;
		if (Player.jump_index<500) Player.vec=CVector(1,-1,0);
		if (Player.jump_index<0) Player.State=STATE_NORM;
	}


	int in;

	// PLAYER DISPLACE //
	int i_x[4],i_y[4];
	float f_x[4],f_y[4];
	int block_around_pl_x[4],block_around_pl_y[4];
	
	f_x[0] = (Player.pos.x-LEVEL_X_OFFSET-20)/50.0f;
	f_y[0] = (Player.pos.y-20)/50.0f;
	f_x[1] = (Player.pos.x-LEVEL_X_OFFSET+20)/50.0f;
	f_y[1] = (Player.pos.y-20)/50.0f;
	f_x[2] = (Player.pos.x-LEVEL_X_OFFSET-20)/50.0f;
	f_y[2] = (Player.pos.y+20)/50.0f;
	f_x[3] = (Player.pos.x-LEVEL_X_OFFSET+20)/50.0f;
	f_y[3] = (Player.pos.y+20)/50.0f;

	// ROUND X,Y //
	for (int i=0;i<4;i++){
		i_x[i] = int(f_x[i]);	i_y[i] = int(f_y[i]);
		if (fabs(f_x[i]-i_x[i])>0.5f) i_x[i]++;	if (fabs(f_y[i]-i_y[i])>0.5f) i_y[i]++;
		block_around_pl_x[i] = i_x[i];	block_around_pl_y[i] = i_y[i];
	}
		
	float tst_fl,tst_fl2;

	float intp;
	float fltp;
	float flx;
	/*flx = (Player.pos.x-LEVEL_X_OFFSET)/50.0f;
	fltp = fmodf(flx,intp);
	if (fabs(fltp)>0.5f) intp++;
	in = floorf(intp);
	tst_fl=round(flx);*/
		
	/*sprintf(nStats, "flx:%f; in:%d", flx, in);//Level[intp][0]);
	MessageBox(NULL, nStats, "Debug!", MB_OK);*/
		
	/*float plx1,plx2,ply1,ply2;
	plx1=Player.pos.x-25; plx2=Player.pos.x+25;
	ply1=Player.pos.y;	  ply2=Player.pos.y+50;*/
	/*int block_around_pl_x = in;//((Player.pos.x-LEVEL_X_OFFSET)/50.0f);
	int block_around_pl_y = Player.pos.y/50.0f;*/


		//float float_x = (float)Player.pos.x/50.0f;
	/*	t_out_x= block_around_pl_x[0];
		t_out_y=block_around_pl_y[0];
		t_out_l=Level[block_around_pl_x[0]][block_around_pl_y[0]];
	*/
	for (int i=0;i<4;i++){
		if (Level[block_around_pl_x[i]][block_around_pl_y[i]] > 0) {
			// JUMP //
			if (Player.State==STATE_UP){
				// STOP //	
				Player.State=STATE_NORM;
				Player.jump_index=-1;
			
				Player.vec=-Player.vec*5.0f;
				Player.pos+=Player.vec;
				//MessageBox(NULL, "Jump Move Stop!", "Debug", MB_OK);
			}

			// PLAYER MOVE LEFT-RIGHT //
/*			if ((Player.State==STATE_NORM)){//&&(Approx(Player.vec.x,1.0f,0.1f))){
					Player.vec=-Player.vec*5.0f;
					Player.pos+=Player.vec;
//					MessageBox(NULL, "Right Move Stop!", "Debug", MB_OK);
					/*Player.State==STATE_UP;
					Player.jump_index=1000;*/
			
//			}
		

		}
	}

	/*Engine.XObject[7].SetPosition(CVector(block_around_pl_x[0]*50+LEVEL_X_OFFSET,block_around_pl_y[0]*50,0));
	Engine.XObject[7].Draw(NULL);*/

		
	/*if (Player.State==STATE_LEFT){
		if (Level[block_around_pl_x][block_around_pl_y]!=0) Player.pos.x+=Player.vec*2.0f;
	}*/

	// PLAYER GRAVITY //
	int gravity_index = 50;
	if (Player.State!=STATE_UP)
	for (int i=0;i<gravity_index ;i++){
		Player.pos.y-=0.005f*GS;
		//block_around_pl_x = (Player.pos.x-LEVEL_X_OFFSET)/50.0f;
		//block_around_pl_y = Player.pos.y/50.0f;
		
		// ROUND X,Y //
		for (int i=0;i<4;i++){
			i_x[i] = int(f_x[i]);	i_y[i] = int(f_y[i]);
			if (fabs(f_x[i]-i_x[i])>0.5f) i_x[i]++;	if (fabs(f_y[i]-i_y[i])>0.5f) i_y[i]++;
			block_around_pl_x[i] = i_x[i];	block_around_pl_y[i] = i_y[i];
		
			if ((Level[block_around_pl_x[i]][block_around_pl_y[i]]>0)||(Player.pos.y<0)) {
				Player.pos.y+=0.01f*GS; 
				i=gravity_index; 
				// STOP //	
				Player.jump_index=-1;
			}
		}
	}


}



void CGame::LoadData()
{

}



void CGame::PressKey()
{
	if (Engine.Keyboard.Key[VK_ESCAPE]) SendMessage(hWnd,WM_CLOSE,0,0);
	if (Engine.Keyboard.Key[VK_UP])	{		
		Player.State=STATE_UP;
		if (Player.jump_index<0){
			// JUMP //
			Player.vec = CVector(1,2,0);
			Player.jump_index = 1000;
		} 
	
	}
	if (Engine.Keyboard.Key[VK_DOWN]){
		Player.State=STATE_DOWN;
	};	
	
	if (Engine.Keyboard.Key[VK_RIGHT])	{
		Player.vec.x=1; //Player.Go(); //if (1==1) Player.pos.x+=0.1f * GS;
		//Player.pos.x+=Player.vec.x;
		Player.State=STATE_NORM;
	}
	if (Engine.Keyboard.Key[VK_LEFT])	{
		Player.vec.x=-1; //Player.Go(); //if (1==1) Player.pos.x-=0.1f * GS;
		//Player.pos.x+=Player.vec.x;
		Player.State=STATE_NORM;
	}

	if (Engine.Keyboard.Key[VK_SPACE]) { 
		if (Player.State!=STATE_UP) Player.Fire(Player.pos);
		//MessageBox(NULL, "Fire!", "Debug", MB_OK);
	}

}


void CGame::Init()
{
	// GAME NEW //
	GenerateLevel();
	NewLevel(1);

	// LOAD MODELS //
	Engine.AddXObjects(NUM_MODELS);
	Engine.XObject[0].Load("Models/gg_011.x");
	Engine.XObject[0].SetOrientation(CVector(0,-90,0));
	Engine.XObject[0].SetPosition(CVector(0,0,0));
	//Engine.XObject[0].SetTextureMode(1,PL_TEX_SPHERE,PL_D3DTOP_ADDSIGNED2X);
	//Engine.XObject[0].LoadSecondTexture("second.bmp");
	//Engine.XObject[0].Visible=FALSE;

	Engine.XObject[1].Load("Models/gg_011up.x");
	Engine.XObject[1].SetOrientation(CVector(0,-90,0));
	Engine.XObject[1].SetPosition(CVector(0,0,0));
	//Engine.XObject[1].SetTextureMode(1,PL_TEX_SPHERE,PL_D3DTOP_ADDSIGNED2X);
	//Engine.XObject[1].LoadSecondTexture("second.bmp");
	//Engine.XObject[1].Visible=FALSE;

	Engine.XObject[2].Load("Models/gg_011dn.x");
	Engine.XObject[2].SetOrientation(CVector(0,-90,0));
	Engine.XObject[2].SetPosition(CVector(0,0,0));
	//Engine.XObject[2].SetTextureMode(1,PL_TEX_SPHERE,PL_D3DTOP_ADDSIGNED2X);
	//Engine.XObject[2].LoadSecondTexture("second.bmp");
	//Engine.XObject[2].Visible=FALSE;
	
	Engine.XObject[3].Load("Models/sky1.x");
	Engine.XObject[3].SetOrientation(CVector(0,0,0));
	Engine.XObject[3].SetPosition(CVector(0,-200,0));

	Engine.XObject[4].Load("Models/w1.x");
	Engine.XObject[4].SetOrientation(CVector(0,0,0));
	Engine.XObject[4].SetPosition(CVector(0,0,0));

	Engine.XObject[5].Load("Models/block1.x");
	Engine.XObject[5].SetOrientation(CVector(0,0,0));
	Engine.XObject[5].SetPosition(CVector(0,0,0));

	Engine.XObject[6].Load("Models/block2.x");
	Engine.XObject[6].SetOrientation(CVector(0,0,0));
	Engine.XObject[6].SetPosition(CVector(0,0,0));

	Engine.XObject[7].Load("Models/block3.x");
	Engine.XObject[7].SetOrientation(CVector(0,0,0));
	Engine.XObject[7].SetPosition(CVector(0,0,0));

	Engine.XObject[8].Load("Models/bul1.x");
	Engine.XObject[8].SetOrientation(CVector(0,0,0));
	Engine.XObject[8].SetPosition(CVector(30,20,-50));

	Engine.XObject[9].Load("Models/Rocket1.x");
	Engine.XObject[9].SetOrientation(CVector(0,-90,0));
	Engine.XObject[9].SetPosition(CVector(0,0,-50));

	Engine.XObject[10].Load("Models/En1.x");
	Engine.XObject[10].SetOrientation(CVector(0,-90,0));
	Engine.XObject[10].SetPosition(CVector(200,100,0));



	/*Engine.XObject[5].Load("Models/lev_gr.x");
	Engine.XObject[5].SetOrientation(CVector(0,0,0));
	Engine.XObject[5].SetPosition(CVector(0,0,0));*/


	// INIT FONTS //
	Engine.InitFonts(3);
	Engine.AddTxtBlocks(6);
	Engine.TxtBlock[0].Set(0,10,50,D3DCOLOR_ARGB(100,10,30,110),"!");
	//Engine.ChangeFont(0,"Arial",5);

	// SET CAMERA //
	Engine.Camera.SetWide(50.0f);
	Engine.Camera.SetPosition(CVector(0,300,-800));
	Engine.Camera.SetOrientation(CVector(0,0,0));
	Engine.Camera.SetDistanse(1, 2500);

	Engine.Fps.SetPoint();

	// INIT ROCKET //
	InitRocket();

}

void CGame::DrawAll()
{
	// Draw Level //
	DrawLevel();
	
	// Draw Player //
	Engine.XObject[Player.State].SetOrientation(CVector(cos(Player.play_breath),-90+sin(Player.play_breath)*5,cos(Player.play_breath)));
	//Engine.XObject[Player.State].SetOrientation(CVector(0,-90,0));
	Engine.XObject[Player.State].SetPosition(Player.pos+CVector(cos(Player.play_breath),sin(Player.play_breath),0));
	Engine.XObject[Player.State].Draw(NULL);

	// Draw bullets //
	for(int i=0;i<NUM_BULLETS;i++){
		if (Player.bullet[i].b_bullet){
			Engine.XObject[8].SetPosition(Player.bullet[i].pos);
			Engine.XObject[8].Draw(NULL);
		}
	}

	// Draw Rocket //
	Engine.XObject[9].SetOrientation(CVector(index_360*20,-90,0));
	Engine.XObject[9].SetPosition(CVector(Rocket.x,Rocket.y,50));
	Engine.XObject[9].Draw(NULL);

	// Draw ALL //
	for(int i=3;i<5;i++){
		if (Engine.XObject[i].Visible) Engine.XObject[i].Draw(NULL);
	}
	

}


void CGame::Move(float SPEED)
{
	// *** CALCULATE SPEED *** //
	GS = 900.0f / Engine.Fps.framerate; //1000.0f;
	if (GS>150.0f) GS = 1.0f;
	
	if (index_360 < 360.0f) index_360+=0.01f*GS; else index_360=0;

	// ROCKET FLY //
	Rocket.x-=0.5f*GS;
	if (Rocket.x<LEVEL_X_OFFSET) InitRocket();

	// PLAYER GO //
	if (Player.play_breath<360.0f) Player.play_breath+=0.01f*GS; else Player.play_breath=0;
	if (Player.pos.x>500) {
		// NEXT LEVEL //
		if (N_Level<10) {
			N_Level++;
			NewLevel(N_Level); //else ...
			Player.pos.x = -480;
		}
	}
	
	// PLAYER MOVE! //
	PlayerGo();
	
	// SKY ROTATE //
	Engine.XObject[3].SetOrientation(CVector(0,-Player.pos.x/15.0f,0));
	

	// PLAYER FIRE FLY //
	Player.FireFly(GS);
	
	// PLAYER & ROCKET //
	if (Approx(Rocket.x,Player.pos.x,20)&&(Approx(Rocket.y,Player.pos.y,20))) {
		Player.life--;//Player.State=STATE_DOWN;
		InitRocket();
	}

	// PLAYER LIFE //
	if (Player.life<0) Player.bDie=TRUE;

}


void CGame::Loop()
{
	//MessageBox(NULL,"ERROR: CP 3","OSHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
	
	char nStats[64];
	
	// LOGIC & MOVE //
	Move(1.0f);
	// SCAN KEY //
	PressKey();

	if (Engine.Fps.GetPoint()>0.0001f){
		Engine.Fps.SetPoint();
	}

	// TEXT //
	Engine.TxtBlock[1].Set(1, 10,10,D3DCOLOR_XRGB(200,190,50),itoa(Engine.Fps.fps,nStats,10));//nStats);
	Engine.Fps.GetPoint();
	/*sprintf(nStats, "mx=%d my=%d ts=%f gt=%f",Engine.Mouse.position.x,Engine.Mouse.position.y, Engine.Fps.set_point, Engine.Fps.time_elapsed);//Engine.Fps.gt);//set_point);
	Engine.TxtBlock[5].Set(0, 10,80,D3DCOLOR_XRGB(200,190,50),nStats);*/
	
	sprintf(nStats, " jump_i= %0.2f; State=%d", Player.jump_index, Player.State);
	Engine.TxtBlock[0].Set(0, 10,50,D3DCOLOR_XRGB(200,190,50),nStats);//nStats);

	sprintf(nStats, "X= %0.2f; Y= %0.2f; Z= %0.2f", 
		Engine.XObject[Player.State].Position.x,Engine.XObject[Player.State].Position.y,Engine.XObject[Player.State].Position.z);
	Engine.TxtBlock[2].Set(1, 10,80,D3DCOLOR_XRGB(100,200,100), nStats); // itoa(Pribor[0].limit,nStats,10));
	sprintf(nStats, "GS=%0.3f", GS);
	Engine.TxtBlock[3].Set(1, 10,110,D3DCOLOR_XRGB(200,50,0), nStats); // itoa(Pribor[0].limit,nStats,10));
	
	//sprintf(nStats, "xi=%d; yi=%d; lev[xi][yi]=%d", t_out_x,t_out_y,t_out_l);
	sprintf(nStats, "bx=%f; by=%f; bool=%d", Player.bullet[0].pos.x,Player.bullet[0].pos.y, Player.bullet[0].b_bullet);
	Engine.TxtBlock[4].Set(1, 10,150,D3DCOLOR_XRGB(0,0,0), nStats); // itoa(Pribor[0].limit,nStats,10));

	sprintf(nStats, " Life= %d", Player.life);
	Engine.TxtBlock[5].Set(0, 10,180,D3DCOLOR_XRGB(200,190,50),nStats);//nStats);

	
	// LOGIC //
	int step = 30;
	int Pr_lx[2];
	Pr_lx[0] = 105;
	Pr_lx[1] = 355;
	

	// DRAW //
	Engine.Fps.Calculate();
	Engine.StartDraw();
	DrawAll();
	Engine.Render();
	Engine.EndDraw();


	

}