// D3DEngine.cpp: implementation of the CD3DEngine class.
//
//////////////////////////////////////////////////////////////////////

#include "D3DEngine.h"
#include <iostream>

LPDIRECT3D9             g_pD3D          ; // Used to create the D3DDevice
LPDIRECT3DDEVICE9       g_pd3dDevice   ; // Our rendering device
D3DPRESENT_PARAMETERS d3dpp; 
D3DCAPS9 d3dCaps;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CD3DEngine::CD3DEngine()
{
	//XObject = new CXObject;
}

CD3DEngine::~CD3DEngine()
{

}

void CD3DEngine::AddXObjects(int nm)//char* xfilename)
{
	/*CXObject *Obj_temp = new CXObject;
	Obj_temp->Load(xfilename);
	XObject.push_back(Obj_temp);
	XObject[NumXObjects]->Visible=TRUE;
	NumXObjects = XObject.size();*/
	//delete Obj_temp;
//	MessageBox(NULL, "Control Point 3 ADDXOBJECT", "Debug!", MB_OK);

	XObject = new CXObject[nm];
	//XObject = new CXObject[1];
	//CXObject 
	//XObject[nm] = new(CXObject);
	NumXObjects= nm;
}

void CD3DEngine::AddTxtBlocks(int nm)
{
	TxtBlock = new CTxtBlock[nm];
	NumTxtBlocks = nm;
}

void CD3DEngine::ChangeFont(int n, TCHAR font_name[80], int font_size)
{
	//TCHAR ff[80];
	//ff = font_name;
	strcpy(TxtFont[n].m_strFontName, font_name);
	TxtFont[n].m_dwFontHeight = font_size;
	TxtFont[n].SetFont("Arial", 65, 0L);
	TxtFont[n].InitDeviceObjects(g_pd3dDevice);
	TxtFont[n].RestoreDeviceObjects();

	/*TxtFont[n] = CD3DFont(font_name, font_size, 0L);
	TxtFont[n]->InitDeviceObjects(g_pd3dDevice);
	TxtFont[n]->RestoreDeviceObjects();*/
}

/*void CD3DEngine::ChangeSecondFont(char*font_name, font_size)
{
	m_pFont = new CD3DFont(font_name, font_size, 0L);
	m_pFont->InitDeviceObjects(g_pd3dDevice);
	m_pFont->RestoreDeviceObjects();
}*/

void CD3DEngine::SetBackGrColor(D3DCOLOR new_color)
{
	BackGrColor = new_color;
}

HRESULT CD3DEngine::InitFonts(int nm)
{
	// Init Fonts //
	TxtFont = new CD3DFont[nm];//("Arial", 14, 0L)[nm];
	for (int i=0;i<nm;i++)	{
		TxtFont[i].SetFont("Arial", 14, 0L);
		TxtFont[i].InitDeviceObjects(g_pd3dDevice);
		TxtFont[i].RestoreDeviceObjects();
	}

	/*m_pFont = new CD3DFont("Arial Black", 14, 0L);
	m_pFont->InitDeviceObjects(g_pd3dDevice);
	m_pFont->RestoreDeviceObjects();

	FontMenu = new CD3DFont("Comic Sans MS", 54, 1L);
	FontMenu->InitDeviceObjects(g_pd3dDevice);
	FontMenu->RestoreDeviceObjects();

	FontMenuSm = new CD3DFont("Arial", 34, 2L);
	FontMenuSm->InitDeviceObjects(g_pd3dDevice);
	FontMenuSm->RestoreDeviceObjects();*/
	
	return S_OK;
}

void CD3DEngine::LightOn()
{
	D3DLIGHT9 d3dLight;
	HRESULT   hr;

	 // Turn on ambient lighting 
	g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, TRUE );
    //g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 0x00505050 );
	 g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 
        D3DCOLOR_COLORVALUE( 0.25, 0.25, 0.25, 1.0 ) );


	// Initialize the structure.
	ZeroMemory(&d3dLight, sizeof(d3dLight));

	// Set up a white point light.
	d3dLight.Type = D3DLIGHT_DIRECTIONAL;// D3DLIGHT_POINT;
	d3dLight.Diffuse.r  = 0.9f;
	d3dLight.Diffuse.g  = 0.9f;
	d3dLight.Diffuse.b  = 0.9f;
	d3dLight.Ambient.r  = 0.1f;
	d3dLight.Ambient.g  = 0.1f;
	d3dLight.Ambient.b  = 0.1f;
	d3dLight.Specular.r = 1.0f;
	d3dLight.Specular.g = 1.0f;
	d3dLight.Specular.b = 1.0f;

	// Position it high in the scene and behind the user.
	// Remember, these coordinates are in world space, so
	// the user could be anywhere in world space, too. 
	// For the purposes of this example, assume the user
	// is at the origin of world space.
	d3dLight.Position.x = -100.0f;
	d3dLight.Position.y = 1000.0f;
	d3dLight.Position.z = -50.0f;

	// Don't attenuate.
	d3dLight.Attenuation0 = 0.9f; 
	d3dLight.Range        = 1450.0f;

	D3DXVECTOR3 vecDir;
	vecDir = D3DXVECTOR3(-0.5f, -0.4f, 0.5f);
	D3DXVec3Normalize( (D3DXVECTOR3*)&d3dLight.Direction, &vecDir );

	// Set the property information for the first light.
	hr = g_pd3dDevice->SetLight(0, &d3dLight);
	hr = g_pd3dDevice->LightEnable(0, TRUE);
	
}


HRESULT CD3DEngine::Init( HWND hWnd )
{
    // INIT //
	NumXObjects = 0;
	NumTxtBlocks = 0;

	// INIT D3D //
	
	// Create the D3D object.
    if( NULL == ( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

    // Set up the structure used to create the D3DDevice. Since we are now
    // using more complex geometry, we will create a device with a zbuffer.
 //   D3DPRESENT_PARAMETERS d3dpp; 
    ZeroMemory( &d3dpp, sizeof(d3dpp) );
//    d3dpp.Windowed = FALSE;
	d3dpp.Windowed = !Screen.FullScreen;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = Screen.Mode; //D3DFMT_UNKNOWN;
	d3dpp.BackBufferWidth = Screen.Width;
	d3dpp.BackBufferHeight = Screen.Height;
	d3dpp.BackBufferCount = Screen.DepthBufCount;
    d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	if (Screen.FullScreen){
		d3dpp.FullScreen_RefreshRateInHz = Screen.RefreshRate; // Not handling multiple refresh rates yet
		d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	}
	else
	{
		d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
			//D3DPRESENT_INTERVAL_DEFAULT;
		d3dpp.FullScreen_RefreshRateInHz = 0;
	}
	
	d3dpp.SwapEffect = D3DSWAPEFFECT_FLIP;



    // Create the D3DDevice
	// Hardvare VP If Possible
	if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  //D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  D3DCREATE_HARDWARE_VERTEXPROCESSING,
								//D3DCREATE_PUREDEVICE,//Screen.UseTnL,
                                      &d3dpp, &g_pd3dDevice)))
    { 
		// else Software VP If Possible
		if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                      D3DCREATE_MIXED_VERTEXPROCESSING,
                                      &d3dpp, &g_pd3dDevice ) ) )
		{
			if ( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  //D3DCREATE_PUREDEVICE,
                                      &d3dpp, &g_pd3dDevice ) ) )
				return E_FAIL;
		}
		
		/*MessageBox(NULL, "Control Point 2", "Debug!", MB_OK);
		return E_FAIL;*/
    }

	//MessageBox(NULL, "Control Point 2", "Debug!", MB_OK);

	//g_pd3dDevice->Present(NULL, NULL, NULL,

	// Turn on the zbuffer
    g_pd3dDevice->SetRenderState( D3DRS_ZENABLE, TRUE );

    // Turn on ambient lighting 
	/*g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, TRUE );
    g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 0x00505050 );*/
	

	// One Side Faces
	g_pd3dDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);

	// Store device Caps
    g_pd3dDevice->GetDeviceCaps( &d3dCaps );
		
	//	MessageBox(NULL, "Control Point 3", "Debug!", MB_OK);
	LightOn();
	//g_pd3dDevice->ShowCursor(FALSE);
	//g_pd3dDevice->ShowCursor(TRUE);
	

	// Init Timer
	DXUtil_Timer( TIMER_RESET );
	DXUtil_Timer( TIMER_START );

	//InitFonts();

	// Assume d3dDevice is a valid pointer to an IDirect3DDevice9 interface.


	return S_OK;
}


HRESULT CD3DEngine::Resize( HWND hWnd )
{
	
//	CleanUp();
		// Delete d3d device
/*	if( g_pd3dDevice != NULL )
        g_pd3dDevice->Release();

    // Delete d3d 9
	if( g_pD3D != NULL )
        g_pD3D->Release();

	if (FAILED(g_pd3dDevice->Reset(&d3dpp))) return E_FAIL;

	Init(hWnd);

	D3DVIEWPORT9 viewData;
	RECT r, m_rcWindowBounds;
	HRESULT hr;
	
	GetWindowRect( hWnd, &m_rcWindowBounds );
	

	GetClientRect(hWnd, &r);
	viewData.X = 0;
	viewData.Y = 0;
	viewData.Width = r.right - r.left;
	viewData.Height = r.bottom - r.top;
	viewData.MinZ = 0.0f;
	viewData.MaxZ = 1.0f;

	hr = g_pd3dDevice->SetViewport(&viewData);
*/

	return S_OK;
}




//-----------------------------------------------------------------------------
// Name: Cleanup()
// Desc: Releases all previously initialized objects
//-----------------------------------------------------------------------------
VOID CD3DEngine::CleanUp()
{

	// Delete Textures & XObjects
/*	for(int n=0; n<NumXObjects; n++ ) {
		if( XObject[n].MeshTextures )
	    {
		    for( DWORD i = 0; i < XObject[n].NumMaterials; i++ )
			{
				if( XObject[n].MeshTextures[i] )
					XObject[n].MeshTextures[i]->Release();
			}
			delete[] XObject[n].MeshTextures;
		}

		if( XObject[n].Mesh != NULL ) XObject[n].Mesh->Release();

	}
*/
	// Delete d3d device
	if( g_pd3dDevice != NULL )
        g_pd3dDevice->Release();

    // Delete d3d 9
	if( g_pD3D != NULL )
        g_pD3D->Release();

	 //!!!m_pFont->DeleteDeviceObjects();

}


//-----------------------------------------------------------------------------
// Name: SetupMatrices()
// Desc: Sets up the world, view, and projection transform matrices.
//-----------------------------------------------------------------------------
VOID CD3DEngine::SetupMatrices()
{
    // For our world matrix, we will just leave it as the identity
    ////D3DXMATRIXA16 matWorld;
    D3DXMatrixRotationY( &matWorld, timeGetTime()/3000.0f );
    g_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );

    // Set up our view matrix. A view matrix can be defined given an eye point,
    // a point to lookat, and a direction for which way is up. Here, we set the
    // eye five units back along the z-axis and up three units, look at the 
    // origin, and define "up" to be in the y-direction.
    //D3DXVECTOR3 vLookat

	D3DXVECTOR3 vEyePt( Camera.Position.x, Camera.Position.y, Camera.Position.z);
    D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 1.0f );//( Camera.LookAt.x, Camera.LookAt.y, Camera.LookAt.z );
	D3DXVECTOR3 vZVec ( 0.0f, 0.0f, 1.0f );
	D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
	
    D3DXMATRIXA16 matView;
	D3DXMATRIXA16 matRotateX, matRotateY, matRotateZ;

	// Set Matrices to 1
	D3DXMatrixIdentity(&matRotateX);
	D3DXMatrixIdentity(&matRotateY);
	D3DXMatrixIdentity(&matRotateZ);

	// Rotate Matrix
	D3DXMatrixRotationX( &matRotateX, Camera.Angle.x/57.2f);
	D3DXMatrixRotationY( &matRotateY, Camera.Angle.y/57.2f);
	D3DXMatrixRotationZ( &matRotateZ, Camera.Angle.z/57.2f);
	
	// Compress 2 Matrices in 1; MatX = MatX & MatY
	matRotateX *= matRotateY;


	// Create vLookatPt From vZVec Rotation
	D3DXVec3TransformCoord(&vLookatPt, &vZVec, &matRotateX);
	// Rotate vUpVec Around Z
	//D3DXVec3TransformCoord(&vUpVec, &vUpVec, &matRotateZ);
	
	// vLookatPt = vEyePt + vLookatPt
	D3DXVec3Add(&vLookatPt, &vEyePt, &vLookatPt );

	// Correct Rotation & Set LookAt
	if ((fabs(Camera.Angle.x) < 90)||(fabs(Camera.Angle.x) >= 270))
		D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );
	else
		D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &-vUpVec );

	// If LookAt Mode ON Then Set
	if (Camera.bLookAt) {
		D3DXVECTOR3 vLookAt (Camera.LookAt.x, Camera.LookAt.y, Camera.LookAt.z);
		vUpVec = D3DXVECTOR3(0,0,1);
		D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookAt, &vUpVec );
	}
	
    g_pd3dDevice->SetTransform( D3DTS_VIEW, &matView );

	Camera.LookAt.x = vLookatPt.x;
	Camera.LookAt.y = vLookatPt.y;
	Camera.LookAt.z = vLookatPt.z;

    // For the projection matrix, we set up a perspective transform (which
    // transforms geometry from 3D view space to 2D viewport space, with
    // a perspective divide making objects smaller in the distance). To build
    // a perpsective transform, we need the field of view (1/4 pi is common),
    // the aspect ratio, and the near and far clipping planes (which define at
    // what distances geometry should be no longer be rendered).
    D3DXMATRIXA16 matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, /*D3DX_PI/4*/ Camera.Wide/57.2f, (float)Screen.Width/Screen.Height, Camera.DisNear, Camera.DisFar );
    g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );
}



//-----------------------------------------------------------------------------
// Name: StartDraw()
// Desc: Start Draws the scene
//-----------------------------------------------------------------------------
VOID CD3DEngine::StartDraw()
{
	
	FLOAT fElapsedAppTime = DXUtil_Timer( TIMER_GETELAPSEDTIME );
	Fps.havetime = fElapsedAppTime;
	GM_SPEED = Fps.havetime*50.0f;


	// Calculate FPS
	Fps.Calculate();
	
	// Clear the backbuffer and the zbuffer
    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, 
                         /*D3DCOLOR_XRGB(0,100,155)*/BackGrColor, 1.0f, 0L );

    
    // Begin the scene
    //if( SUCCEEDED( 
	g_pd3dDevice->BeginScene(); // ) )


}


//-----------------------------------------------------------------------------
// Name: Render()
// Desc: Draws the scene
//-----------------------------------------------------------------------------
VOID CD3DEngine::Render()
{
/*    int i;

	FLOAT fElapsedAppTime = DXUtil_Timer( TIMER_GETELAPSEDTIME );
	Fps.havetime = fElapsedAppTime;
	GM_SPEED = Fps.havetime*50.0f;


	// Calculate FPS
	Fps.Calculate();
	
	// Clear the backbuffer and the zbuffer
    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, 
                         BackGrColor, 1.0f, 0L );

    
    // Begin the scene
    if( SUCCEEDED( g_pd3dDevice->BeginScene() ) )
    {*/
        // Setup the world, view, and projection matrices
        SetupMatrices();
		
		int i;

		// ? Camera.Set(...);

	char stmp[50];
		// Draw All XObjects
		/*!!! for(i=0; i<NumXObjects; i++ ){
			if ( XObject[i].Visible ) {
				//MessageBox(NULL, "DRAW!", "D3DENGINE.Render!", MB_OK);
				XObject[i].Draw(NULL);
	
				sprintf(stmp,"N MODEL %d\n", i);
				//MessageBox(NULL, stmp, "D3DENGINE.Render!", MB_OK);
			}
		}
		!!!*/
		
		// Far Call Game Loop
//		Game.Loop();
	
		// *** TEXT BLOCK *** //
		for(i=0; i<NumTxtBlocks; i++ ){
			if ( TxtBlock[i].Visible ) 
			TxtFont[TxtBlock[i].N_Font].DrawText(TxtBlock[i].x, TxtBlock[i].y, TxtBlock[i].color, TxtBlock[i].txt);
		}
		 
        // End the scene
  /*      g_pd3dDevice->EndScene();

    //}
    // Present the backbuffer contents to the display
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );*/
//	MessageBox(NULL, "Control Point 4 Just RENDER", "Debug!", MB_OK);
}

VOID CD3DEngine::EndDraw()
{
	// End the scene
    g_pd3dDevice->EndScene();
    
    // Present the backbuffer contents to the display
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );

}


