#ifndef ONCE_BULLETS
#define ONCE_BULLETS

#include "Lists.h"
#include "Animators.h"
#include "PlayerClass.h"

struct Bullet
{
	WeaponInfo *Weapon;

	Vector2f Position;

	float Damage;
	float Angle;
	float AngleSpin;
	float Scale;

	int ID;
	int HitID;

	bool Processed;
	bool Enemy;

	bool Rotate;

	GravityAnimator EffectGravity;
};

class BulletsClass
{
	private :
		bool Trigger;
		void CheckHit(Bullet* b0, Bullet* b1);

	public :
		BulletsClass();

		int BulletID;
		int HitsCount;

		SieveList <Bullet> List;

		void AddBullet(WeaponParams& Weapon);
		void AddEnemyBullet(WeaponParams& Weapon, Vector2f& Target, Vector2f& Direction);

		void Update(float Time, float dT);
		void Render();
};

#endif