#ifndef ONCE_ENEMIES
#define ONCE_ENEMIES

#include ".\hge\include\hgefont.h"	

#include "Globals.h"
#include "Lists.h"
#include "Weapons.h"
#include "Bullets.h"

enum EnemiesKinds
{
	TURREL_STATIC_RIFLE = 0,
	TURREL_STATIC_MINI = 1,
	TURREL_STATIC_BALL = 2
};

class Enemy abstract
{
	public :
		hgeFont *Font;
		hgeSprite *Image;	

		Vector2f Position;
		Vector2f Velocity;

		WeaponParams Weapon;
		bool Fire;

		float Life;

		Enemy();
		~Enemy();

		bool CheckFire(Vector2f& Target);

		virtual void Update(Vector2f& Target, float dT);
		virtual bool CheckHit(Vector2f& Point) abstract;
		virtual void Render() abstract;
};

class EnemyStaticTurrel : public Enemy
{
	void Update(Vector2f& Target, float dT);
	bool CheckHit(Vector2f& Point);
	void Render();
};

class EnemiesClass
{
	public :
		hgeFont *Font;
		
		EnemiesClass();
		~EnemiesClass();

		SolidList <HTEXTURE> Textures;
		SieveList <Enemy> List;

		BulletsClass *Bullets;
			
		bool LoadResources();

		void Update(Vector2f& Target, float dT);
		void Render();

		void AddEnemy(EnemiesKinds Kind, Vector2f& Position);
		void AddEnemyStaticTurrel(EnemiesKinds Kind, Vector2f& Position);
};

#endif