#include <math.h>

#include "Globals.h"

HGE *hge = NULL;
bool SHOW_INFO = false;

/* -- Vector functions -- */

void VectorNormalize(Vector2f& v)
{
	float n = VectorLength(v);
	VectorDivide(v, n);
}

float VectorAngle(Vector2f& v)
{
	Vector2f t = { v[0], v[1] };

	VectorNormalize(t);

	if (t[0] == 0.0f) return t[1] * M_PI_2;
	else return atan2(t[1], t[0]);
}

float VectorLength(Vector2f& v)
{
	return sqrt(v[0] * v[0] + v[1] * v[1]);
}

void VectorDivide(Vector2f& v, float n)
{
	if (n != 0.0f)
	{
		v[0] /= n;
		v[1] /= n;
	}
}

/* -- Routine functions -- */

int round (const float t)
{
	if (t >= 0.0)
	    return (int) (t + 0.5);
	else
		return (int) (t - 0.5);
};

int random (const int t)
{
	float v = (float) rand() * (float) t / (float) RAND_MAX;
	return round(v); 
};

float random (const float t)
{
	float v = (float) rand() * t / (float) RAND_MAX;
	return v; 
};