#ifndef ONCE_LEVEL_CLASS
#define ONCE_LEVEL_CLASS

#include ".\hge\include\hgefont.h"
#include ".\hge\include\hgesprite.h"

#include ".\tinyxml\include\tinyxml.h"

#include "PlayerClass.h"
#include "Animators.h"
#include "Bullets.h"
#include "Enemies.h"
#include "Lists.h"

const float FADE_IN_TIME	= 1.0f;
const float FADE_OUT_TIME	= 0.5f;

enum LevelStates
{
	LEVEL_STATE_STARTUP,
	LEVEL_STATE_GAME,
	LEVEL_STATE_FINISH,
	LEVEL_STATE_CLEANUP
};

class LevelClass
{
	private :		
		HTEXTURE BackgroundTex;
		hgeSprite *Background;

		HTEXTURE ForegroundTex;
		hgeSprite *Foreground;

		HTEXTURE BordersTex;
		hgeSprite *Borders;


		LevelStates State;

		SolidList <PlateStruct> Plates;

	public :
		hgeFont *Font;

		LevelClass();
		~LevelClass();

		float LevelScore;
		float LevelLength;
		float LevelPosition;
		float LevelStarted;
		float LevelTime;
		float LevelWave;
		int LevelID;

		Vector2f StartPosition;
		WeaponsKinds StartWeapon;

		bool SpacePressed;
		bool LevelLoaded;

		PlayerClass *Player;
		BulletsClass *Bullets;
		EnemiesClass *Enemies;
		LinearAnimator EffectFade;
		LinearAnimator EffectWait;

		int PlatesCountBlue;

		void SetLevelPosition(float PlayerX);
		void Update(float Time, float X, float Y, float dT);
		void UpdateScore();
		void UpdateGrounds();
		void UpdatePlayerHits();
		void UpdateEnemiesHits();
		
		void Render();
		void RenderInfo();
		void RenderBack();
		void RenderFront();
		void RenderPlates();
		void RenderScore();
		DWORD MakeColor(float t, float dt);
		void LevelClass::RenderColored(float x, float& y, float t, float& dt, char *Text);

		// void RenderArtefact();

		bool LoadLevel(const char *LevelName, int ID);
		bool LoadResources();
};



#endif
