#ifndef ONCE_PLAYER_CLASS
#define ONCE_PLAYER_CLASS

#include ".\hge\include\hge.h"
#include ".\hge\include\hgesprite.h"

#include "Globals.h"
#include "Animators.h"
#include "Weapons.h"

struct PlateStruct
{
	Vector2f Corner;
	float Width;
	int Repeat;
	bool Red;
	bool Blue;
};

class PlayerClass
{
	public :
		PlayerClass();
		~PlayerClass();

		HTEXTURE BodyTex;
		hgeSprite *Body;

		WeaponParams Weapon;
		GravityAnimator EffectGravity;

		Vector2f Position;
		Vector2f Velocity;
		Vector2f Speed;

		float Life;
		bool RedPlate;

		bool FallDown;
		float FallGround;

		float BodyAngle;
		float BodyRadius;

		void Render();
		void Update(float Time, float dT);
		void SetWeaponAngle(float dT, float X, float Y);

		void SetPosition(float X, float Y);
		void SetPosition(Vector2f& Position);

		bool LoadWeapon(int Index, char *WeaponName, char *BulletName);
		bool LoadResources();
};


#endif