#ifndef ONCE_WEAPONS
#define ONCE_WEAPONS

#include ".\hge\include\hgesprite.h"

#include "Globals.h"
#include "Lists.h"

enum WeaponsKinds
{
	WEAPON_RIFLE = 0,
	WEAPON_MINI  = 1,
	WEAPON_BALL  = 2
};

struct WeaponSector
{
	float Min, Max;

	WeaponSector(float m0, float m1) 
		{ Min = m0; Max = m1; }
};

struct WeaponInfo
{
	WeaponsKinds Kind;
	char *Name;

	HTEXTURE WeaponTex;
	hgeSprite *WeaponSprite;

	HTEXTURE BulletTex;
	hgeSprite *BulletSprite;
	
	float WeaponLength;
	float WeaponDamage;
	
	float EnemyPeriod;
	float PlayerPeriod;

	int WeaponStraight;

	float BulletSpeed;
	float BulletGravity;
	float BulletRadius;
	float BulletThrottle;
	float BulletFriction;
	float BulletBreaking;
	float BulletTangential;

	int BulletHits;

	SolidList <WeaponSector> WeaponSectors;
};

struct WeaponParams
{
	WeaponInfo *Info;

	Vector2f Direction;
	Vector2f Position;
	Vector2f Offset;

	float Angle;
	float Time;
};

extern WeaponInfo WeaponsInfo[3];
void InitializeWeapons();

#endif