unit S_Dura; //     

interface
uses
  Omega, S_materials;

type
  T_TDura = record  //  
    Speed : single;
    Live  : word;   //   .
    Power : byte;   //   .
  end;

  T_Dura = record   // 
    X, Y,           //   
    Speed : single;
    Live  : word;   //   .
    T     : byte;   //  / 
    Enabled : boolean;
  end;

  T_PDura = record    //   
    X, Y,             //   
    LiveA : single;   // .
    T     : byte;     //  / 
    S     : shortint;
  end;

var
  TDura : array[1..5] of T_TDura;
  Dura  : array       of T_Dura;
  PDura : array       of T_PDura;

procedure Init;
procedure Fire(X, Y : single; T : byte; pX : shortint);  //  
procedure Work;
procedure Draw;

implementation
uses
  S_map, S_game, S_ai, Live;

procedure Init;
begin
  TDura[1].Speed:=6;
  TDura[1].Live :=500;
  TDura[1].Power:=12;

  TDura[2].Speed:=8;
  TDura[2].Live :=500;
  TDura[2].Power:=10;

  TDura[3].Speed:=8;
  TDura[3].Live :=200;
  TDura[3].Power:=12;

  TDura[4].Speed:=8;
  TDura[4].Live :=500;
  TDura[4].Power:=8 ;

  TDura[5].Speed:=5;
  TDura[5].Live :=500;
  TDura[5].Power:=5;
end;

procedure Fire(X, Y : single; T : byte; pX : shortint);  //  
var
  J, I : integer;
begin
  I:=-1;
  for J:=0 to length(Dura)-1 do
  if not Dura[J].Enabled then
    begin
      I:=J;
      Break;
    end;
  if I=-1 then
    begin
      I:=length(Dura);
      SetLength(Dura, I+1);
    end;

  Dura[I].Speed:=pX*TDura[T].Speed;

  Dura[I].Y:=Y;
  Dura[I].X:=X+Dura[I].Speed;

  Dura[I].T:=T;
  Dura[I].Live:=TDura[T].Live;
  Dura[I].Enabled:=True;
end;

procedure Work;
var
  I, I2 : integer;
  kX, kY : word;
begin
  for I:=0 to length(Dura)-1 do
  with Dura[I] do
  if Enabled then
    begin
      X:=X+Speed;
      Dec(Live);
      
      kX:= round( X+S_map.Ed_X        )  div S_map.Ed_X-1;
      kY:= round( Y+S_Map.Ed_Y        )  div S_map.Ed_Y-1;

      if (Live<1) or (X<0) or(kX>Map.MofKlX) or (not KlNoClip(kX, kY, round(Y))) then
      Enabled:=false
      else
      for I2:=0 to Map.MofBot-1 do
        if  (BotP2[I2].Live>11)
        and (X>Map.Bot[I2].X+10)
        and (X<Map.Bot[I2].X+BotT[Map.Bot[I2].T].W-10)
        and (Y>Map.Bot[I2].Y+4)
        and (Y<Map.Bot[I2].Y+BotT[Map.Bot[I2].T].H-4)
        then
          begin
            Enabled:=false;

            if Map.Bot[I2].T<5 then
              begin
                BotP2[I2].Animation:=4;
                if BotP2[I2].Live-TDura[T].Power<=11 then
                BotP2[I2].Live:=11
                else
                dec(BotP2[I2].Live, TDura[T].Power);
                if (BotP2[I2].Live<=11) then
                BotP2[I2].Animation:=6;
                BotP2[I2].AnimationN:=1;
              end
            else
            if BotP2[I2].Live>11 then
              begin
                BotP2[I2].Animation:=11;
                BotP2[I2].AnimationN:=1;
                BotP2[I2].Pr:=true;
                BotP2[I2].PrV:=0.1;
                BotP2[I2].AnimationPr:=1;
                if BotP2[I2].Live-TDura[T].Power<=11 then
                BotP2[I2].Live:=11
                else
                dec(BotP2[I2].Live, TDura[T].Power);
              end;
          end;
      if Enabled then
        if  (HeroP2.Animation<10)
        and (X>Map.Hero.X+40)
        and (X<Map.Hero.X+HeroT.W-40)
        and (Y>Map.Hero.Y+4)
        and (Y<Map.Hero.Y+HeroT.H-4)
        then
          begin
            Enabled:=false;
            HeroP2.Animation:=11;
            HeroP2.AnimationN:=1;
            HeroP2.Pr:=true;
            HeroP2.PrV:=0.1;
            if HeroP2.Live-TDura[T].Power<=11 then
            HeroP2.Live:=11
            else
            dec(HeroP2.Live, TDura[T].Power);
          end;
    end;

end;

procedure Draw;
var
  I, Flag : integer;
begin
  for I:=0 to length(Dura)-1 do
  with Dura[I] do
  if Enabled then
  begin
  if Speed<0 then Flag:=FX_DEFAULT or FX_FLIPX
  else Flag:=1;
  if (X-CameraX>=0) and (X-CameraX<=1024) then
  Omega.SSprite_Draw(S_materials.TTMD[T], Dura[I].X-CameraX, Dura[I].Y-CameraY, 8, 8, 255, 0, Flag);

  end;
end;

end.
