unit S_game;

interface
uses
  Omega, MScenes, S_ai,
  Setup, S_Dura, S_IniPers;

  {
   1 : 
   2 : 
   3 :   
   4 :   
   5 :
  }

var
  HeroP2  : TpersP2;
  HeroT   : TTPers;
  LevelN  : string;   //  
//  ProfyS  : string;
  UsedGun : integer =1;
  ImFire  : integer =0;

  HeroKX, HeroKY  : integer;

  ChLevel : boolean = false; //  

  CameraX, CameraY : single; // - 

procedure Init;
procedure Draw;
procedure Work;
procedure LoadLevel(LN : string = '');
procedure NewLevel (LN : string = '');

implementation
uses
  Live, S_map, S_materials, S_Scripts,  LexUtils;

//____ INIT!!!
procedure Init;
begin
  Live.kX:=0;
  Live.kY:=0;
  S_IniPers.Init;
  ChLevel:=false;

end;
//_____

//_____ DRAW!!!
procedure Draw;
var
  X1, Y1, X2, Y2, Y3 : integer;
begin
  S_map.Draw;
  Omega.SSprite_Draw(S_materials.TBar, 6, 6, 320, 40, 210);
  Omega.Text_Draw(S_materials.FontA1, 12, 12, PChar( ': ' + U_IntToStr( HeroP2.Live-11)), 1, 0, 255, 0 );

{ X1:=S_Map.Ed_RY;
  Y1:=Map.Hero.Y+HeroT.H+8;
  X2:= (Map.Hero.X+round(HeroT.W*0.25))  div S_map.Ed_X;
  Y2:= ( Map.Hero.Y+HeroT.H  )  div S_map.Ed_Y;
  Y3:= ( Y1 )  div S_map.Ed_Y;

  Omega.Text_Draw(S_materials.FontA1, 12,  50, PChar( 'X1: ' + U_IntToStr( X1)), 1, 0, 255, 0 );
  Omega.Text_Draw(S_materials.FontA1, 12, 100, PChar( 'Y1: ' + U_IntToStr( Y1)), 1, 0, 255, 0 );
  Omega.Text_Draw(S_materials.FontA1, 12, 150, PChar( 'X2: ' + U_IntToStr( X2)), 1, 0, 255, 0 );
  Omega.Text_Draw(S_materials.FontA1, 12, 200, PChar( 'Y2: ' + U_IntToStr( Y2)), 1, 0, 255, 0 );
  Omega.Text_Draw(S_materials.FontA1, 12, 250, PChar( 'Y3: ' + U_IntToStr( Y3)), 1, 0, 255, 0 );
  }
end;
//_____
procedure LoadLevel(LN : string = ''); //  
begin
  S_game.Init;
  if LN<>'' then LevelN:=LN;
  S_map.Open(LevelN+'.lex');
  S_Scripts.Open(LevelN+'.txt');
end;

procedure NewLevel(LN : string = '');  //  
begin
  ChLevel:=true;
  if LN<>'' then LevelN:=LN;
  S_map.Map.Hero.X:=kX*Ed_X-16-8;
  S_map.Map.Hero.Y:=kY*Ed_Y-5;
end;

// Work Proc's
procedure GameOver;
begin
  MScenes.NewScn(1, 47);
end;

//_____ WORK!!!
procedure Work;
var
  pX, pY : shortint;
//  lpX, lpY : single;
begin
  S_map.Work;
   
  pX:=0;
  pY:=0;

  if HeroP2.Live>11 then
    begin
      if ImFire>=1 then dec(ImFire);

      //  :

      if Omega.Key_Down(K_1   ) then UsedGun:=1;
      if Omega.Key_Down(K_2   ) then UsedGun:=2;
      if Omega.Key_Down(K_3   ) then UsedGun:=3;






      if Omega.Key_Down(UK_up   ) then                      // 
        begin
          dec(pY);
          if HeroP2.Animation in [1,2,3] then
          HeroP2.Antigravity:=20;
        end;
      if Omega.Key_Down(UK_down ) then inc(pY);
      if Omega.Key_Down(UK_left ) then dec(pX);
      if Omega.Key_Down(UK_right) then inc(pX);
      if Omega.Key_Down(UK_shift) then HeroP2.Shift:=true   //  
                                  else HeroP2.Shift:=false;

      if Omega.Key_Down(UK_E) and (ImFire=0) then           //  
        begin
          if HeroP2.Left then
          S_Dura.Fire( Map.Hero.X        , Map.Hero.Y+HeroT.Gun_pY+4, UsedGun, -1)
          else
          S_Dura.Fire( Map.Hero.X+HeroT.W, Map.Hero.Y+HeroT.Gun_pY+4, UsedGun,  1);
          ImFire:=25;
        end;
    end;

  if ChLevel then                                  //  
    begin
      MScenes.NewScn(1, 47);
    end
  else
  Live.Move(pX, pY, HeroT, map.Hero, HeroP2 );  // 

  HeroKX:=kX; //     
  HeroKY:=kY;

  //  :
  if ( Live.kX<Map.MofKlX) and (Live.kY<16)
  and (S_map.Map.Kl[kX, kY].ScH>0) then
  S_scripts.WorkHero(S_scripts.SScr[S_map.Map.Kl[kX, kY].ScH - 1]);

  // ____________________________________
  if HeroP2.Live<=10 then GameOver;                //     
  if Key_Down( K_ESCAPE ) Then MScenes.NewScn(45); //   
  //_____________________________________

  S_ai.Work;                                       //  
  S_Dura.Work;                                     //  

  // :
  if (Map.Hero.Y>CameraY+512)
  then
  CameraY:=Map.Hero.Y-512
  else
  if (Map.Hero.Y<CameraY+256)
  then
  CameraY:=Map.Hero.Y-256;

  if (Map.Hero.X>CameraX+768)
  then
  CameraX:=Map.Hero.X-768
  else
  if (Map.Hero.X<CameraX+256)
  then
  CameraX:=Map.Hero.X-256;

  if CameraY>768 then CameraY:=768;
  if CameraX<0 then CameraX:=0;

end;
//____

end.
