unit S_map;
// 
interface
uses
  Omega, S_materials, S_game, S_Dura, S_ai, S_Hero;

type
  TkT = ( none, clip, clip2, left, top);

  TKl = record
    B,  F,  O,  S,  L,          // , , , ,  
    Ba, Fa, Oa, Sa, La,         // ...
    ScH, ScB            : byte; // 
    T : TkT;                    // , ,  1  2
  end;

  TKlStr = array [0..16] of TKl;

  Tpers = record
    X, Y : integer;
    T : byte;
  end;

  Tmap = record
    Kl : array of TKlStr;
    MofKlX  : word;
    Hero    : TPers;
    BGcolor : integer; //  
    BGimage : string[200];
    Bot     : array of TPers;
    MofBot  : word;
  end;

  TmapKl = record
    Alpha, St, T    : byte;
  end;

const
  Ed_X = 64;  {1/4 * Ed_RX}
  Ed_Y = 128; {1/8 * Ed_RX}

  Ed_RX = 64-32;
  Ed_RY = 128-33;

var
  Map : Tmap;
  MapKl : array [0..32, 0..16] of TmapKl;
  BGimg : Omega.PTexture;

procedure Draw;
procedure Work;
procedure Clear;
procedure Open(FN : string);
procedure Save(FN : string);

implementation

procedure Draw;
var
 iX, iY  : byte;
 sX, sY, eX, eY : integer;

 S : string;

procedure DrawAT(A, I, I2: byte; tX, tY : integer);

  function GetKLAlpha : byte;
  begin
    if (A=A_b) then
     result:=255
    else
    if (A=A_f) and (iY<12) then
     result:=MapKl[iX, iY+1].Alpha
    else
     result:=MapKl[iX, iY].Alpha;
  end;

begin
  if I>0 then
    begin
      with TData.CA[A][I] do
      if T=0 then
      SSprite_Draw(TA[A][I], iX*Ed_X+tX+pX-CameraX, iY*Ed_Y+tY+pY-CameraY, W, H, 255)
      else
      ASprite_Draw(TA[A][I], iX*Ed_X+tX+pX-CameraX, iY*Ed_Y+tY+pY-CameraY, W, H, I2, 255);
    end;
end;

begin
  if Map.BGimage<>'' then
  Omega.SSprite_Draw(BGimg, 0, 0, 1024, 768)
  else
  Omega.Pr2D_Rect(0, 0, 1024, 768, Map.BGcolor, 255, 1);  // 

  eX:= round( CameraX+S_map.Ed_X )  div S_map.Ed_X -2;
  eY:= round( CameraY+S_Map.Ed_Y )  div S_map.Ed_Y -1;

  if eX<0 then eX:=0;
  if eY<0 then eY:=0;
  if eX+19>Map.MofKlX  then sX:=Map.MofKlX else sX:=eX+19;
  if eY+ 9>16  then sY:=16 else sY:=eY+9;

  for iX:=sX downto eX do
  for iY:=sY downto eY do
    begin
   { A_b = 1;  //    
     A_l = 2;  //  
     A_f = 3;  // 
     A_s = 4;  //  
     A_o = 5;  //        }
      DrawAT(A_b, Map.Kl[iX, iY].B,  Map.Kl[iX, iY].Ba, -32,   -33 );
      DrawAT(A_f, Map.Kl[iX, iY].F,  Map.Kl[iX, iY].Fa, -32, Ed_RY );
      case Map.Kl[iX, iY].T of
        top  : DrawAT(6, Map.Kl[iX, iY].O, Map.Kl[iX, iY].Oa, -32,    -0 );
        left : DrawAT(7, Map.Kl[iX, iY].O, Map.Kl[iX, iY].Oa, -32,    -0 );
         else  DrawAT(5, Map.Kl[iX, iY].O, Map.Kl[iX, iY].Oa, -16,    -16 );
      end;

      DrawAT(A_l,  Map.Kl[iX, iY].L, Map.Kl[iX, iY].La, -32,   -33 );
    end;

  S_Dura.Draw;
  S_Hero.Draw;
  S_ai.Draw;

  //   
  for iX:=sX downto eX do
  for iY:=sY downto eY do
    begin
      DrawAT(A_s, Map.Kl[iX, iY].S,  Map.Kl[iX, iY].Sa, 0, -1);
      case Map.Kl[iX, iY].T of
        none : S:='n';
        clip : S:='c';
        clip2 : S:='c2';
        left : S:='l';
        top: S:='t';
        end;
     { Omega.Text_Draw(FontA1, iX*Ed_X-14-CameraX, iY*Ed_Y-14-CameraY,
                          PChar(S), 1);  }

    end;

end;

procedure Work;
var
  iX, iY : byte;
begin

end;

procedure Clear;
var
  iX, iY : byte;
begin
  Map.MofKlX:=32;
  SetLength(Map.Kl, 33);
  for iX:=32 downto 0 do
  for iY:=16 downto 0 do
    begin
      Map.Kl[iX, iY].B:= 0;
      Map.Kl[iX, iY].Ba:=0;
      Map.Kl[iX, iY].F:= 0;
      Map.Kl[iX, iY].Fa:=0;
      Map.Kl[iX, iY].O:= 0;
      Map.Kl[iX, iY].Oa:=0;
      Map.Kl[iX, iY].S:= 0;
      Map.Kl[iX, iY].Sa:=0;
      Map.Kl[iX, iY].L:= 0;
      Map.Kl[iX, iY].La:=0;
      MapKl[iX, iY].Alpha:=255;
      MapKl[iX, iY].St:=0;
    end;
  Map.Hero.T:=0;
end;

procedure Open(FN : string);
var
  F : file;
  I : integer;
  S : string;
begin
  assignfile(F, FN);
  reset(F, 1);
  BlockRead(F, Map.MofKlX,  SizeOf(word));
  SetLength(S_map.Map.Kl , S_map.Map.MofKlX+1);
  For I:=0 to  Map.MofKlX do
  BlockRead(F, Map.Kl[I],   SizeOf(TKlStr));
  BlockRead(F, Map.Hero,    SizeOf(TPers));
  BlockRead(F, Map.BGcolor, SizeOf(Integer));

  BlockRead(F, Map.BGimage, SizeOf(Map.BGimage));
  S:=Map.BGimage;
  if S<>'' then
  BGimg:=Tex_LoadFromFile(PChar(S), -1, TEX_DEFAULT_2D);

  BlockRead(F, Map.MofBot,  SizeOf(word));
  SetLength(S_map.Map.Bot ,S_map.Map.MofBot);
  SetLength(S_ai.BotP2 ,S_map.Map.MofBot);
  For I:=0 to Map.MofBot-1 do
    begin
      BlockRead(F, Map.Bot[I],  SizeOf(TPers));
      Map.Bot[I].X:=Map.Bot[I].X*2;
      Map.Bot[I].Y:=Map.Bot[I].Y*2;
      
      with S_ai.BotP2[I] do
        begin
          Animation  :=1;
          AnimationN :=1;
          Pr         :=false;
          Left       :=false;
          Shift      :=false;
          F          :=true;
          case Map.Bot[I].T of
            1 : Live       :=35;
            2 : Live       :=25;
            3 : Live       :=50;
            4 : Live       :=120;
            5 : Live       :=100;
          end;
        end;
    end;  
  closefile(F);

  Map.Hero.X:=Map.Hero.X*2;
  Map.Hero.Y:=Map.Hero.Y*2;
  
  CameraX:=Map.Hero.X-256;
  CameraY:=Map.Hero.Y-256;

end;

procedure Save(FN : string);
var
  F : file;
  I : integer;
begin
  assignfile(F, FN);
  rewrite(F, 1);
  BlockWrite(F, Map.MofKlX,  SizeOf(word));
  For I:=0 to Map.MofKlX do
  BlockWrite(F, Map.Kl[I],   SizeOf(TKlStr));
  BlockWrite(F, Map.Hero,    SizeOf(TPers));
  BlockWrite(F, Map.BGcolor, SizeOf(Integer));
  BlockWrite(F, Map.BGimage, SizeOf(String));
  BlockWrite(F, Map.MofBot,  SizeOf(word));
  For I:=0 to Map.MofBot-1 do
  BlockWrite(F, Map.Bot[I],  SizeOf(TPers));
  closefile(F);
end;

end.
