unit S_materials;

interface
uses
  Omega, LexUtils;

type

  TTcord = record
    pX, pY, sH, sW, H, W : integer;
    N, M, UN : string[250];
    useM : boolean;
    T : byte;
  end;

const
    A_b = 1;
    A_l = 2;
    A_f = 3;
    A_s = 4;
    A_o = 5;
    A_t = 6;
    A_r = 7;

type
  TTData = record
    CA  : array[A_b..A_r] of array[1..100] of TTcord;
    Mof : array[A_b..A_r] of byte;
  end;


var
  FontA1 : Omega.PFONT2D; //  
  THero : array[1..15] of Omega.PTexture;
  TBot  : array[1..10, 1..15] of Omega.PTexture;
  
  TA : array[A_b..A_r] of array of Omega.PTexture;
  TData   : TTData;

  TTMD  : array[0..5] of Omega.PTexture;
  TGun  : array[0..3] of Omega.PTexture;
  TTMSD : array[0..2] of Omega.PTexture;
  TBar  : Omega.PTexture;
procedure Save(FN : string);
procedure Open(FN : string);
procedure Load;
procedure LoadM(iT, N : byte; iM : TTcord);

implementation

procedure LoadM(iT, N : byte; iM : TTcord);
var
  Flag  : integer;
  S : string;
begin
  if iM.useM then
    begin
      S:=iM.M;
      Tex_LoadMaskFromFile(PChar(S));
      Flag:=TEX_DEFAULT_2D or TEX_USEMASK;
    end
  else
  Flag:=0;
  S:=iM.N;
  TA[iT][N]:=Tex_LoadFromFile(PChar(S), -1, Flag);
  if iM.T>0 then
  Omega.Tex_SetFramesSize(TA[iT][N], iM.sW, iM.sH);

end;

procedure Save(FN : string);
var
  F : File;
  I, I1 : integer;
begin
  assignfile(F, FN);
  rewrite(F, 1);
  for I:=1 to 7 do
    begin
      //  :
      BlockWrite( F, TData.Mof[I], SizeOf( Integer ) );
      // :
      for I1:=1 to  TData.Mof[I] do
      BlockWrite( F, TData.CA[I][I1],  SizeOf( TTcord ) );
    end;
  closefile(F);
end;

procedure Open(FN : string);
var
  F : File;
  I, I1 : integer;
begin
  Load;
  assignfile(F, FN);
  reset(F, 1);
  for I:=1 to 7 do
    begin
      //  :
      BlockRead( F, TData.Mof[I], SizeOf( Integer ) );
      // :
      for I1:=1 to TData.Mof[I] do
      BlockRead( F, TData.CA[I][I1],  SizeOf( TTcord ) );
    end;
  closefile(F);

  for I:=1 to 7 do
    begin
      SetLength(TA[I], TData.Mof[I]+1);
      for I1:=1 to TData.Mof[I] do
      LoadM(I, I1, TData.CA[I][I1]);
    end;
end;

procedure Load;
var
  I : integer;
begin

  for I:=1 to 7 do
  begin
    setlength(TA[I], 1);
    TA[I][0]:=Tex_LoadFromFile(PChar('Data\eror.jpg'), -1, 0);
    TData.Mof[I]:=0;
  end;
  TBar:=Tex_LoadFromFile(PChar('Data\dialog.jpg'), -1, TEX_DEFAULT_2D);

  for I:=1 to 5 do
    begin
        Tex_LoadMaskFromFile(PChar('Data\GF\td1m.gif'));
        TTMD[I]:=Tex_LoadFromFile(PChar('Data\GF\td'+Int2S(I)+'.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
     end;
  for I:=1 to 3 do
    begin
        Tex_LoadMaskFromFile(PChar('Data\GF\G'+Int2S(I)+'m.gif'));
        TGUN[I]:=Tex_LoadFromFile(PChar('Data\GF\G'+Int2S(I)+'.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
     end;
     
  //   
  for I:=1 to 12 do
    begin
      Tex_LoadMaskFromFile(PChar('Data\Hero\'+Int2S(I)+'_m.gif'));
      THero[I]:=Tex_LoadFromFile(PChar('Data\Hero\'+Int2S(I)+'.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
      Omega.Tex_SetFramesSize(THero[I], 128, 128);
    end;

  //______________

  for I:=1 to 6 do
    begin
      Tex_LoadMaskFromFile(PChar('Data\Hunter\'+Int2S(I)+'_m.gif'));
      TBot[1,I]:=Tex_LoadFromFile(PChar('Data\Hunter\'+Int2S(I)+'.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
      Omega.Tex_SetFramesSize(TBot[1,I], 128, 64);
    end;

  for I:=1 to 6 do
    begin
      Tex_LoadMaskFromFile(PChar('Data\bee\'+Int2S(I)+'_m.gif'));
      TBot[2,I]:=Tex_LoadFromFile(PChar('Data\bee\'+Int2S(I)+'.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
      Omega.Tex_SetFramesSize(TBot[2,I], 128, 64);
    end;

  for I:=1 to 6 do
    begin
      Tex_LoadMaskFromFile(PChar('Data\Hunter\'+Int2S(I)+'_m.gif'));
      TBot[3,I]:=Tex_LoadFromFile(PChar('Data\Hunter\'+Int2S(I)+'.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
      Omega.Tex_SetFramesSize(TBot[3,I], 128, 64);
    end;

  for I:=1 to 6 do
    begin
      Tex_LoadMaskFromFile(PChar('Data\bee\'+Int2S(I)+'_m.gif'));
      TBot[4,I]:=Tex_LoadFromFile(PChar('Data\bee\'+Int2S(I)+'.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
      Omega.Tex_SetFramesSize(TBot[4,I], 128, 64);
    end;

  for I:=1 to 13 do
  if I in [1,2,4,6,11,12,13] then
    begin
      Tex_LoadMaskFromFile(PChar('Data\Doctor\'+Int2S(I)+'_m.gif'));
      TBot[5,I]:=Tex_LoadFromFile(PChar('Data\Doctor\'+Int2S(I)+'.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
      Omega.Tex_SetFramesSize(TBot[5,I], 128, 128);
    end;

  for I:=3 to 10 do
  if I in [3,7,10] then
    begin
      Tex_LoadMaskFromFile(PChar('Data\Doctor\1_m.gif'));
      TBot[5,I]:=Tex_LoadFromFile(PChar('Data\Doctor\1.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
      Omega.Tex_SetFramesSize(TBot[5,I], 128, 128);
    end;

  for I:=5 to 9 do
  if I in [5,8,9] then
    begin
      Tex_LoadMaskFromFile(PChar('Data\Doctor\4_m.gif'));
      TBot[5,I]:=Tex_LoadFromFile(PChar('Data\Doctor\4.gif'), -1, TEX_DEFAULT_2D or TEX_USEMASK);
      Omega.Tex_SetFramesSize(TBot[5,I], 128, 128);
    end;

  //______________
  Tex_LoadMaskFromFile(PChar('Data\Font1.jpg'));
  FontA1:= Text_LoadFontFromFile( 'Data\Font1.jpg', 'Data\Font1.ofi', 0, TEX_DEFAULT_2D or TEX_USEMASK);

end;

end.
