unit GUI;

interface

uses Windows, OpenGL, eXgine, uGUI, sysUtils;

 var
    Cur    : TGCursor;
    Panels : array[1..24] of TPanel;
    Buttons: array[1..24] of TButton;
    ChBoxes: array[1..24] of TCheckBox;
    Edits  : array[1..24] of TEdit;
    BCount,ChCount : integer;

procedure InitGUI;
procedure RenderGui(Group: integer);
procedure UpdateGUI(Grou: integer);

implementation

uses Editor;

procedure SaveButtonClick;
begin
  SaveMap('Test');
end;

procedure SetNoneButtonClick;
begin
  em:=emNone;
end;

procedure SetBlockButtonClick;
begin
  em:=emBlock;
end;

procedure SetDelModeButtonClick;
begin
  em:=emDelete;
end;

procedure QuitButtonClick;
begin
  eX.Quit;
end;

procedure NBButtonClick;
begin
  bt:=1;
end;

procedure BBButtonClick;
begin
  bt:=2;
end;

procedure SBButtonClick;
begin
  bt:=3;
end;

procedure ATButtonClick;
begin
  bt:=4;
end;

procedure ABButtonClick;
begin
  bt:=5;
end;

procedure AEButtonClick;
begin
  bt:=6;
end;

procedure S1ButtonClick;
begin
  sub:=1;
end;

procedure S2ButtonClick;
begin
  sub:=2;
end;

procedure S3ButtonClick;
begin
  sub:=3;
end;

procedure S4ButtonClick;
begin
  sub:=4;
end;

procedure S5ButtonClick;
begin
  sub:=5;
end;

procedure InitGUI;
begin
  panels[1].Create(700,300,200,600);
  buttons[1].Create(710,20,160,20,'', @SaveButtonClick);

  buttons[5].Create(710,60,160,20,'', @SetNoneButtonClick);
  buttons[2].Create(710,80,160,20,'', @SetBlockButtonClick);
  buttons[3].Create(710,100,160,20, '', @SetDelModeButtonClick);

  Buttons[6].Create(710, 140, 160, 20, ' ', @NBbuttonClick);
  Buttons[7].Create(710, 160, 160, 20, ' ', @BBButtonClick);
  Buttons[8].Create(710, 180, 160, 20, ' ', @SBButtonClick);
  Buttons[9].Create(710, 200, 160, 20, ' ', @ATButtonClick);
  Buttons[10].Create(710, 220, 160, 20, '', @aBButtonClick);
  Buttons[14].Create(710, 240, 160, 20, '', @aEButtonClick);

  Buttons[11].Create(710, 280, 160, 20, ' 1', @S1ButtonClick);
  Buttons[12].Create(710, 300, 160, 20, ' 2', @S2ButtonClick);
  Buttons[13].Create(710, 320, 160, 20, ' 3', @S3ButtonClick);
  Buttons[15].Create(710, 340, 160, 20, ' 4', @S4ButtonClick);
  Buttons[16].Create(710, 360, 160, 20, ' 5', @S5ButtonClick);


  buttons[4].Create(710,560,160,20, '', @QuitButtonClick);

  panels[2].Create(100,50,200,100);
end;

procedure RenderGui(Group: integer);
var i: integer;
    p: TPoint;
    m, b, s: String;
begin
  for I := 1 to 24 do
    begin
      panels[i].Render;
      buttons[i].Render;
    end;

  glColor3f(1, 0, 0);

  case em of
    emNone   : m:='emNone';
    emBlock  : m:='emBlock';
    emDelete : m:='emDelete';
  end;

  case bt of
    1   : b:='btTile';
    2   : b:='btBase';
    3   : b:='btSolid';
    4   : b:='btArea';
    5   : b:='bt';
    6   : b:='btEnemy';
  end;

  case sub of
    1   : s:='Sub1';
    2   : s:='Sub2';
    3   : s:='Sub3';
  end;

  GetCursorPos(p);
  ogl.TextOut(0,5,15,PChar(' : '+m));
  ogl.TextOut(0,5,25,PChar(': '+IntToStr(Count-1)));
  ogl.TextOut(0,5,35,PChar('  : '+b+'/'+s));
  ogl.TextOut(0,5,45,PChar('Cam.X : '+FloatToStr(cam.Pos.x)));
  ogl.TextOut(0,5,55,PChar('Cam.Y : '+FloatToStr(cam.Pos.Y)));
  ogl.TextOut(0,5,65,PChar('Cam.Z : '+FloatToStr(cam.Pos.Z)));
  ogl.TextOut(0,5,75,PChar('Cur.X : '+FloatToStr(cam.Pos.X+400-p.X)));
  ogl.TextOut(0,5,85,PChar('Cur.Y : '+FloatToStr(cam.Pos.Y+300-p.Y)));
end;

procedure UpdateGUI(Grou: integer);
var i: integer;
begin
  for I := 1 to 24 do
    begin
      buttons[i].Update;
    end;
end;




end.
