unit AnimObj;

interface

uses Windows, opengl, eXgine;

type
  TObjPart = record
    Pos     : TVector;
    Ang     : single;
    w, h    : integer;
    u, v, u1, v1    : single;
    Hprop   : single;
    Texture : TTexture;
  end;

   TDynObj = class(TObject)
     constructor Create(_Parts: integer);
   public
     Parts : array of TObjPart;
     PCnt  : integer;
     Right : Boolean;
     Pos, Speed : TVector;
     BAng       : Single;
     procedure AddPart(Part: TObjPart);
     procedure Render;
     procedure Update;
   end;

function CreatePart(_Pos: TVector; _Ang,_HProp: single; _w, _h, Tex: integer): TObjPart;

implementation

function CreatePart(_Pos: TVector; _Ang, _Hprop: single; _w, _h, Tex: integer): TObjPart;
begin
  Result.Pos:=_Pos;
  Result.Ang:=_Ang;
  Result.Hprop:=_Hprop;
  Result.w:=_w;
  Result.h:=_h;
  Result.Texture:=Tex;
  Result.u:=0;
  Result.u1:=1;
  Result.v:=0;
  Result.v1:=1;
end;

constructor TDynObj.Create(_Parts: Integer);
begin
  SetLength(Parts, _parts);
end;

procedure TDynObj.AddPart(Part: TObjPart);
begin
  inc(PCnt);
  Parts[PCnt]:=Part;
end;

procedure TDynObj.Render;
var
  I: Integer;
  p: TVector;
begin
  glColor4f(0.8, 0.8, 0.8, 1);
  for I := 1 to PCnt do
    begin
      glPushMatrix;
      p:=vec.Add(Parts[i].Pos, pos);
      glTranslatef(p.X, p.Y, 0);
      glRotatef(Parts[i].Ang, 0, 0, 1);
      With Parts[i] do
        begin
         tex.Enable(Texture);
         if Right then
         begin
         glBegin(GL_QUADS);
           glTexCoord2f(U,V);
           glVertex2f(-w/2, +h*(1-HProp));
           glTexCoord2f(u1,V);
           glVertex2f(+w/2, +h*(1-HProp));
           glTexCoord2f(u1,v1);
           glVertex2f(+w/2, -h*HProp);
           glTexCoord2f(u,v1);
          glVertex2f(-w/2, -h*HProp);
         glEnd;
         end else
         begin
         glBegin(GL_QUADS);
           glTexCoord2f(u1,v);
           glVertex2f(-w/2, +h*(1-HProp));
           glTexCoord2f(u,v);
           glVertex2f(+w/2, +h*(1-HProp));
           glTexCoord2f(u,v1);
           glVertex2f(+w/2, -h*HProp);
           glTexCoord2f(u1,v1);
          glVertex2f(-w/2, -h*HProp);
         glEnd;
         end;
        end;
      tex.Disable();
      glPopMatrix;
    end;
end;

procedure TDynObj.Update;
begin

end;

end.
