unit BackGround;

interface

uses Windows, OpenGl, eXgine, Player;

type
  TBack = record
    pos  : TVector;
    W, h : integer;
    u, v : single;
    texture : TTexture;
  end;

procedure InitBack;
procedure RenderBack;
procedure UpdateBack;

var
   BG: Array [1..3] of TBack;

   TexLvl1,
   TexLvl2,
   TexLvl3: TTexture;

implementation

uses Game;

procedure InitBack;
begin
  TexLvl1:=tex.Load('Data\Tex\Back\Ruins.tga');
  TexLvl2:=tex.Load('Data\Tex\Back\Clouds.gif');
  TexLvl3:=tex.Load('Data\Tex\Back\Back.jpg');

  with bg[1] do
    begin
      pos:=vec.Add(Cam.Pos, vec.Create(0,-768/8, 0));
      W:=1024; H:=500;
      texture:=TexLvl1;
    end;
  with bg[3] do
    begin
      pos:=Cam.pos;
      W:=2048; H:=768;
      texture:=TexLvl3;
    end;
end;

procedure RenderBack;
begin
  with bg[3] do
    begin
      glPushMatrix;
      glTranslatef(pos.X, pos.Y, 0);
      glColor4f(1,1,1,1);
      tex.Enable(Texture);
      glBegin(GL_QUADS);
        glTexCoord2f(0,0);
        glVertex2f(-w/2, +h/2);
        glTexCoord2f(1,0);
        glVertex2f(+w/2, +h/2);
        glTexCoord2f(1,1);
        glVertex2f(+w/2, -h/2);
        glTexCoord2f(0,1);
        glVertex2f(-w/2, -h/2);
      glEnd;
      tex.Disable();
      glPopMatrix;
    end;

  with bg[1] do
    begin
      glPushMatrix;
      glTranslatef(pos.X, pos.Y, 0);
      glColor4f(1,1,1,1);
      tex.Enable(Texture);
      glBegin(GL_QUADS);
        glTexCoord2f(0+u,0+v);
        glVertex2f(-w/2, +h/2);
        glTexCoord2f(1+u,0+v);
        glVertex2f(+w/2, +h/2);
        glTexCoord2f(1+u,1+v);
        glVertex2f(+w/2, -h/2);
        glTexCoord2f(0+u,1+v);
        glVertex2f(-w/2, -h/2);
      glEnd;
      tex.Disable();
      glPopMatrix;
    end;
end;

procedure UpdateBack;
begin
  bg[1].u:=cam.Pos.X/2048;
  bg[3].pos:=cam.Pos;
  bg[1].pos.x:=CAM.Pos.X;
end;

end.
