unit Game;

interface

uses Windows, opengl, eXgine, GUI, camera, Level, sysutils,
     Player, BackGround, Guns, Sound, Enemies, sys_main;

type
  TGameStatus = (gsMenu, gsGame, gsEnd);


procedure GameInit;
procedure GameUpdate;
procedure GameInput;
procedure GameRender;

var
  gs : TGameStatus = gsMenu;
  cam: TCamera;

implementation

procedure GameInit;
begin
  tex.Load('Data\Tex\Axis.jpg');
  tex.Load('Data\Tex\SysQuad.tga')  ;
  tex.Load('Data\Tex\Set_1\tex02a.jpg');
  tex.Load('Data\Tex\Set_1\tex02b.jpg');
  tex.Load('Data\Tex\Set_1\tex03.jpg');

  LoadSFX;

  InitBack;

  EnemiesInit;


  InitializePlayer;
  InitBullets;

  cam.Pos:=vec.Create(0,0,-302);
  cam.ang:=vec.Create(0, 1.57 , 0);
end;

procedure GameUpdate;
begin
  case gs of
    gsMenu:
      begin
        if inp.LastKey=VK_RETURN then 
          begin
{      ( ),     1 
             
     ,  -  ...    }
            if FileExists(PChar('Maps\Test.mdt')) then LoadMap('Maps\Test')
               else if FileExists(PChar('Maps\LvL1.mdt')) then LoadMap('Maps\LvL1')
                    else
                      begin
                        LogOut('Maps "Test.mdt" or "Lvl1.mdt not found in %GameDir%\Maps\');
                        LogOut(' App will be killed. ');
                        eX.Quit;
                      end;

            RefreshPlayer(2, vec.Create(0,0,0));

            gs:=gsGame;
          end;
      end;
    gsGame:
      begin
{       ...  ...}
         //      
         if (trunc(abs(PRec.spd*10))<1) and
            (PRec.param=0) then
           begin
             plr.Parts[2].Texture:=LegsTex;
             plr.Parts[2].u:=0;
             plr.Parts[2].u1:=1;
             plr.Parts[2].v:=0;
             plr.Parts[2].v1:=1;
             plr.Parts[2].w:=45;
             plr.Parts[2].h:=60;
           end;

         if (PRec.param>0) and (PRec.param<3) then
           begin
             plr.Parts[2].Texture:=JumpTex;
             plr.Parts[2].u:=0;
             plr.Parts[2].u1:=1;
             plr.Parts[2].v:=0;
             plr.Parts[2].v1:=1;
             plr.Parts[2].w:=45;
             plr.Parts[2].h:=60;
           end;

        {       )))
                 }
        if (cam.Pos.X<>plr.Pos.X)or
           (cam.Pos.Y<>plr.Pos.Y)then
           begin
             if cam.Pos.x-plr.Pos.x>0 then
                cam.Pos.X:=cam.Pos.X-(cam.Pos.X-Plr.Pos.X)/30;
             if cam.Pos.Y-plr.Pos.Y+150>0 then
                cam.Pos.Y:=cam.Pos.Y-(cam.Pos.Y-Plr.Pos.Y-150)/30;

             if cam.Pos.x-plr.Pos.x<0 then
                cam.Pos.X:=cam.Pos.X+(-cam.Pos.X+Plr.Pos.X)/30;
             if cam.Pos.Y-plr.Pos.Y+150<0 then
                cam.Pos.Y:=cam.Pos.Y+(-cam.Pos.Y+Plr.Pos.Y-150)/30;
           end;
        cam.Update;
        cam.SetProj;

        UpdateBack;

        UpdatePlayer;
        UpdateBullets;
        EnemiesUpdate;

      end;
  end;
end;

procedure GameInput;
var p : TPoint; lAng: single;
begin
 case gs of
   gsGame:
     begin
{=================================================================
      D       =======}

       if inp.Down(Ord('D'))and(PRec.param=0)then
         begin
{           ...
                 ...  ))                           }
           plr.Parts[2].Pos:=vec.Create(120,-0,0) ;
           plr.Parts[2].w:=96;
           plr.Parts[2].h:=64;
           plr.Parts[2].Texture:=RunsTex;
           plr.Parts[2].u:=plr.Parts[2].u+0.25;
           if plr.Parts[2].u>0.75 then
             begin
               plr.Parts[2].u:=0;
               plr.Parts[2].v:=plr.Parts[2].v+0.25;
               if plr.Parts[2].v>0.75 then plr.Parts[2].v:=0;
             end;
           plr.Parts[2].u1:=plr.Parts[2].u+0.25;
           plr.Parts[2].v1:=plr.Parts[2].v+0.25;

//   

           if plr.Right then PRec.spd:=-4
                        else PRec.spd:=-2;
         end;

{=================================================================
           =========}

       if inp.Down(Ord('A'))and(PRec.param=0)then
         begin
{           ...   ))
                 ...  ))                               }
           plr.Parts[2].Pos:=vec.Create(-120,-0,0) ;
           plr.Parts[2].w:=96;
           plr.Parts[2].h:=64;
           plr.Parts[2].Texture:=RunsTex;
           plr.Parts[2].u:=plr.Parts[2].u+0.25;
           if plr.Parts[2].u>0.75 then
             begin
               plr.Parts[2].u:=0;
               plr.Parts[2].v:=plr.Parts[2].v+0.25;
               if plr.Parts[2].v>0.75 then plr.Parts[2].v:=0;
             end;
           plr.Parts[2].u1:=plr.Parts[2].u+0.25;
           plr.Parts[2].v1:=plr.Parts[2].v+0.25;

//     

           if plr.Right then PRec.spd:=2
                        else PRec.spd:=4;
         end;

{=================================================================
     S       ========}

         //param=4 
       if inp.Down(ORD('S'))and
          (prec.param=0)    then
       begin
         PRec.param:=4;
         plr.Parts[2].Texture:=SeatTex;
         plr.Parts[2].u:=0;
         plr.Parts[2].u1:=1;
         plr.Parts[2].v:=0;
         plr.Parts[2].v1:=1;
         plr.Parts[2].w:=64;
         plr.Parts[2].h:=32;
       end;

{=================================================================
    SPACE       =====}

         // param=2 
       if inp.Down(VK_SPACE)and
          (prec.param=4)   then
          begin
            PRec.param:=2;
            PRec.DJTime:=0;
          end;
       // param=1 
       if inp.Down(VK_SPACE)and
            (PRec.param=0) then
            begin
              PRec.param:=1;
              PRec.JTime:=0;
            end;

{=================================================================
   .  
     ====================================}

       GetCursorPos(p);
       plr.BAng:=1.57+arctan((plr.Pos.Y-(768/2-p.Y+cam.Pos.Y))/
                            (plr.Pos.x-(512-p.x+cam.Pos.x)));
       //lAng:=plr.BAng;
      if p.X-512>0 then plr.BAng:=plr.BAng+3.14;


{===================================================================
      =================================}

       //  !!!
       if (inp.lastkey=(M_BTN_1))and(PRec.unvis=falSE) then
         begin
           AddBullet(1, vec.Add( vec.Add(plr.Pos,
                                         plr.Parts[5].Pos),
                                 vec.Create(45*cos(plr.BAng-1.57),
                                            45*sin(plr.BAng-1.57),
                                            0)), plr.BAng-1.57);
         end;

{===================================================================
      .  =========}

      if inp.Down(M_BTN_2)and(PRec.Spirit>0) then
         begin
           PRec.unvis:=true;
           dec(PRec.spirit, 2);
         end else
         PRec.unvis:=false;


     end;
 end;
end;


procedure GameRender;
var i : integer;
    p : Tpoint;
begin
  ogl.Blend(BT_SUB);
  case gs of
    gsMenu:
      begin
        ogl.Set2D(0,0, 1024, 768);
        glColor4f(1, 1, 1, 1);
        tex.Enable(StartScreen1);
        glBegin(GL_QUADS);
            glTexCoord2f(0,0);
            glVertex2f(0, 0);
            glTexCoord2f(1,0);
            glVertex2f(1024, 0);
            glTexCoord2f(1,1);
            glVertex2f(1024, 768);
            glTexCoord2f(0,1);
            glVertex2f(0, 768);
        glEnd;


        tex.Disable();
        glColor3f(0,0,0);
        ogl.TextOut(0, 450,500, PChar('Press ENTER to start game.'));
      end;
    gsGame:
      begin
        cam.SetRender;
          RenderBack;
          LevelRender;
          RenderPlayer;
          RenderBullets;
          EnemiesRender;

          ogl.Set2D(0,0,1024, 768);
          glBegin(GL_QUADS);
            glColor3f(1,0,0);
            glVertex2f(0, 0);

            glColor3f(1-(PRec.hp/100), (PRec.hp/100), 0);
            glVertex2f(1024*(PRec.hp/100), 0);
            glVertex2f(1024*(PRec.hp/100), 10);

            glColor3f(1,0,0);
            glVertex2f(0, 10);
          glEnd;

          glBegin(GL_QUADS);
            glColor3f(1,0,0);
            glVertex2f(0, 10);

            glColor3f(0, 0, (PRec.Spirit/1000));
            glVertex2f(1024*(PRec.Spirit/1000), 10);
            glVertex2f(1024*(PRec.Spirit/1000), 20);

            glColor3f(1,0,0);
            glVertex2f(0, 20);
          glEnd;

      end;
  end;

  {      
  }
  ogl.Set2D(0,0, 1024, 768);
  GetCursorPos(p);
  glColor4f(1, 0, 0, 1);
  glPushMatrix;
  glTranslatef(P.X, P.Y, 0);
  tex.Enable(cross);
  begin
    glBegin(GL_QUADS);
      glTexCoord2f(0,0);
      glVertex2f(-16, +16);
      glTexCoord2f(1,0);
      glVertex2f(+16, +16);
      glTexCoord2f(1,1);
      glVertex2f(+16, -16);
      glTexCoord2f(0,1);
      glVertex2f(-16, -16);
    glEnd;
  end;
  tex.Disable();
  glPopMatrix;
end;

end.
