unit Player;

interface

uses Windows, openGl, eXgine, AnimObj, level;

type
  TPlayerRecord = record
    hp, lives: integer;
    spd: single;
    param, DJTime, JTime, fallTime : integer;
    unvis, sh  : boolean;
    Spirit, wpn, WpnPoints, Pow : integer;
  end;

procedure InitializePlayer;
procedure RenderPlayer;
procedure UpdatePlayer;

procedure RefreshPlayer(Lv: integer; pos: TVector);

var
  Plr : TDynObj;
  PRec: TPlayerRecord;

  BodyTex,
  ArmsTex,
  LegsTex,
  HeadTex,
  WpnsTex,
  RunsTex,
  JumpTex,
  SeatTex: TTexture;
implementation

uses Enemies, guns;

procedure InitializePlayer;
begin
  bodytex:=tex.Load('Data\SPR\GGBody.tga');
  Headtex:=tex.Load('Data\SPR\GGHead.tga');
  ArmsTex:=tex.Load('Data\SPR\GGArm.tga');
  LegsTex:=tex.Load('Data\SPR\GGLegs.tga');
  WpnsTex:=tex.Load('Data\SPR\GGPistol.tga');
  RunsTex:=tex.Load('Data\SPR\GGRun.tga');
  JumpTex:=tex.Load('Data\SPR\GGJump.tga');
  SeatTex:=tex.Load('Data\SPR\GGSit.tga');

  plr:=TDynObj.Create(5);
  plr.AddPart(CreatePart(vec.Create(0, 5, 0),
                         0, 0.1, 24, 40, BodyTex));
  plr.AddPart(CreatePart(vec.Create(8,-0,0),
                         0, 0.9, 45, 60, LegsTex));
  plr.AddPart(CreatePart(vec.Create(-5,42,0),
                         0, 0.5, 20, 20, HeadTex));
  plr.AddPart(CreatePart(vec.Create(0,0,0),
                         -90, 0.5, 15, 20,WpnsTex));
  plr.AddPart(CreatePart(vec.Create(1,27,0),
                         -90, 0.9, 20, 45, ArmsTex));
  PRec.param:=0;

end;

procedure RenderPlayer;
begin
  plr.Render;

  glPushMatrix;
  glTranslatef(plr.Pos.X, plr.Pos.Y-50, 0);
  glColor3f(1,0,0);
  glBegin(GL_QUADS);
    glVertex2f(-2, +2);
    glVertex2f(+2, +2);
    glVertex2f(+2, -2);
    glVertex2f(-2, -2);
  glEnd;
  glPopMatrix;
end;

procedure UpdatePlayer;
var i, f, b: integer;
begin
  inc(PRec.Spirit);


  if plr.Parts[2].Texture=LegsTex then
     begin
       plr.Parts[2].u:=0;
       plr.Parts[2].v:=0;
     end;

  //   
  plr.Parts[5].Ang:=plr.BAng*180/3.14;
  plr.Parts[4].Ang:=(plr.BAng)*180/3.14;

  // left/ right
  if plr.BAng>6.27 then plr.BAng:=0;
  if plr.BAng<0 then plr.BAng:=6.27;
  if plr.BAng<3.14 then plr.Right:=false else plr.Right:=true;

  {    
           }

   plr.Parts[4].Pos:=vec.Create(-37*cos(plr.BAng+1.57),
                                -37*sin(plr.BAng+1.57)+27,
                                        0);

   if PRec.param=4 then
       begin
         plr.Parts[1].Pos.y:=-25;
         plr.Parts[2].Pos.y:=-30;
         plr.Parts[3].Pos.y:= 12;
         plr.Parts[4].Pos:=vec.Create(-37*cos(plr.BAng+1.57),
                                      -37*sin(plr.BAng+1.57)-3,
                                      0);
         plr.Parts[5].Pos.y:=  -3;
       end else
       begin
         plr.Parts[1].Pos.y:= 5;
         plr.Parts[2].Pos.y:= 0;
         plr.Parts[3].Pos.y:= 42;
         plr.Parts[4].Pos:=vec.Create(-37*cos(plr.BAng+1.57),
                                      -37*sin(plr.BAng+1.57)+27,
                                      0);
         plr.Parts[5].Pos.y:=  27;
       end;

   if plr.Right then
   begin
     if (trunc(abs(PRec.spd*10))>1)and
        (PRec.param=0) then
        plr.Parts[2].Pos.x:= -6
     else
        plr.Parts[2].Pos.x:= -2;

     plr.Parts[3].Pos.x:= -5;
     plr.Parts[5].Pos.x:=  1;
   end else
   begin
     if (trunc(abs(PRec.spd*10))>1)and
        (PRec.param=0) then
        plr.Parts[2].Pos.x:= 6
     else
        plr.Parts[2].Pos.x:= 2;

     plr.Parts[3].Pos.x:=  5;
     plr.Parts[5].Pos.x:= -1;
   end;

  {      ()
      round(PRec.spd*10) "" 
        Single }
  if PRec.param=0 then
     begin
       if round(PRec.spd*10)<0 then PRec.spd:=PRec.spd+0.5;
       if round(PRec.spd*10)>0 then PRec.spd:=PRec.spd-0.5;
     end;

  if PRec.param=4 then
     begin
       if round(PRec.spd*10)<0 then PRec.spd:=PRec.spd+1;
       if round(PRec.spd*10)>0 then PRec.spd:=PRec.spd-1;
     end;


  if PRec.spd>4 then PRec.spd:=4;
  if PRec.spd<-4 then PRec.spd:=-4;

  plr.Pos:=Vec.Add(plr.Pos, vec.Create(PRec.spd, 0, 0));

{==================================================================
     =========================================}

  for I := 1 to 128 do
    if EExist[i] then
    case En[i].PCollision  of
      1: PRec.hp:=PRec.hp-25;
      5: PRec.hp:=PRec.hp-25;
    end;

 if PRec.hp<=0 then
    case lvl of
      1: refreshplayer(PRec.lives+1, vec.Create(0,0,0));
      2: ;
      3: ;
    end;


 for I := 1 to 128 do
    if BExist[i] then b:=Bullets[i].Collision(Plr.Pos, 40, 80);

  case b of
    10: PRec.HP:=PRec.HP-10;
  end;

  {    , 
                                        }

  collision(plr.Pos, PRec.param, 100);

  // 
  if PRec.param=1 then
     begin
       PRec.fallTime:=0;
       inc(PRec.JTime);
          if PRec.JTime>20 then PRec.param:=3;
       plr.Pos:=vec.Add(plr.Pos, vec.Create(0,30/PRec.JTime,0));
     end;
  // 
  if PRec.param=2 then
     begin
       inc(PRec.DJTime);
       if PRec.DJTime>30 then
          begin
            PRec.param:=3;
            PRec.fallTime:=PRec.DJTime;
          end;
       plr.Pos:=vec.Add(plr.Pos, vec.Create(0,-0.1*PRec.DJTime,0));
     end;

  // 
  if PRec.param=3 then
     begin
       inc(PRec.FallTime);
       if PRec.fallTime>20 then f:=20 else f:=Prec.fallTime;
       plr.Pos:=vec.Add(plr.Pos, vec.Create(0,-0.15*f,0));
     end;

  //   
  if PRec.param=0 then PRec.fallTime:=0;

end;


procedure RefreshPlayer(Lv: integer; Pos: TVector);
begin
  PRec.hp:=100;
  PRec.lives:=lv;
  Plr.Pos:=pos;
  PRec.Spirit:=1000;
  PRec.wpn:=0;
  PRec.WpnPoints:=0;
end;

end.
